ActiveBPEL engine v5.0.2 0 (20080509) 
 
**************************************************************************
** NOTE **
**************************************************************************
*
* ActiveBPEL engine v5.0.2 (20080509) 
*
* This is the (GA) release of ActiveBPEL engine v5.0.2 with support for
* BPEL4People and WS-HT.  
*
**************************************************************************

org.activebpel.rt.b4p.server

* Reverting back to pre-lpg changes checkin state since they do not belong to
  this branch [ build 43.001, 4/14/08]


* jdoc cleanup [ build 43.002, 4/21/08]

org.activebpel.rt

* Reverting back to pre-lpg changes checkin state since they do not belong to
  this branch [ build 566.001, 4/14/08]


* jdoc cleanup [ build 566.002, 4/21/08]


* Removed the <?xml version="1.0"?> line from the start of
  ws-addressing-2004-08.xsd that castor does not like. [ build 566.003,
  4/24/08]


* Added a utility method that normalizes (currently, just trims) a URN string
  (Defect #4222). [ build 566.004, 4/28/08]


* Added a missing //$NON-NLS-1$ to AeUtil. [ build 566.005, 5/5/08]

org.activebpel.rt.http

* jdoc cleanup [ build 8.001, 4/21/08]


* Updated ae.build.properties to include mail and activation.jars [ build
  8.002, 4/24/08]

org.activebpel.wsio

* jdoc cleanup [ build 47.001, 4/21/08]

org.activebpel.rt.b4p

* Reverting back to pre-lpg changes checkin state since they do not belong to
  this branch [ build 153.001, 4/14/08]


* jdoc cleanup [ build 153.002, 4/21/08]


* Fixed a couple of header files that were broken into multiple lines. This
  was apparently causing issues with builds (Defect #4219). [ build 153.003,
  4/28/08]


* added null check to b4p localNotification validation rule [ build 153.004,
  5/7/08]

org.activebpel.rt.axis

* jdoc cleanup [ build 77.001, 4/21/08]

org.activebpel.rt.b4p.services

* Reverting back to pre-lpg changes checkin state since they do not belong to
  this branch [ build 36.001, 4/14/08]

org.activebpel.rt.bpeladmin.war

* jdoc cleanup [ build 270.001, 4/21/08]


* Added support for using ant style parameters when entering file locations
  for a file based identity service (for Chris) (Defect #4205). [ build
  270.002, 4/28/08]


* manually deleted the peopleActivity image files from cvs and re-adding them
  since there were problems with their case sensitivity [ build 270.003,
  4/30/08]

org.activebpel.rt.identity

* jdoc cleanup [ build 44.001, 4/21/08]


* Added support for using ant style parameters when entering file locations
  for a file based identity service (for Chris) (Defect #4205). [ build
  44.002, 4/28/08]

org.activebpel.rt.bpel

* Reverting back to pre-lpg changes checkin state since they do not belong to
  this branch [ build 770.001, 4/14/08]


* jdoc cleanup [ build 770.002, 4/21/08]


* Updated the Endpoint serializers so that wsa:ServiceName and
  wsa:ReferenceProperties are written in the proper order to be schema-valid.
  [ build 770.003, 4/24/08]


* (1) If a namespace is used as a default namespace in a schema,
  AeWSDLDefHelper.findPrefixForNamespace(...) was returning an empty string as
  the prefix. Looking out for this scenario and avoiding such an empty prefix
  being returned. This fixes an issue where "1" was used as prefix for a
  namespace (Defect #4212). (2) Entering a URN mapping in the console with a
  trailing space was treated differently from a URN without trailing space.
  This caused errors when attempting to resolve a URN mapping. URN strings are
  now normalized (currently, just trimmed) in all relevant operations in a URN
  resolver (Defect #4222). [ build 770.004, 4/28/08]

org.activebpel.rt.axis.bpel.web

* jdoc cleanup [ build 100.001, 4/21/08]

org.activebpel.rt.bpel.ext.expr

* jdoc cleanup [ build 38.001, 4/21/08]

org.activebpel.rt.ht

* Reverting back to pre-lpg changes checkin state since they do not belong to
  this branch [ build 111.001, 4/14/08]


* jdoc cleanup [ build 111.002, 4/21/08]

org.activebpel.rt.bpel.ext.expr.bsf

* jdoc cleanup [ build 16.001, 4/21/08]

org.activebpel.rt.bpel.server

* jdoc cleanup [ build 572.001, 4/21/08]


* Added checks to the delegating web service deployer to deal with missing
  service info more gracefully. [ build 572.002, 4/24/08]


* Entering a URN mapping in the console with a trailing space was treated
  differently from a URN without trailing space. This caused errors when
  attempting to resolve a URN mapping. URN strings are now normalized
  (currently, just trimmed) in all relevant operations in a URN resolver
  (Defect #4222). [ build 572.003, 4/28/08]


* Changed marking of journal entry for coordination to happen within the
  process lock. This ensures that the journal will be marked as done. [ build
  572.004, 4/29/08]

org.activebpel.b4p.war

* There is an issue with commons FileUpload::FileItem on Unix flavors, where
  the uploaded file (binary - non text) size is reported as 0 after saving
  file to a temp file. (saving is implemented as renameTo in delegate file
  handle, which returns 0 after rename). Updated
  AeWorkFlowRenderTaskXslServlet to use the file size of the uploaded temp
  file instead of commonts FileUpload::FileItem.getSize().; Fixes defect 4171
  - Cannot add binary attachment on Weblogic Linux [ build 33.001, 4/11/08]


* jdoc cleanup [ build 33.002, 4/21/08]

ActiveBPEL engine v5.0 M1 (20080213) 
 
**************************************************************************
** NOTE **
**************************************************************************
*
* ActiveBPEL engine v5.0 0 (20080213) 
*
* This is a M1 release of ActiveBPEL engine v5.0.0 with support for
* BPEL4People and WS-HT.  The Final (GA) release is currently planned
* for March / April 2008.  Please continue to check the download site
* for interim builds.
*
* Known issues include:
*   - if writing your own task client, keep in mind that API support 
*     for the following task operations is not included or incomplete
*     in this build - (no impact the ActiveBPEL inbox application):
*
*     - getRendering
*     - getRenderingTypes
*     - getTaskDescription
*     - nominate
*     - getGenericHumanRoles
*
**************************************************************************

org.activebpel.rt

* 1) AeMimeUtil supports more common mime types 2) AeMimeUtil now supports
  windows filenames with spaces [ build 441, 9/7/07]


* Updated AeXmlUtil::doTransform(..) to check to see if the XSL transform
  factory (class name) is based on weblogic impl., and if so, to use the
  factory impl. from bundled xalan.jar - as work around for defect 3112 [
  build 442, 9/10/07]


* Updated bpel extended wsdl def - when created a bpel extended wsdl def with
  only a schema, we weren't refreshing the schema refs (so the mSchemaDefs had
  a list of Schema objects, but mSchemaReferences was still empty). [ build
  443, 9/12/07]


* Added a static boolean to AeUtil which indicated if the current execution
  platform is Unix. Also added the helper method isUrlLocation. [ build 444,
  9/13/07]


* 1) refactored the bpel def io layer into base classes for reuse by ht defs
  and any other xml defs we'll create (i.e. bpelunit defs) [ build 445,
  9/25/07]


* Added a few convenience methods to AeXPathUtil. [ build 446, 9/26/07]


* Added method AeXmlUtil::replaceText(Element, String) [ build 447, 9/27/07]


* merging sterling branch [ build 448, 9/28/07]


* 1) repackaged some of the def visitors to their own package 2) pulled up
  parent visitor and location path visitor from rt.bpel to rt [ build 449,
  10/1/07]


* Javadoc fixes to remove BPEL references [ build 450, 10/4/07]


* 1) Added Interfaces for ExtensionObject and Extension Adapter 2) Added
  ExtensionObject interface reference in AeExtensionElementDef 3) Added Setter
  for Extension Element Reader in AeDefIORegistry [ build 451, 10/4/07]


* 1) Added reference to IAeExtensionObject in AeExtensionAttributeDef 2) Added
  Interface IAeExtensionRegistry to store map of Qname to class for extension
  elements, attributes and activities [ build 452, 10/12/07]


* 1) Implemented AeNamespaceBasedDefReaderRegistry and
  AeMashupDefWriterRegistry to support BPEl4People Def model 2) Added
  isSupported method to IAeDefWriterRegistry to detect Registry based on Def
  base class. 3) removed BPEL from javadocs to reflect generic nature. [ build
  453, 10/16/07]


* Added getExtensionElementDef(QName) onto the base xml def. [ build 454,
  10/17/07]


* 1) AeMashupDefWriterRegistry now uses the Def parent registry when there is
  no registry associated with the Def. 2) Removed reference to bpel in
  javadocs for the generic base classes AeBaseDefReader, AeDefReaderRegistry,
  IAeDefReaderRegistry. 3) deleted AeNamespaceBasedDefReaderRegistry that is
  no longer used. [ build 455, 10/17/07]


* Renamed AeWSBPELExtensionRegistry to AeMapBasedExtensionRegistry and moved
  it from org.activebpel.rt.bpel to org.activebpel.rt [ build 456, 10/17/07]


* replaced bpel references with generic ones [ build 457, 10/19/07]


* Fixed a bug in the castor structure factory - we were not properly handling
  attributes without types (default type if not specified is
  xsd:anySimpleType). Fixed the dom traverser - no longer traverse into
  extension elements. In the lib 'project', I also checked in a new version of
  Castor that properly handles the ws-bpel 2.0 schema (same issue - no type).
  [ build 458, 10/23/07]


* Added createElement() method to AeXmlUtil [ build 459, 10/24/07]


* Pulled up addChildrenToLiteral() into base xml layer and renamed to
  'getChildrenForLiteral' (now shared between bpel and ht). [ build 460,
  10/24/07]


* Added convenience method(s): createExtensionElementDef() onto base xml def.
  [ build 461, 10/26/07]


* Removed private constructor which caused warning a warning using eclipse 3.3
  compiler as a publcic onstructor was available. [ build 462, 10/31/07]


* Added getExtensionAttributeDef(QName aAttributeQName) in AeBaseXmlDef to get
  extension attribute def based on QName [ build 463, 11/2/07]


* 1) Added new utility class AeCloneUtil to use for deep cloning of List, Map
  and Set collections 2) Implemented clone capability for AeBaseXmlDef and aux
  classes [ build 464, 11/6/07]


* 1) overloaded AeXPathUtil to use ns context instead of just a map 2) added
  some helper methods to AeBaseXmlDef to access extension elements 3) added
  some more conv methods for reading/writing xml in the defs 4) pulled up some
  more behavior for base xml def i/o including: extension element reader
  registry entries, base code for traversing defs and creating elements, base
  segment visitor for location path building, base traverser [ build 465,
  11/8/07]


* javadoc spelling [ build 466, 11/8/07]


* 1) added conv method to AeBaseXmlDef to find an extension object for a given
  attribute qname [ build 467, 11/9/07]


* 1) Added support in base classes for ability to clone def objects. 2) Fixed
  minor issue in AeCloneUtil class used in deep cloning of Collections [ build
  468, 11/13/07]


* Added method traverseElement(AeBaseXmlDef aRootDef, Element aElement ) that
  accepts a root def and the elemnt to be desrialized as cildren of the root
  def. [ build 469, 11/14/07]


* 1) AeBaseXmlDef can resolve ns prefix through its parents 2) AeBaseXmlDef
  provides hooks for understanding extensions 3) no longer cloning
  IAeExtensionObject in AeExtensionAttributeDef, AeExtensionElementDef 3)
  setExtensionObject uses AeXmlDefUtil.installDef() to see if the extension
  object provides an adapter to hold a reference to the def that it is
  installed on 4) AeExtensionElementDef will ask its parent def if it is
  understood 5) IAeExtensionDefHolder - new adapter for extension objects that
  want a reference to the def they're installed on 6) removed
  IAeExtensionObject.clone() 7) IAeExtensionValidator - new adapter for
  extension objects that want to validate extension attributes or elements 8)
  changed impl of findNamespace to walk up parent hierarchy to resolve the ns.
  Added getNamespace(String) which just checks on the current def [ build 470,
  11/14/07]


* sterling merge: 1) fixed NPE in sample data generator stemming from invalid
  schema [ build 471, 11/15/07]


* 1) some minor def i/o refactoring 2) added resolveFileLocation to AeFileUtil
  - resolves a relative path based on a parent path [ build 472, 11/15/07]


* added method addNamespacesInScope() to support serializing any def as a root
  def [ build 473, 11/15/07]


* 1) added trang.jar to classpath along with a wrapper class to generate
  schemas from instance docs [ build 474, 11/16/07]


* forgot to update ae.build.properties [ build 475, 11/16/07]


* javadoc typos [ build 476, 11/19/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  477, 11/20/07]


* 1) added convenience method to read and write xml:lang for defs [ build 478,
  11/20/07]


* 1) modified AeSchemaGenerator as per trang expected command line. 2) New
  AeWSDLGenerator class to generate WSDL from partner interaction properties
  3) spelling [ build 479, 11/26/07]


* 1) added interface for defs that are parents of IAeExtensionObject
  (AeExtensionElementDef, AeExtensionAttributeDef) 2) removed FIXME from wsdl
  generator 3) left fixme in AeLoggerFactory to not set level [ build 480,
  11/26/07]


* 1) added another getAttribute*() method to def reader base class 2)
  refactored some schema and base xml methods [ build 481, 11/28/07]


* Fixed a problem with AeBaseXmlDef::findPrefixesForNamespace() - this method
  was not properly handling shadowed prefix declarations. [ build 482,
  11/30/07]


* Moved AeWSDLGenerator and AeSchemaGenerator up to core layer to eliminated
  dependency on trang.jar in open source distribution [ build 483, 11/30/07]


* Removed a FIXME, added some comments. [ build 484, 12/3/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 485, 12/3/07]


* Added constants for SAML assertions to IAePolicyConstants [ build 486,
  12/3/07]


* 1) changed AeBaseXmlDef.getHashCode() to use the location path for the
  hashcode instead of the location id. 2) AeExtensionAttributeDef uses its
  QName as the hashcode instead of the location id/path. [ build 487, 12/3/07]


* Added to AeSchemaUtil a static string array of build-in simple schema types.
  [ build 488, 12/4/07]


* Changed AeXmlDefUtil::formatQName to use AeXmlUtil::encodeQName - better
  code reuse and fixes a bug. [ build 489, 12/5/07]


* Added a utililty method compareObjects(String, String, boolean) which works
  off of the existing method compareObjects(Object, Object) with the
  additional ability to set whether null and empty strings are to be treated
  equal. Added a constant for "bpel". [ build 490, 12/6/07]


* Fixed NON-NLS warning. [ build 491, 12/7/07]


* 1) Added ability to add schema imports to types section in
  AeBPELExtendedWSDLDef 2) Add flexibility for adding schema definitions by
  giving user ability to control when we rebuild the schema map. This gives
  better control when schemas are added which have dependencies. [ build 492,
  12/7/07]


* Added new JMS transport constants to IAePolicyConstants. [ build 493,
  12/11/07]


* 1) Fixed bug in resolveNamespaceToPrefixes method of AeBPELExtendedWSDLDef
  now iterates on entrySet not values. 2) fixed typos [ build 494, 12/11/07]


* 1) changes to AeStandardSchemas handling to expose some add/remove methods
  for unit tests 2) AeURILocation resolves the input source in its ctor in
  order to fail fast while the exception can be caught and handled by castor
  3) changed AeURIResolver to return null if it can't resolve the schema
  through its standard schemas. This is part of a change to Castor. Schemas
  were previously being loaded as follows: #1 if schemaLocation was present,
  load from that location. If it fails, then you get an exception. #2 if there
  was no schemaLocation, then attempt to load through the URIResolver. Our
  impl of the URLResolver - AeURIResolver - would attempt to load the schema
  from its standard schemas in its classpath via its internal config file. If
  not found there, then it would use the namespace value as its schemaLocation
  and attempt to load that. This behavior was consistent with the schema
  specification EXCEPT that it bypassed our local caching of the "standard"
  schemas (like SOAP, ws-addressing, etc). Therefore if your net connection
  was down your offline tests might fail if the WSDL/Schema they were using
  had schemaLocations in them. I changed Castor to do the following: #1
  attempt to resolve using the namespace and URIResolver #2 attempt to resolve
  using the schemaLocation if present #3 create a URILocation using the
  namespace. This behavior is still consistent with the specification and it
  allows us to cache these schemas locally. The next logical step is to expose
  this caching to the end user and make it configurable. Perhaps for 5.1 4)
  changed AeBaseXmlDef to have methods for assigning itself as the parent on
  newly added child defs 5) changed AeExtensionElementDef to not have a QName
  and take its element in the ctor [ build 495, 12/13/07]


* 1) Created AeAutoCloceBlobInputStream an autoclosing extension to
  AeBlobInputStream that closes the stream (delete temp file) as soon as the
  eos is reached. 2) added AeAutoCloseBlobInputStream.ERROR_ReadClosedStream
  to messages.properties 3) spelling fixes [ build 496, 12/17/07]


* 1) null check in AeXmlUtil.doXslTransform() if params are null 2) changed
  AeUtil.resolveImport to use File.toURL() if the import location is a file [
  build 497, 12/17/07]


* Added constants for retry enhancements to IAePolicyConstants. [ build 498,
  12/18/07]


* 1) added method parseLong(String):long to AeUtil; 2) added AeXmlUtil methods
  addNillableElementNS(..), addElementNSDate(..), addElementNSQName(..) and
  setNil(Element). [ build 499, 12/19/07]


* Fixed a logic issue in a compare method [ build 500, 12/20/07]


* 1) added main to AeJCEUtil for use by jw during install [ build 501,
  12/26/07]


* 1) In AeSchemaUtil added a method to get the QName of the root type of an
  XMLType 2) In AeTypeMapping added a method to determine if the simple type
  is a supported SimpleType [ build 502, 12/27/07]


* Added REST support. 1) new TAG_REST_CONTEXT_PATH and TAG_PATH_ATTR added to
  IAePolicyConstants 2) XML_UTF8_MIME added to AeMimeUtil [ build 503,
  12/27/07]


* Added 'getOperation' to AeWSDLDefHelper - takes a port type qname and
  operation name and returns the Operation [ build 504, 12/28/07]


* 1) added AeXmlDefUtil.generateUniqueName which accepts a prefix and a
  collection of IAeNamedDefs. This is used to generate a unqiue name [ build
  505, 12/29/07]


* 1. Added getTextList(node, xpath,map) -> List to AeXPathUtil. This returns a
  list of string based on the selected text nodes; 2. Add new package
  org.activebpel.rt.xml.def.graph package. This package contains light weight
  objects and extension adapter to represent a graph/tree model which can be
  used to build visual models. The process graph viewer will use this for
  rendering exenstion elements and activities. [ build 506, 1/3/08]


* Added methods on top of selectNodes(..) and selectSingleNode(..) in
  AeXPathUtil to convert AeException to RuntimeException [ build 507, 1/3/08]


* 1) added http policy constants to IAePolicyConstants. 2) added common
  mimetypes to AeMimeUtil [ build 508, 1/4/08]


* Added contant HTML_MIME to AeMimeUtil [ build 509, 1/7/08]


* [ build 510, 1/10/08]


* 1) restored import of xmlschema-schema to xml.xsd file in standard schemas
  packaging (avoids errors in wst editor) 2) restored import of xml schema to
  xmlschema-schema file in standard schemas packaging (avoids errors in wst
  editor) 3) changed AeXmlUtil.encodeQName() to avoid declaring ns for xml ns
  4) added ctor to AeBPELExtendedWSDLDef to accept Schema[] 5) AeXMLParserBase
  avoids serializing schemas if validation is disabled. 6) AeXMLParserBase
  ensures that the xml schema is the first in the list of serialized schemas
  returned. This seems to solve some of the problems with the xerces
  validation code fetching the xml schema even though it was provided in the
  JAXP schema source property. Special thanks to the w3c which blocked our IP
  address due to over use of loading the xml schema from their website. If not
  for them, this would have gone undetected. 7) AeAbstractDefWriter - inlined
  writeAttributes(), it was just calling writeStandardAttributes() 8) some def
  writer changes to better support different QNames [ build 511, 1/10/08]


* Modified IAeNamedDef to expose setName() [ build 512, 1/11/08]


* Refactored to moved the IAeWSDLProvider & IAeContextWSDLProvider from
  org.activebpel.rt.bpel to org.activebpel.rt [ build 513, 1/11/08]


* Added HTTP policy options to set the client connection timeout and
  connection pool timeout to IAePolicyConstants [ build 514, 1/17/08]


* In AeBaseXmlDef added missing assignParent call in the method
  addExtensionElementDef. [ build 515, 1/17/08]


* Added method AeSchemaParserUtil::loadSchema(InputSOurce) and refactored
  AeSchemaParserUtil::loadSchema(String aPath, Class aClass) to use new method
  [ build 516, 1/18/08]


* added a null check on the reader returned from the IAeDefRegistry in
  traverseRootElement. Now when a null reader is returned an AeException will
  be throw instead of an NPE [ build 517, 1/21/08]


* Updated policy constants IAePolicyConstants: replaced element
  RESTContextPath with RESTenabled. RESTenabled has optional attribute
  'description' and sub element 'usage' [ build 518, 1/22/08]


* Added a new method replaceVarsInString(..) in AeUtil that replaces variables
  of pattern {$var} with values in a given string [ build 519, 1/22/08]


* 1) removed AeBPELExtendedWSDLDef.write(PrintStream) - was never being
  called. 2) removed AeBPELExtendedWSDLDef.write(String) - was being called
  with physical locations which is problematic in eclipse. Better to rely on
  the write() that returns a Document or the write(Writer) and let the caller
  decide where to write the file. [ build 520, 1/24/08]


* Moved many of the interfaces and abstract classes dealing with expression
  parsing and validation from org.activebpel.rt.bpel in order for HT
  validation to have access to them. In addtion the manifest.mf file was
  update to export the new packages within th rt project. Any BPEL specific
  expression parsing/validation related classes remain in the rt.bpel project.
  [ build 521, 1/25/08]


* 1) added AeBaseXmlDef.addNamespaces(Map) 2) added null check to
  AeDomTraverser.preserveProcessComments [ build 522, 1/27/08]


* Added an optional flag to allow documentToString to put in the xml header. [
  build 523, 1/29/08]


* Added an XInclude aware XML parser which sets up a AeXMLParserBase with the
  xinclude feature and delegates document loading and validation to the xml
  base parser. [ build 524, 1/29/08]


* 1) added check for empty qname in AeXmlUtil.setAttributeQName [ build 525,
  1/31/08]


* 1) updated MANIFEST.MF to reference the updated jaxp api (xml-apis.jar
  instead of xmlParserAPIs.jar) 2) in IAeXercesFeatures added 2 additional
  static fields for XInclude features [ build 526, 1/31/08]


* Added Import-Package for javax.xml.namespace to manifest to make it easier
  to create engine installation within eclipse. [ build 527, 1/31/08]


* The simple type data producer now outputs time sensitive data for DAY,
  MONTH, MONTHDAY, and YEARMONTH rather than always returning Jan 1. [ build
  528, 2/1/08]


* 1)Add ctor to AeSchemaDateTime which takes a utc-millisec arg; 2) Refactored
  WS-I serializers and deserializers into new base abstract classes
  AeXMLDeserializerBase and AeXMLSerializerBase [ build 529, 2/2/08]


* Added constants for MapProcessInitiatorAsHeader policy to
  IAePolicyConstants. This is a new internal policy used by the task client
  process to propagate the process initiator within the abx:principal header.
  [ build 530, 2/4/08]


* fixed an issue in the dom traverser that was causing duplication of comments
  and incorrectly assigning comments to the wrong element when serializing the
  model after a designer restart. [ build 531, 2/6/08]


* Added support for wildcards (optional, default is 'off') in the XML compare
  class. Element values and attribute values can be wildcarded with a * -
  element children can be skipped using a special qualified attribute on the
  'expected' document. [ build 532, 2/6/08]


* 1) added constuctor to AeAutoCloseBlobInputStream 2) added isNullOrEmpty and
  notNullOrEmpty formethod for org.w3c.dom.Node 3) refractored AeMimeUtil to
  support multipart mimes and added mime related utility methods: getMime
  getSafeTextMime contentIsXml isXmlText isText isMultipart isMultipartForm
  formMultipart [ build 533, 2/8/08]


* new method (AeUtil.getFilenameSansExtension) to get the filename without an
  extension from a location [ build 534, 2/8/08]


* Added convenience method in AeBaseXmlDef to removeExtensionElementDef [
  build 535, 2/11/08]


* 1) the getValidator method of the function validator factory now requires a
  bpel namespace 2) expression validation context is not constructed with the
  namespace for the process and a getter was added to the context interface [
  build 536, 2/12/08]


* 1) Added instanceLocationPath to the signature of getProperties() method in
  IAeXmlDefGraphNodeAdapter, so the adapter for people activity can retrieve
  state related properties 2) Added isRemove() method to
  IAeXmlDefGraphNodeProperty interface, so adapters can specify properties
  that need not be displayed 3) Implemented isRemove() in
  AeXmlDefGraphNodeProperty [ build 537, 2/12/08]

org.activebpel.rt.axis.bpel

* Fixed problem where EventHandler for engine events was defaulting to RPC for
  externally developed event listeners. [ build 216, 9/14/07]


* merging sterling branch [ build 217, 9/28/07]


* 1) Changed invoke handler to use resolved policy list 2) Fixed areas which
  were manipulating policy list directly instead of through endpoint [ build
  218, 9/28/07]


* Implemented WS-Policy for web service timeouts for invoke handler [ build
  219, 10/12/07]


* Modified invoke handler to use invoke web service timeout [ build 220,
  10/12/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 221, 12/3/07]


* Updated crypto.properties under shared/classes to include SAML issuer
  properties for unit tests. [ build 222, 12/3/07]


* Refactored some useful wsdl and wsa utility methods out of the Axis invoke
  handler into a new abstract AeSOAPInvokeHandler so they can be used by other
  handlers without introducing dependencies on Axis. [ build 223, 12/11/07]


* Upgraded apache commons httpclient to version 3.1 [ build 224, 12/11/07]


* updated ae.build.properties with current version of
  commons-httpclient-3.1.jar [ build 225, 12/11/07]


* javadoc spelling [ build 226, 12/27/07]


* Refactoring of the IAeWSDLProvider & IAeContextWSDLProvider required all
  references to those interfaces to be updated [ build 227, 1/11/08]


* Renamed the AeInvokeHandler to AeAxisInvokeHandler for clarity. [ build 228,
  1/14/08]


* Created an extension of AxisServer that lets us set the thread-local message
  context where necessary. This is necessary when you need to invoke a handler
  chain outside of the AxisServer.invoke() method. An example of this is where
  we need to invoke the response handler chain within a durable reply sender.
  [ build 229, 1/16/08]


* updated .classpath to include reference to new HttpClient 3.1 source [ build
  230, 1/17/08]


* Fixed problem where server timeouts were not properly being propagated as
  the ActiveEndpoints timeout extension policy [ build 231, 1/23/08]


* Updated the certificate for aeadmin stored in ae.keystore since the old
  certificate expired recently. [ build 232, 2/4/08]


* Changes from MF - Updated AeSimpleAuthenticationHandler to allow
  unauthenticated access to pass through, but if the user credentials are
  given and is verified by the security provider, then set subject as a
  property in the message context (instead of setting the username to null) [
  build 233, 2/7/08]


* 1) Added overloaded method to AeAttachmentUtil::soap2wsioAttachments(..) to
  take second optional principalName argument - if given, this will be used as
  the "Attached-By" attachment header attribtue 2) Updated
  AeBpelHandler::invoke(..) to pass in the username (principal) from the
  message context to AeAttachmentUtil::soap2wsioAttachments(..) call [ build
  234, 2/13/08]

org.activebpel.rt.war

* 1) Add ae war tags to handle xpath queries - SetNamespaceMappingTag,
  XPathNodeIteratorTag, XPathSelectNodeTextTag, XPathSelectNodeDateTah,
  XPathExists and XPathNotExists [ build 15, 1/11/08]

org.activebpel.rt.b4p

* 1) Added aeb4p:eval() custom function support - implemented by
  AeB4EvalFuction along with its own variable resolver, expression runner
  context etc.; 2) Added function contexts for WSHT and B4P namespaces witha
  temperary custom fuction in each NS. These custom fuctions are accessible
  only via aeb4:eval(); 3) Added AePersistentB4PManager - a custom manager
  which is used to install the eval() function; 4) Added IAeB4PConstants; 5)
  Added variable snapshot serializer (IAeVariable -> aeb4p:processVariable
  element) and deserializer; 6) Renamed
  org.activebpel.rt.b4p.def.IAeB4pConstants as IAeB4PDefConstants; 7) Updated
  tasklifecycle wsdl (for cancel task op), updated related wsdl to pass PA
  process id to the lifecycle process [ build 10, 11/1/07]


* Removed linked resouces to temp files from the .project file. [ build 100,
  2/4/08]


* 1) Added visitors for various steps of task and notification requests
  namely, inlining, lpg evaluation in people assignments, expression
  evaluation, updating missing expreesion languages in defs creating LPG def
  to organizational entity map, accounting for overrides in local task and
  local notifications 2) Moved Task and Notification request creation code to
  org.activebpel.rt.b4p.impl.request package 3) Added expiration and defer
  activation elements to human task context 4) Changed executeTask(..) and
  executeNotification(..) methods in IAeB4PManager interface to accept an
  optional attachment container [ build 101, 2/4/08]


* 1) use delegating function factory in eval function in order to pick up on
  other functions. 2) add placeholder for parent task instance to presentation
  params custom function (will return to have state machine pass values) 3)
  created new internal custom function: createHumanTaskContext() for use in
  the notification lifecycle in order to create humanTaskContext overrides 4)
  created new new ht function context for use in the notification lifecycle
  process. [ build 102, 2/4/08]


* pasted wrong notes in previous checkin: 1) impl'd ht:getActualOwner 2) added
  taskName to each of the ht functions 3) renamed AeHtFunctionRunner to
  AePeopleActivityBasedHtFunctionContext 4) added parent task state to
  AeTaskStateBasedHtFunctionContext 5) added parent task instance to
  processNotificationRequest 6) made output optional on interfaceMetadata, not
  applicable for notifications 7) added notification and taskInstance to
  createTaskRequest 8) added notification-lifecycle process 9) added global
  variable to task state to determine if its a task or notification and
  updated initialization routine to pull data from either task or notification
  element 10) renamed notificationRecipients to recipients [ build 103,
  2/4/08]


* 1) Updated AePATaskReqBuilder::createProcessVariablesSet() to return empty
  Set (instead of null) if no variables are found; 2) Updated import paths for
  service-ref xsd in aeb4p-task-events-wsdl.xsd and aeb4p-task-state-wsdl.xsd;
  3) Updated aeb4p-task-client bpel process to use abx:getProcessInitiator()
  to set the principal when making invokes to the storage layer to get the
  task listings; 4) Removed unnessary my role from internalTaskServicePLT; 5)
  Added PDDs for all the B4P processes and updated the bprd; 6) Removed
  aeb4p-taskclient-configuration wsdl since it is no longer used [ build 104,
  2/5/08]


* 1) removed service names from IAeB4PConstants 2) made assignment of
  processVariables optional since they might not exist [ build 105, 2/5/08]


* 1) added new entry to b4p-rules.xml for getInput validation 2) added new b4p
  rule class which extends the HT rule for getInput validation [ build 106,
  2/6/08]


* 1) Added a specific exception to the b4p custom functions for the case when
  the context is missing (rather than NPE) 2) the taskInstance is now returned
  by the createTask operation (the task state machine) and passed as data to
  the escalation process in that process's create message 3) Updated the
  expression language visitor to hit all of the required expression defs (and
  it only inlines the expression language if the expression def actually has
  an expression) [ build 107, 2/6/08]


* 1) fixed header in AeProcessTaskRequest 2) added task id to reassign message
  3) implemented add/remove listener, expiration, escalated, and reassign on
  state process. 4) escalation process now passes task id as part of reassign
  message 5) added property aliases needed for new operations [ build 108,
  2/7/08]


* 1) Removed all B4P validation classes that were created to extend HT rules.
  2) b4p-rules.xml file modified to point to the HT rules directly since the
  b4p rules that extended ht rules were removed. 3) B4P validation context
  will now create the correct traversal visitor to be used by the rule for
  validation [ build 109, 2/7/08]


* Added dependency on org.activebpel.wsio [ build 11, 11/2/07]


* removed aux.project.properties=eclipse.3.3.1.classpath.properties in
  ae.build.properties [ build 110, 2/7/08]


* 1) Various changes to the task presentation and command xsl to support the
  task details view; 2) Updated tasks PDD with new service names - using the
  format AeB4P{processName}-{PLTName}; 3) Updated b4ptasks bprd [ build 111,
  2/7/08]


* 1) Updated taskclient bpel process with updateComment and deleteComment
  aeTaskOperations impl.; 2) Changes (xapth, ns etc) to presentation and
  command xsl files to support B4P comments, fail and faults. [ build 112,
  2/8/08]


* 1) moved all support resources (bpel, wsdl, schema) to a new project:
  org.activebpel.rt.b4p.services 2) removed aux build from project [ build
  113, 2/11/08]


* Fixed issue where state document was returning mis-spelled OrgEntity for
  BusinessAdmins [ build 114, 2/11/08]


* 1) removed ht rule 114 from the b4p-rules.xml file 2) AeB4PValidationContext
  updated due to AeExpressionValidationContext constructor signature change [
  build 115, 2/12/08]


* 1) Implemented support in Human Interactions property builder adapter to
  remove current state property for all ht extensions in human interactions
  except logical people group elements 2) Added current state property for
  logical people group element 3) Added Static and State related properties
  for Task and Notifications inside a people activity 4) Added skippable
  property to the task request message [ build 116, 2/12/08]


* 1) renamed all b4p functions to have a b4p prefix. This is to differentiate
  them from the ht functions with the same name. i.e.
  ht:getPotentialOwners(taskName) vs
  b4p:getPotentialOwners(peopleActivityName) 2) include the generic human
  roles and other state when people activity faults. Actual owner and other
  roles may be required for reading and the spec doesn't say whether or not
  they're available so erring on the side of caution and adding them [ build
  117, 2/13/08]


* Change to test case due to some test refactorings. [ build 12, 11/5/07]


* 1) Created new AeDefUtil for B4P def utility methods 2) Implemented new
  visitors for creating empty def placeholders to be used by property sheet [
  build 13, 11/6/07]


* 1) removed entries for extension elements/attributes, handled in the base
  class now [ build 14, 11/8/07]


* 1) Created BPEL4People core preprocessing and validation preprocessing
  support. created extention objects, adapters traversers and visitors. New
  classes and interfaces: AeB4PCoreProcessingAdapter,
  AeB4PValidationPreprocessingAdapter, AeB4PHumanInteractionsExtensionObject,
  AeP4PPeopleAssignmentsExtensionObject, AeAbstractB4PExtensionObject,
  IAeB4PExtensionObject, AeB4PDefPathSegmentVisitor, AeB4PLocationPathVisitor
  2) new visitor to inline 'localNotification' references. new:
  AeB4PInlineDefVisitor, AeB4PNotificationFirstDefTraverser. 3) AeB4PIO
  deserialize now sets the Def parent child relationship. run:
  AeDefAssignParentVisitor 4) new visitor to resolve process scoped variable
  usage for all relevent WS-HT expressins within a B4P def. new class
  AeB4PVariableUsageVisitor. 5) Added getNotificationDef helper method to
  AeHumanInteractionDef for the inline visitor. 6) IAeHtConstants renamed to
  IAeHtDefConstants, IAeB4PConstants rename to IAeB4PDefconstants [ build 15,
  11/8/07]


* 1) Modified getAccessiblePeopleGroups to navigate to parent scopes in
  determining available LPG from enclosing human interactions elements 2)
  Fixed problem with plugin.xml imports which was causing processes with B4P
  elements to fail loading into editor. [ build 16, 11/8/07]


* 1) Added AePeopleActivityExtensionObject that is aware of the lifecycle
  adapter required on people extension activity 2) Added
  AePeopleActivityLifecycleAdapter that supports lifecycle callbacks on people
  activity [ build 17, 11/8/07]


* Added ae_wsio.jar to build classpath [ build 18, 11/8/07]


* Added org.activebpel.wsio import in plugin.xml [ build 19, 11/8/07]


* 1) New plugin project: org.activebpel.rt.b4p creaed to implement the
  BPEL4People Def model. This model basically extends the WS-HT model and adds
  the B4P specific elements. 2) Implemented B4P Def objects
  AeHumanInteractionsDef, AePeopleAssignmentsDef, AeBusinessAdministratorsDef,
  AeProcessInitiatorDef, ArProcessStakeholdersDef,
  AeAbstractGenericHumanRileDef, and the B4P Def base class AeB4PBaseDef. 3)
  Implemented B4P specific contants in IAeB4PConstants and
  IAeB4PClassConstants 3) Implemented B4P Read and Write Registries:
  AeAbstractB4PReaderRegistry, AeB4PDefReaderRegistry,
  AeAbstractB4PWriterRegistry, AeB4PDefEriterRegistry 4) Implemented registry
  visitors: AeB4PDelegatingDefWriterVisitor, AeB4PDefEriterVisitor,
  AeB4PDefReaderVisitor 4) Implemented B4P traversal visitors:
  AeB4PDefTraverser, AeB4PTraversalVisitor, IAeB4PDefTraverse,
  IAeB4PDefVisitor. [ build 2, 10/16/07]


* 1) Modified logic for obtaining accessible people groups to provide cleaner
  interface 2) Added clone and comparison support for B4P def layer [ build
  20, 11/13/07]


* 1) Added B4P model support for peeopleActivity. 2) rename BPEL4People
  AeHumanInteractionsDdef and AePeopleAssignmentsDef to
  AeB4PHumanInteractionsDef and AeB4PPeopleAssignmentsDef [ build 21,
  11/14/07]


* Inlined all Def Class definition constants [ build 22, 11/14/07]


* Removed FIXME comment [ build 23, 11/14/07]


* 1) AeAbstractB4PExtensionObject - replaced container for base def with
  actual base def 2) preprocess adapters are implemented directly by the base
  class 3) removed clone() from extension objects 4) changed
  AeB4PIO.deserialize to throw AeException instead of Exception 5) removed
  rt.bpel from plugin.xml since it's exported from rt.bpel.server [ build 24,
  11/14/07]


* 1) removed plugin activator (to remove Eclipse dependency) 2) minor def i/o
  refactoring [ build 25, 11/15/07]


* 1) Added Def objects for B4P elements shceduledActions, deferActivation,
  expiration, for, until. 2) AeB4PIo enhanced to resolve inscope namespaces
  for serializing Def objects to element. 3) B4P traversers and visitor
  updated to support the new element Def objects. [ build 26, 11/15/07]


* 1) Added override def traversing to localTask and local Notification 2)
  Added bpel schema validation to all B4P unit test 3) Modified
  ws-bpel4people.xsd: fromPart and toPart are now references to the
  ws-bpel_executable.xsd definitions s [ build 27, 11/19/07]


* 1) Modified AePeopleActivityDef to implement IAeMessageDataConsumerDef and
  IAeMessageDataProducerDef 2) Implemented AeProcessTaskRequestBuilder to
  build AeProcessTaskRequest object from people activity 3) Implemented
  AeProcessTaskRequestSerializer to serialize AeProcessTaskRequest object 4)
  Created class hierarchy for AeProcessTaskRequest [ build 28, 11/20/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  29, 11/20/07]


* 1) Added AeBuildNumber, AeMessages, messages.properties 2) Added b4p
  framework support AE schemas for escalations, events, lifecycle and runtime
  state. 3) Added AE b4p WSDLs for task escalations, events, lifecycle and
  process state. [ build 3, 10/16/07]


* 1) created impl object for <b4p:humanInteractions> 2) created extension
  object for logical people group 3) created provider interface to initialize
  logical people groups with data from the IAeProcessPlan (pdd) -- currently
  defaults to a literal provider which pulls an ht:organizationalEntity from
  the pdd to init the LPG 4) created impl object for <b4p:logicalPeopleGroup>.
  Maintains the state for the logical people group 5) updated manifest build
  file to remove wsio project since it's available from rt.bpel.server (was
  being reported as dupe entry in build path) [ build 30, 11/20/07]


* Updated OSGI manifest to pick up missing package exports [ build 31,
  11/21/07]


* 1) reader visitor wasn't reading ns decls for scheduled actions 2) added
  sets for understood extension elemnents and attributes to pa ext object. [
  build 32, 11/26/07]


* 1) people activity def implements IAeNamedDef to name will appear in
  location path 2) b4p extension object uses enclosing bpel path to make all
  location paths fully qualified for b4p/ht resources. i.e.
  "/humanInteractions/tasks" becomes "/process/scope/humanInteractions/tasks"
  3) changed AeB4PLocationPathVisitor to accept a base path [ build 33,
  11/27/07]


* Added executing expressions and logical people groups for people assignments
  when building process task request [ build 34, 11/27/07]


* Typo in the manifest file. [ build 35, 11/28/07]


* 1) Initial check of task lifecycle process 2) place holder process for task
  state; 3) Updated lifecycle wsdl/schema to add task meta data (priority,
  actual owner, potential owners etc) return response; 4) Refactored
  "identifier" and "listenerId" varprops to aeb4p-task-common.wsdl (from
  esclations and task state wsdl) ; 5) Typo fix in comments (in
  AeB4PProcessVariableCollectionSerializer) [ build 36, 11/30/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 37, 12/3/07]


* 1) moved logic for walking tasks, LPG's, and notifications from
  AeB4PHumanInteractionsDef to the respective container defs AeTasksDef,
  AeLogicalPeopleGroupsDef, AeNotificationsDef 2) Replaced the string for the
  LPG on AeFromDef to QName to match the schema 3) Extracted logic for finding
  referenced defs from AeB4PInlineVisitor into AeB4PResourceFinder. Also
  replaced recursive for loops with upwards traversing visitor 4) Added logic
  to inline visitor to inline LPG defs on AeFromDef's that ref LPG 5) added
  code to convert LPG references in an escalation handler to a literal in
  order to simplify the execution in our BPEL processes [ build 38, 12/3/07]


* 1) Implemented AeLPGMapCreationVisitor to traverse people activity and
  create a map of LPG Def to Organizational Entiry for all LPGs referenced in
  task,localtask,notofication, and localnotification 2) Modified
  AeProcessTaskRequestBuilder to use LPG Map visitor for resolving LPGs [
  build 39, 12/4/07]


* previous build failed - updated ae.build.properties to support eclipse
  pluging class path [ build 4, 10/16/07]


* Removed an unnecessary 'accept' implementation, change to call 'accept'
  instead of 'visit'. [ build 40, 12/5/07]


* Added AePresentationElementsDef visit method override to the
  AeB4PHtDefDeflationVisitor and AeB4PHtDefExpansionVisitor. [ build 41,
  12/7/07]


* 1) Added AeLocalNotificationInliner visitor to inline notification that is
  referenced in local notification of an escalation 2)
  AePeopleActivityStateImpl for people activity state save and restore 3)
  Validating messages in people activity 4) Using message consumer in the
  onMessage of People activity impl to consume output in process task response
  5) Retrieving people assignments and priority in the task metadata of task
  response [ build 42, 12/7/07]


* 1) removed transient from hi def's context field. obj not serializable so
  transient doesn't make sense 2) added b4p context interface to pa def to
  enable accessing enclosing hi defs from within designer 3) added parent
  interface for context defs (impld by hi and pa defs) 4) moved people
  activity deserializer to top level class 5) added
  AeB4PIO.deserializePeopleActivity 6) changed
  AeB4PIO.deserialize(def,element) to take a pa def instead of base xml def
  and to be a void. The method was previously returning a base xml def which
  you'd think was the def from the element but was actually the pa def passed
  in. 7) changed AeB4PResourceFinder to use the context in the hi or b4p to
  continue traversing up the model in search of its resource 8) added
  AeTaskInterfaceFinder to find the interface for a given people activity.9)
  removed pa deserialization code from AePeopleActivityExtensionObject in
  favor of using the PA deserializer [ build 43, 12/8/07]


* 1) added assignParent on all add/set def calls 2) combined
  IAeB4PForDefParent and IAeB4PUntilDefParent into a single interface:
  IAeB4PAlarmDef 3) changed skipable back to isSkipable. The schema has it as
  "isSkipable". 4) removed AeB4PPeopleActivityTraverserAdapter, it was never
  used. Its behavior moved into the core traversal of defs since the child
  extension activity def now traverses by the order of the defs having been
  added to it 5) removed throws from AeB4PIO.serialize where it wasn't needed.
  6) added null checks for AePeopleActivityDeserializer 7) fixed
  AePeopleActivityExtensionObject's isUnderstood(attr), was building the QName
  incorrectly [ build 44, 12/13/07]


* 1) Added AeTaskDef visit method override to the AeB4PHtDefDeflationVisitor
  class for handling empty task interface and priority defs. 2) Added
  interface and priority def null expansion checks in the AeTaskDef visit
  method in the AeB4PHtDefExpansionVisitor class. [ build 45, 12/14/07]


* 1. Implemented B4P extension functions
  getActualOwner(),getTaskInitiator(),getTaskStakeholders(),getPotentialOwners(),getAdministrators()
  and getTaskPriority() 2. Implemented visit(AeB4PLocalNotificationDef aDef)in
  AeB4PInlineDefVisitor to traverse local notifications in people activity
  when building notification request 3. Added traversing priorityDef when
  visiting task def in AePABaseVisitor since now we use this base visitor to
  build task and notification requests 4. Implemented a notification request
  builder to build notification requests 5. Modified Task request builder to
  use AePABaseVisitor 6. Implemented save() and restore() for people activity
  impl. 7. Created wsdl for notification request [ build 46, 12/14/07]


* fixed typos [ build 47, 12/17/07]


* 1) replaced use of AeHtDefUtil with AeB4PResourceFinder. The prev impl
  wasn't traversing up through the b4p context in order to reach enclosing
  human interactions for scoped resources. 2) added IAeLocalNotificationDef
  and IAeLocalResourceDef to achieve better reuse between local task and local
  notification 3) added AeB4PLocalNotificationDef to b4p writer registry 4)
  refactored the "finders" in the visitors.finders package to support
  returning all scoped resources of a given type. i.e. all LPG's in scope.
  They still support finding a specific resource by name. 5) added finders
  package to MANIFEST.MF since it used outside of the project. 6) added
  clone() to b4p defs that were missing it [ build 48, 12/17/07]


* 1) Added AePriorityDefvisit, AeNotificationInterfaceDef and
  AeTaskInterfaceDef method overrides to the AeB4PHtDefDeflationVisitor class
  for handling empty interface and priority defs. 2) Added interface and
  priority def null expansion checks in the AeNotificationDef visit method in
  the AeB4PHtDefExpansionVisitor class. [ build 49, 12/18/07]


* 1) AeB4PIO uses AeB4PReaderRegistry instead of AeNamespaceBasedDefReader 2)
  AeB4PReaderRegistry extends AeHtReaderRegistry 3)
  AeAbstractB4PReaderRegistry extends AeAbstractHtReaderRegistry and qualifies
  Def classes with names common to B4P and ht. [ build 5, 10/17/07]


* 1) Updated AeB4P:eval() function to take args (string|elem, processVariable,
  optionalExpLangUri) instead of (string|elemm, addElementNSDate(..)). The
  process variables element now must be supplied to the evak function;2) Moved
  constants from AePeopleActivityImpl to IAeProcessTaskConstants;3) Added
  constants for task and notification process's service names used by PA
  queuInvoke(...); 4) Updated PA AeProcessNotificationRequest,
  AePLRequestSerializer, AeProcessTaskRequest to support
  <tlc:peopleActivityId/> element - this is the PA "instance id" used for
  correlations; 5) Updated Task Lifecycle process, schema. Added support for
  suspend/resume; 6) Added wsdl and schema for custom process invoke
  escalation notifications; 7) Added process to handle escalations; 8) Updated
  and renamed aeb4p-notification.wsdl as aeb4p-task-notifications.wsdl [ build
  50, 12/19/07]


* 1. Implemented save and restore for LPGs in human interactions 2.
  Implemented b4p:getLogicalPeopleGroup function [ build 51, 12/20/07]


* updated ae.build.properties to use eclipse.3.3.1.classpath.properties [
  build 52, 12/26/07]


* 1) added missing equals to AeAttachmentPropagationDef, AeB4PBaseDef,
  AeB4PLocalNotificationdef, AeLocalTaskDef, AePeopleActivityDef,
  AeScheduledActionsDef 2) added clone(), setTaskData to AePeopleActivityDef
  3) use AeXmlDefUtil in AeGetLogicalPeopleGroupFunction [ build 53, 12/26/07]


* 1) Implemented WSHT extension functions 2) Modified Task and Notification
  request builders to execute PA expressions after the LPG and literal
  assignments are set in the context [ build 54, 12/27/07]


* 1) changed expansion visitor to create all of the roles for the people
  assignments. Was previously only creating the roles relevant to the task
  type but the people activity in designer's all tab will display all of the
  people assignments which was causing NPE [ build 55, 12/29/07]


* 1) task-rt.xsd: added identifier element and type for task ids 2)
  task-state-wsdl.xsd: added elements for getTaskInstance and activate 3)
  task-state.bpel: first crack at state machine bpel process. Added some code
  to handle deferActivation. [ build 56, 12/31/07]


* Modified expansion/deflation vistors to handle AeDelegationDef, AeOutcomeDef
  and AeSearchByDef [ build 57, 1/3/08]


* Removed selectNode(..) and selectSingleNode(..) methods from
  AePeopleActivityStateImpl and using these from AeXPathUtil [ build 58,
  1/3/08]


* 1) Modified expansion/deflation vistors to handle AeToPartsDef,
  AeConditionDef and AeEscalationDef. 2) Added the methods getToPartsCount,
  removeToParts and toString to the class AeToPartsDef. [ build 59, 1/4/08]


* 1) Added ability to deserialize an Element in AeB4PIO 2)
  AeAbstractB4PReaderRegistry now uses AeHtExtensionElementReader to remove
  superfluous namespaces during deserialization [ build 6, 10/19/07]


* 1) removed test function from context 2) added duration to deadline function
  3) all schemas changed to reference identifier element in trt 4) added
  interfaceMetadata to lifecycle and state messages. Currently optional
  element. 5) renamed attachmentInfos to attachments and will use the ht
  elements directly 6) made some of the elements in trt nillable and optional.
  The ones that will eventually have to have data (i.e. output) will be
  nillable while others that won't get added dynamically will remain optional
  (i.e. primarySearchBy) 7) lifecycle.bpel - removed some unused variables.
  dropped empty messages in favor of no variables 8) state.bpel - impld new
  operations: claim, complete, fail, release, resume, setOutput, setPriority,
  start, stop, suspend, suspendUntil 9) escalate.bpel - minor changes per
  changes in wsdl (part names, identifier type) 10) added task storage wsdl [
  build 60, 1/7/08]


* 1) removed test function from context 2) added duration to deadline function
  3) all schemas changed to reference identifier element in trt 4) added
  interfaceMetadata to lifecycle and state messages. Currently optional
  element. 5) renamed attachmentInfos to attachments and will use the ht
  elements directly 6) made some of the elements in trt nillable and optional.
  The ones that will eventually have to have data (i.e. output) will be
  nillable while others that won't get added dynamically will remain optional
  (i.e. primarySearchBy) 7) lifecycle.bpel - removed some unused variables.
  dropped empty messages in favor of no variables 8) state.bpel - impld new
  operations: claim, complete, fail, release, resume, setOutput, setPriority,
  start, stop, suspend, suspendUntil 9) escalate.bpel - minor changes per
  changes in wsdl (part names, identifier type) 10) added task storage wsdl [
  build 61, 1/7/08]


* Set the BUnit-Classpath-Contributor header to "true" in MANIFEST.MF [ build
  62, 1/7/08]


* Modified expansion & deflation vistors to handle AeLocalNotificationDef and
  AeReassignmentDef [ build 63, 1/8/08]


* (1) Added a visitor to collect all lpgs from a BPEL process. Used by the LPG
  editor. (2) Exporting newly created package in plugin manifest. [ build 64,
  1/9/08]


* 1) created a new b4p def find visitor to find a def by location path for a
  b4p/ht extension object 2) created the context and factory classes and rules
  needed for b4p/ht validation and the rules file. 3) the
  AeAbstractB4PExtensionObject now implements IAeValidationAdapter to
  implement the rules based validation logic. [ build 65, 1/9/08]


* 1) updated the b4p validation context to correctly resolve LPGs 2)
  validation preferences was refactored to extend the wsresource preferences
  base class 3) b4p rules xml file updated to conform to new schema [ build
  66, 1/10/08]


* 1. Modified AeB4PHumanInteractionsExtensionObject so it provides adapter for
  IAeXmlDefGraphNodeAdapter type 2. Implemented
  AeHumanInteractionsGraphNodeAdapter that handles calls to getProperties(..)
  and getTreeNode() for human interactions extension element 3. Implemented
  AePAGraphNodeAdapter that handles calls to getICon() and getProperties() for
  people activity 4. Modified AePeopleActivityExtensionObject so it provides
  adapter for IAeXmlDefGraphNodeAdapter 5. Added AeHIGraphNodeVisitor to
  traverse human interactions def and build tree node 6. Implemented
  AePAGraphNodeAdapter to create properties for people activity [ build 67,
  1/10/08]


* 1) added deadlines to deflation visitor 2) renamed expansion visitor to
  inflation visitor so it's symmetrical with the deflation visitor 3) impl'd
  skip, forward, delegate, getTaskInfo on the state machine 4) adding impl of
  suspend resumer courtesy of jason [ build 68, 1/10/08]


* Added task state wsdl ns to IAeProcessTaskConstants [ build 69, 1/11/08]


* 1. some minor b4p def refactorings 2. fixed the b4p reader registry (it was
  not properly setting up the ht and b4p reader mappings) 3. added abstract
  b4p def visitor and traversing visitor [ build 7, 10/23/07]


* 1) Refactored the B4P manager a bit. 2) Introduced an in-memory version of
  the B4P manager. 3) Combined some duplicate NS constant decls 4) The people
  activity now goes through the B4P manager when exec'ing a task or a
  notification (rather than queueing data directly onto the engine) [ build
  70, 1/11/08]


* 1) Modified AeB4PIO serialization to enable serialization of a HT/B4P
  fragment 2) Changed return of deserialize to return a AeBaseXmlDef 3)
  Created new AeB4PFragmentReaderRegistry used for reading fragments [ build
  71, 1/11/08]


* 1) removed the validation context factory from project 2) Added new
  IAeB4PContext classes for AeB4PHumanInteractionDef and
  AeB4PPeopleActivityDefs which in the
  AeAbstractB4PExtensionObject.preprocessForCore() method call 3) updated the
  AeB4PResourceFinder to correctly use the context for Defs that implement
  IAeB4PContextParent 4) updated the b4p validator to reflect the changes to
  the wsresource validation engine and statically cache the b4p rules [ build
  72, 1/11/08]


* Created removeOwner process and interface. [ build 73, 1/11/08]


* Modified expansion & deflation vistors to handle AeStartDeadlineDef,
  AeCompletionDeadlineDef and AeProcessDataExpressionDef. [ build 74, 1/15/08]


* 1) added name and type for people activity implicit attachments 2) pa
  extension object creates the implicit variable if it doesn't exist 3) added
  b4p people assignments to inflation visitor [ build 75, 1/15/08]


* Created some constants for the people activity fault names. [ build 76,
  1/15/08]


* 1. Implemented AeTaskInterfaceHelper to create task interface metadata 2.
  Adding attachments to task request message based on attachment propagation
  information in task definition 3. Consuming attachments when present in the
  task response message [ build 77, 1/15/08]


* Modified expansion & deflation vistors to handle AeRenderingsDef member data
  for AeTaskDef and AeNotificatonDef. [ build 78, 1/17/08]


* 1) removed skip flag from AeB4pResourceFinder in favor of stopping once the
  context has been found and relying on the context to resolve any enclosing
  HI defs. This is possible now since there is a context installed at runtime
  and design time. 2) added validation prefs to turn off validators for wsdl.
  [ build 79, 1/17/08]


* added a base visit method to the abstract traversing b4p def visitor [ build
  8, 10/24/07]


* 1) removed skip flag from AeB4pResourceFinder in favor of stopping once the
  context has been found and relying on the context to resolve any enclosing
  HI defs. This is possible now since there is a context installed at runtime
  and design time. 2) added validation prefs to turn off validators for wsdl.
  [ build 80, 1/17/08]


* 1) Added ae xsl rendering types to aeb4p-task-rt.xsd schema; 2) Added BPEL
  process aeb4p-taskclient-getconfiguration.bpel - returns current engine
  config to the inbox wrt xsl cache settings; 3) Added custom functions to
  return inbox engine config data; 4) Updated B4P managers to deploy
  aeb4p-tasks.bpr (contains task processes, schemas, xsl resources etc); 5)
  Added task ui rendering xsl resources and schemas (these will be deployed to
  the engine catalog); 6) New bprd (aeb4ptasks.bprd) to support tasks
  processes, wsdls, schemas and xsl and other catalog resources; 7) Ant aux
  post build script to build aeb4ptasks.bprd and add resulting bpr to project
  jar [ build 81, 1/18/08]


* 1) In the AeB4PInlineDefVisitor a visit for AeEscalationDef was added so
  that the notifications within escalations are inlined. 2) added the b4p/ht
  validation rules to as well as the validation context [ build 82, 1/21/08]


* 1) dropped comment type from trt schema in favor of using ht type 2) added
  renderings element to trt schema 3) added permissions to trt schema 4) added
  updateComment, deleteComment to state wsdl 5) fixed duplication of
  externalPLT in state wsdl by renaming one to removeOwnerPLT 6) added
  permissions, renderings to getTaskInstance() in state bpel 7) impld
  addComment, updateComment, deleteComment in state bpel 8) added PLT to state
  wsdl: aeTaskOperationsPLT. This is where our public additions to the ht spec
  go 9) changed all b4p validation rules to be WARNING instead of ERROR. We
  have too many sample files that are invalid and need to clean these up.
  Until then, the SA codes will be WARNING. 10) adding task_client process
  from jz [ build 83, 1/21/08]


* 1) Add $Date: 2008/05/09 18:48:36 $ into version.properties.; 2) Move eval and other internal b4p
  custom functions to rt.b4p.server project; 3) Removed AeInMemoryB4PManager
  and AePersistentB4PManager - refactored into rt.b4p.server project; 4) Added
  base AeNoopB4PManager (abstract) class. This class also installs the ws-ht
  b4p functions.; 5) Removed server dependencies from manifest and
  ae.build.properties [ build 84, 1/22/08]


* Added visit(AeDelegationDef aDef) in AePLTaskReqBuilder that inlines people
  assignments in AeDelegationDef [ build 85, 1/22/08]


* 1) fixed completion of AePeopleActivityImpl to handle complex types in the
  output message [ build 86, 1/23/08]


* Fixed problem where aeb4p-taskclient-configuration process was showing up in
  regular process list, it should be part of system group [ build 87, 1/23/08]


* fixed addCommentResponse in state process since wsdl message changed [ build
  88, 1/24/08]


* Moved the AeTaskResponseData helper out of the com.activee.bpel4peopleep
  project into the org.activebpel.rt.b4p project so it can be shared across
  bunit and simulation managers without introducing depenencies on UI
  plug-ins. Expanded the response template to include context metadata
  elements in addition to message data. [ build 89, 1/25/08]


* Removed plugin nature for this project to avoid eclipse 3.3 warninngs. Note
  there is an eclipse dependency here which should be removed in upcoming
  checkins. [ build 9, 11/1/07]


* Updated the default priority element in processTaskResponse.xml to have a
  valid default value. [ build 90, 1/25/08]


* 1) all Ht functions were changed to use the static function name from
  IAeFunctionNames in the rt.ht project and in addtion, each rule now invokes
  the alternate constructor of its superclass with the its function name. 2)
  new rules were added for b4p element validation along with an update to the
  b4p-rules.xml file 3) Updated all references to the expression parsing and
  validation classes/interfaces that were moved from org.activebpel.rt.bpel to
  org.activebpel.rt [ build 91, 1/25/08]


* 1) moved serialize2Protocol() into AeB4PIO from AeHTIO, only used in exec of
  PA 2) added AeB4PIO.serializePresentations() 3) added
  AeTaskStateBasedHtFunctionContext for use in executing ht functions w/in
  processes 4) rt.xsd - created an element def for the presentation data
  instead of relying on a type 5) state bpel process is using the new
  presentation custom function in task storage and return of task instance
  data 6) updated getTaskInfo.xsl to render the localized name and subject
  elements 7) removed the builders from this project until they are a little
  more stable [ build 92, 1/27/08]


* Made a few small name and javadoc changes. [ build 93, 1/28/08]


* Removed special bunit classpath contrbutor from manifest as now the engine
  plugin (org.activebpel.enginep) will account for it. [ build 94, 1/29/08]


* 1) use impl path instead of def path when resolving LPG name to impl 2)
  added static serialize method to AePLTaskReqBuilder to make it easier to use
  3) changed fault name from QName to NCName in trt schema 4) implemented
  getInput, getOutput, setFault, getFault on state machine 5) changed the
  getter operations which are impl'd using an onEvent to use scoped plinks to
  avoid concurrency issues with getMyRoleProperty [ build 95, 1/31/08]


* 1) removed some commented out code from the b4p validation context 2) the
  problem handler will now pass both the error code and error message to the
  BPEL ErrorReporter, this allows validation tests to use the problem code in
  the expected errors file instead of the error message which may change with
  time. [ build 96, 1/31/08]


* Made some changes to how LPGs are evaluated. They are now evaluated by the
  B4P manager. This gives us a hook that we can use during simulation and
  BUnit. The LPG providers are still present, but are only used by the server
  b4p manager. [ build 97, 2/1/08]


* 1) AePeopleActivityImpl's onMessage wasn't converting fault NCName into
  QName before throwing fault 2) added authorize operatiion to task state
  public port type 3) task-client: implemented task listings, added logic to
  change partner role EPR for onEvent services, added getInstance operation
  from aeTaskOperationsPLT 4) task-state.wsdl: renamed partnerLinkTypes and
  internal port type to follow ht conventions 5) task-storage.wsdl: added
  roleList to storage listings [ build 98, 2/2/08]


* 1) removed aeb4p-taskclient-getconfigration BPEL and PDD 2) Add first round
  of PDDs for task processes 3) UPdated aeb4p.bprd with new PDDs and
  serviceref xsd [ build 99, 2/2/08]

org.activebpel.rt.tamino

* Fixed a problem with Tamino upgrades. Previous refactoring had broken it. [
  build 69, 9/12/07]


* merging sterling branch [ build 70, 9/28/07]


* converted project to plugin project so we can add it to the test engine
  plugin dependencies [ build 71, 10/7/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  72, 11/20/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 73, 12/3/07]


* updated the ae.build.properties to use the newer jaxp api (xml-apis.jar
  instead of xmlParserAPIs.jar) [ build 74, 1/31/08]

org.activebpel.rt.exist

* 1) Maded AeExistConnection ctor public; 2) AeExistConnection - removed in
  memory static counter and added support for persistent AeCounter via
  getNextCounterValue() instance method; 3) Added method
  AeExistConnection::insertRawDocument(xml). This is used by AeExistDataSource
  when it needs to seed the db with AeMetaInfo and AeCounters.; 4) Updated
  AeExistDataSource to insert AeCounters element when seeding db; 5) Fixed
  'ProcessStorage.GetProcessList.for' query in exist-queries.xml (defined
  $procId var) [ build 10, 9/27/07]


* merging sterling branch [ build 11, 9/28/07]


* Parameterized the connection pool size (engine config setting) for eXist. [
  build 12, 10/3/07]


* converted project to plugin project so we can add it to the test engine
  plugin dependencies [ build 13, 10/7/07]


* Add the ability to have eXist database triggers installed when a new eXist
  database is created and seeded. This will be leveraged at a future time to
  implement unique constraints in eXist. [ build 14, 10/26/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  15, 11/20/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 16, 12/3/07]


* Upgraded eXist to the latest version (1.2.0). This required manifest and
  .classpath changes. [ build 17, 1/28/08]


* Updated export list in manifest to account for org.amldb.api. [ build 18,
  1/29/08]


* updated the ae.build.properties to use the newer jaxp api (xml-apis.jar
  instead of xmlParserAPIs.jar) [ build 19, 1/31/08]


* Added B4P custom storage and provider to engine config [ build 20, 2/2/08]

org.activebpel.rt.axis

* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 68, 12/3/07]


* Typos [ build 69, 12/11/07]


* Added AeHttpUtil used to support the http service used by REST and Axis(work
  in progress) [ build 70, 1/17/08]


* moved AeHttpUtil to new project org.activebpel.rt.http [ build 71, 1/24/08]


* Updated AeWSDLTrimmer and the AECatalogServlet to use a base64 encoding of
  the imports which makes it easier to handler ?WSDL and like on imported
  wsdl. [ build 72, 1/29/08]


* Changed wsdl trimmer cataloging encoding to not use base64 with line breaks
  to avoid url encoding issues. [ build 73, 2/1/08]


* Updated AeWsdTrimmer::encodeImportLocation() to short return if the
  importLocation is project:/ scheme based (otherwise, the '/b64/xxx/' breaks
  the resolving of relative paths due to change of the canonical path) [ build
  74, 2/5/08]


* Changed WSDL Trimmer to not use base64 encoding, but instead replace
  problematic elements on catalog uris, like double slashes and colons. [
  build 75, 2/7/08]

org.activebpel.rt.bpel

* Updated AeWSIInvokeHandlerBase::invokeOperation() not to log
  InvocationTargetException to the console. (the target error is rethrown as a
  fault anyway) [ build 638, 9/7/07]


* 1) renamed AeUnknownExtensionActivityDef to
  AeNotUnderstoodExtensionActivityDef and added base class and impl for
  understood extension. This had an impact on a number of visitor interfaces
  but it's just a simple rename. I didn't add any logic yet for understood
  extensions [ build 639, 9/11/07]


* 1) change to AeRestoreCompInfoVisitor in order to read scope locations by
  path instead of id in order to fix issue with restoring previously executed
  onEvent scope instances [ build 640, 9/19/07]


* 1) pulled core def io classes up to rt layer 2) changed a lot of interfaces
  and classes as a result of refactoring [ build 641, 9/25/07]


* 1) Added ability for process plan to obtain policies for both my role and
  partner role references 2) Changed message validation logic to honor message
  validation settings which are defined in process plan and allow ability to
  override global engine config setting 3) Modified WSIO activities to obtain
  defined policies prior to performing message validation [ build 642,
  9/26/07]


* merging sterling branch [ build 643, 9/28/07]


* 1) Modified IAeEndpointReference to provide method to obtain resolved
  policies, so we only have resolve them once 2) Added convenience method to
  locate policy elements on a endpoint for a given policy name 3) Modified
  access to policy list so that getter provides unmodifiable list and methods
  on endpoint reference facilitate manipulation of policies [ build 644,
  9/28/07]


* 1) Added validation to check for duplicate target scope names 2) Added
  read/write usage validation for variables during static analysis [ build
  645, 9/28/07]


* 1) removed setParent from AeBaseDef, use method in base class instead 2)
  moved impl of def path visitor and assign parent visitor to rt 3) reordered
  core visitors to have implicit variable visitor run prior to parent visitor
  4) changed traversal visitor impl to work with IAeBaseXmlDefVisitor
  interface instead of IAeDefVisitor which is BPEL specific [ build 646,
  10/1/07]


* Added 'running or suspended' as one of the options for the process filter
  state flag. [ build 647, 10/1/07]


* Split out the variable contexts used when running queries (not expressions)
  into a from variant and a to variant. The only difference is that one calls
  getVariable() and the other calls getVariableForUpdate(). [ build 648,
  10/3/07]


* 1) Added ChildActivity Defs List to AeUnderstoodExtensionActivityDef 2)
  Added visit(AeUnderstoodExtensionActivityDef) in IAeDefVisitor and
  implemented this in WSBPEL reader and writer visitors 3) Added support in
  WSBPEL factory to set a map of understood extension activity qnames in the
  reader registry so the registry can return appropriate reader for extension
  activities [ build 649, 10/9/07]


* Changed element declaration of WS-Policy for message validation to be
  consistent with timestamp policy nomenclature. [ build 650, 10/9/07]


* Renamed AeBpelDefTraverserVisitor to AeBpelDelegatingDefWriterVisitor [
  build 651, 10/9/07]


* 1) Implemented AeWSBPELExtensionRegistry to store QName to class map for
  extension element, attribute and activity 2) Renamed
  AeUnderstoodExtensionActivityDef to AeChildExtensionActivityDef and removed
  AeNotUnderstoodExtensionActivityDef (we now use AeChildExtensionActivityDef
  for both understood and not understood extension activities) 3) Modified
  visitors to account for extension activity def rename 4) Implemented visitor
  that looks for extension objects implementations (which provide access to
  adapters) in AeWSBPELExtensionRegistry and assign them to
  AeExtensionElementDef, AeExtensionAttributeDef and
  AeChildExtensionActivityDef 5) Added AeWSBPELAssignExtObjVisitor to
  runCoreVisitors(..) method of AeRegistryBasedBpelReader [ build 652,
  10/12/07]


* 1) Added new helpers on AeWSDLPolicyHelper to facilitate locating policy
  elements 2) Implemented WS-Policy for web service timeouts in receive
  handler 3) Created new fault for timeout conditions 4) Created helper
  classes for timeout and validation policies [ build 653, 10/12/07]


* 1) Modified engine configuration to split existing "Web Service Timeout"
  into two separate timeouts. One timeout will control the invoke timeouts and
  another will control the receive timeouts. 2) Modified queueReceive to use
  receive timeout. [ build 654, 10/12/07]


* Fixed reading of extensionAssignOperation - it was looking for the old name:
  extensibleAssign. Fixed traversing of extension elements - we now correctly
  traverse extension elements after documentation elements, but before
  anything else. [ build 655, 10/15/07]


* removed 'implements IAeDefWriterRegistry' from AeBPWSDefWriterRegistry that
  is already implementd by the extended class AeAbstractBpelWriterRegistry [
  build 656, 10/16/07]


* removed superflous implements IAeDefReaderRegistry from
  AeAbstractBpelReaderRegistry [ build 657, 10/17/07]


* Added AeEngineConfigExtensionRegistry extending from
  AeMapBasedExtensionRegistry that takes an instance of AeConfiguration and
  generates Extension Qname To Class Name map and passes to its parent [ build
  658, 10/17/07]


* 1) Created AeLoggerExtensionObject to install on logger extension activity
  2) Created Adapter for logger extension activity 3) Created impl for
  extension activity - AeActivityChildExtensionActivityImpl 4) Modified
  visit(AeChildExtensionActivityDef) method in AeDefToWSBPELImplVisitor to
  install Adapter for the extension activity in
  AeActivityChildExtensionActivityImpl when the extension activity is
  understood 5) Created lifecycle context interface and class for supporting
  activity lifecycle call backs from extension activity adapter 6) Implemented
  visit(AeActivityChildExtensionActivityImpl) in AeSaveImplStateVisitor and
  AeRestoreImplStateVisitor [ build 659, 10/24/07]


* Pulled up addChildrenToLiteral() into base xml layer and renamed to
  'getChildrenForLiteral' (now shared between bpel and ht). [ build 660,
  10/24/07]


* Child ext activity def now implements the various I*ParentDef interfaces to
  eliminate the need for instanceof checks in the bpel io layer. [ build 661,
  10/26/07]


* Changed check of instance of for dom node to use check via getNoneType as
  this is more standard. [ build 662, 10/31/07]


* 1) Refactored IAeVariable into IAeVariable and IAeVariableView.The
  IAeVariableView defines the getters that were in IAeVariable ; 2) Add new
  interface and base impl IAeExpressionVariableResolver - this interface is
  responsible for resolving IAeVariables with in a expression runner context;
  3) Updated IAeExpression to have getter for IAeExpressionVariableResolver ;
  4) Changes due to IAeExpression interface changes [ build 663, 11/1/07]


* 1) Added new base reply receiver and non durable reply receiver for
  extension activity 2) Added Extension Activity durable info which is used by
  reply-receiver factory to create extension activity durable reply receiver
  4) Modified visit(AeChildExtensionActivityDef aDef) in
  AeDefToWSBPELImplVisitor so the impl participates in traversal when the
  extension activity is understood 5) Added call back methods onMessage and
  onFault to AeActivityChildExtensionActivityImpl and implemented these call
  backs in the Adapter installed on extension activity impl 6) Added
  queueReceiveData(IAeMessageData aMessageData, AeMessageContext
  aMessageContext) in AeActivityLifeCycleContext to handle invoke on extension
  activity [ build 664, 11/2/07]


* Modified AeLoggerExtension object to support cloning [ build 665, 11/6/07]


* 1) removed entries for extension elements/attributes, handled in the base
  class now 2) extracted code from delegating def writer, segment visitor, and
  def traverser into base classes in the rt layer [ build 666, 11/8/07]


* 1) Added IAeCoreProcessingAdapter, IAeValidationPreprocessingAdapter. 2) new
  visitors that use extension object adapters: AeCorePreprocessingVisitor,
  AeValidationPreprocessingVisitor. these visitors are added to
  AeRegistryBasedBpelReader and AeProcessDef respectively. [ build 667,
  11/8/07]


* Relaxed validation on extension attributes when they are found on people
  activity since these attributes are not qualified [ build 668, 11/8/07]


* 1) added support for extension attribute on from-spec and to-spec 2) left
  some fixme's in code for additional changes needed for extensions 3) exposed
  process properties on IAeBusinessProcessInternal for use in test case [
  build 669, 11/9/07]


* Impact from refactoring [ build 670, 11/13/07]


* 1) added support for peopleActivity extension activity. 2) new
  IAeExtensionTraverserAdapter to hook in custom traversers for extensions. 3)
  Added order list to AeChildExtensionActivityDef to maintain the correct
  element order for traversal for hybrid models. 4) Added readers for
  fromParts and toParts in AeWSBPELDefReaderRegistry 5) the
  AeChildActivityExtensionDef vistor in AeDefTraverser supports
  IAeExtensionTraverserAdapter implementions in the extension object and
  traversal is done in order of the order list of the def. 6) a
  AeChildExtensionActivityDef visitor has been added to
  AeCoreProcessingVisitor [ build 671, 11/14/07]


* 1) AeChildExtensionActivityDef consults extension object to determine if an
  extension element or attribute is understood. 2) refactored the message
  producer/consumer interfaces and classes for better reuse with extension
  objects that want to produce or consume message (i.e. people activity) 3)
  added throws AeException to IAeCorePreprocessingAdapter 4) added
  fromPart/toPart mappings for AeChildExtensionActivityDef in ws-bpel reader
  registry 5) changed AeFromPartValidator/ToPart to handle extension
  activities that may be the parent of the fromPart/toPart 6) context removed
  from message producer/consumer ctors in favor of passing in with the
  produce/consume call. This simplifies construction for extension objects 7)
  avoid adding IAeFrom to variable impl, wasn't being used during variable
  initialization since this is handled differently by the variables container
  8) ws-bpel 2.0 defToImpl asks AeChildExtensionActivityDef if it has an
  adapter for message producer/consumer. Allows for extension activity to
  send/receive messages like other wsio activities (i.e. people activity) 9)
  AeWSBPELDefMessagePartsMapVisitor asks for adapter on
  AeChildExtensionActivityDef's extension object. This adatper will enabled
  the setting of the message parts map for message being produced or consumed.
  10) AeMessageDataStrategyVisitor looks for adapters on
  AeChildExtensionActivityDef to see if extension object is producing or
  consuming a message 11) added base class for extension activities [ build
  672, 11/14/07]


* Minor def i/o refactoring [ build 673, 11/15/07]


* 1) changed access modifier from protected to public for
  findProcessVariable(..) in IAeBusinessProcess and AeBusinessProcess 2) Added
  getProcess() to IAeActivityLifeCycleContext and its implementations [ build
  674, 11/20/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  675, 11/20/07]


* 1) added IAeCopyOperation to to-spec extension adapter and restored the
  to-def to the method sig 2) def2impl now checks for extension objects for
  non-activity extensions (like the b4p:humanInteractions) 3) moved
  AeAbstractBpelObject's accept(IAeImplVisitor) to IAeBpelObject 4) added
  getExtensions() on AeAbstractBpelObject -- currently only supported at
  activity level and from-spec, to-spec 5) added getExtensions() to
  IAeProcessPlan to return extension xml data from pdd 6) new interface/base
  class for non-activity extensions that want to provide runtime behavior:
  IAeExtensionLifecycleAdapter receives notifications of the enclosing
  activity's state changes. 7) AeActivityImpl notifies any extensions of state
  changes 8) scope notifies any extensions of variable initialization 9)
  removed context from save/restore methods on IAeActivityLifecycleAdapter 10)
  created helper class to notify extensions of state changes:
  AeExtensionNotifier 11) refactored impl visitors to use visitBase pattern
  12) added getter for IAeBpObject to IAeCopyOperationContext, necessary to
  traverse up the hierarchy and find extensions. 13) added AE function to get
  extensions from PDD (not exposed in picklist but it's available in core
  context) [ build 676, 11/20/07]


* spelling [ build 677, 11/26/07]


* 1) AeChildExtensionActivityDef implements IAeExtensionObjectParentDef 2)
  skip detailed usage validation errors if the variable is never used 3) Fixed
  issue in ImplVisitors where the onEvent scope wasn't being visited in some
  cases. This was introduced in last week's checkin. The new behavior is to
  have a visitScope() method similar to visitBase() that both scope impls will
  call into. [ build 678, 11/26/07]


* Added getBpelObject() to IAeActivityLifeCycleContext and
  AeActivityLifeCycleContext to get the AeAbstractBpelObject which has this
  context [ build 679, 11/27/07]


* Minor change due to method rename. [ build 680, 11/28/07]


* Fixed a minor whitespace problem in Manifest.mf that Ant's 'jar' task
  doesn't like. [ build 681, 11/30/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 682, 12/3/07]


* Updated the WS Addressing Serializer to only use the SAAJ API when we really
  need to serialize to a SOAPEnvelope. [ build 683, 12/3/07]


* Backed out last minute change to AeWSAddressingSerializer that was causing
  addressing test to fail. [ build 684, 12/3/07]


* 1) changed AeDefUtil.getProcessDef() to accept AeBaseXmlDef to allow
  traversal up from some extension def [ build 685, 12/3/07]


* Refactor - removed AeXmlDefUtil::getPrefixesForNamespace because the xml
  base def has an equivalent method "findPrefixesForNamespace" [ build 686,
  12/5/07]


* 1) Modified visit(AeChildExtensionActivityDef aDef) in
  AeDefToWSBPELImplVisitor to install message validator on the extension
  activity adapter when present 2) Added IAeMessageValidationAdapter interface
  for extension activities to implement when they wish to provide for message
  validation [ build 687, 12/7/07]


* Fixed a bug in the WS-Addressing serializer where the recipient was always
  serializing as an endpoint, this is only valid for the 2003 addressing
  schema. [ build 688, 12/7/07]


* 1) changed getPortType and getOperation in IAeMessageDataConsumerDef and
  IAeMessageDataProducerDef interfaces to be more explicit regarding the port
  type/op. Methods are now getProducer/ConsumerPortType()
  getProducer/ConsumerOperation(). This was done to address the pa (or other
  defs) where the def can mix port types/operations in its sending/receiving
  of data. [ build 689, 12/8/07]


* Fixed typos [ build 690, 12/11/07]


* 1. Changed method signature for queueReceiveData(..) in
  IAeActivityLifeCycleContext and its implementation
  AeActivityLifeCycleContextto receive a oneWay flag so the reply receiver can
  be sent as null 2. Modified visit(AeActivityChildExtensionActivityImpl
  aImpl) method in AeSaveImplStateVisitor so the extension activity state
  element is a child of this impl [ build 691, 12/14/07]


* Implementation of retry policy enhancements in AeInvokeRetryPolicy. Added
  AeSuspendReason.SUSPEND_CODE_INVOKE_RETRY. [ build 692, 12/18/07]


* 1) Updated AeWSIInvokeHandlerBase to check wsio operation starts with
  lowercase - if not convert 1st char to lowercase to match Java method naming
  conventions; 2) Refactored AeWSIInvokeHandlerBase to include some common
  convenience methods; 3) Added new serializer i/o base class
  AeWSIInvokeMessageIOBase [ build 693, 12/19/07]


* Delegating save and restore for extensions if the extensions provide
  lifecycle adapter [ build 694, 12/20/07]


* 1) fixed jd in IAeAttachmentManager 2) renamed restoreHIState to
  restoreExtensionState in AeRestoreImplVisitor [ build 695, 12/26/07]


* 1) In AePartnerLinkDef corrected spelling of javadoc 2) Added
  AeDefActivityInvokeVisitor to find all Invokes in a BPEL process [ build
  696, 12/27/07]


* 1) Modified getFunctionContextNamespaceList() on IAeEngineConfiguration and
  its implementations to return a Set instead of List 2) Implemented
  AeDelegatingFunctionFactory that delegated getFunction() call to an
  appropriate function factory based on namespace [ build 697, 12/27/07]


* Recording time taken to validate a message when the validation is turned on
  [ build 698, 12/31/07]


* 1) changed AeActivityCompensateImpl's creation of implicit compensate
  activity to use the enclosing scope or FCT def's definition object as its
  own. This impl previously never had a def (since it's an implicit object and
  not modeled in the xml) and all cases where a def was needed were accounted
  for until I got a stacktrace related to the exitOnStandardFault handling.
  Solution was to use the parent def to ensure that the implicit object always
  has a def in place. [ build 699, 12/31/07]


* Added properties for the message data, fault, and location path of
  corresponding receive activity to the AeReply object. Added a property for
  location path of the receive activity to AeOpenMessageActivityInfo [ build
  700, 1/2/08]


* fixed typos and removed TODO [ build 701, 1/4/08]


* Introduce ht/b4p validation to bpel files. 1) IAeValdiationAdapter was
  introduced to to allow existing AeAbstractExtensionAttributeValidator
  objects to perform rules based validation. 2) WSBPEL Extension element
  validator classes were changed to validate the b4p elements. [ build 702,
  1/9/08]


* 1) writeAttributes changes to writeStandardAttributes as per base class
  change [ build 703, 1/10/08]


* 1) added getDefinition to the bpel object interface 2) broke out
  queueReceiveData into a static helper class to be re-used [ build 704,
  1/11/08]


* Refactoring of the IAeWSDLProvider & IAeContextWSDLProvider required all
  references to those interfaces to be updated [ build 705, 1/11/08]


* Moved some useful methods from the partner addressing layer in the server
  project into AeAddressingHeaders. These methods are used to get the
  namespace-specific URIs and QNames for the anonymous role, fault action, and
  reply relationships. [ build 706, 1/14/08]


* 1) change the order of core visitors. new order is: parent, extensions,
  implicit variable, parent (again), others. 2) added adapter for creating of
  implicit variables and added use of this adapter to ws-bpel implicit
  variable visitor [ build 707, 1/15/08]


* Fjavadoc spelling [ build 708, 1/17/08]


* A visit method was added for AeOnEventDef in AeAbstractEntryPointVisitor to
  address defect #3456. This visitor now receives a callback on all inbound
  message activities. [ build 709, 1/21/08]


* 1) added check for null role in AePartnerLinkDef 2) added check for
  undefined message in AeVariableValidator. WSDL4J implicitly adds referenced
  messages to the def but marks them as undefined. We should ignore these and
  treat them as missing during validation. [ build 710, 1/21/08]


* javadoc spelling [ build 711, 1/22/08]


* 1) Refractored logic to safely covert a Double to Long in
  unwrapXPathValue(..) method into AeUtil 2) Removed a blank line in
  getFunction(..) method of AeExtensionFunctionContext [ build 712, 1/22/08]


* Fixed problem where policies were not being honored for MyRole endpoints
  when policy is declared as a policy reference [ build 713, 1/23/08]


* Updated AeInvokeRetryPolicy so the default fault exclusion behavior matches
  what people intuitively expect. Previously we would automatically exclude
  faults declared on the port type. Now we will retry on all faults unless
  explicitly excluded. The policy UI has been updated to include a default
  exclusion list for port type faults. [ build 714, 1/25/08]


* Moved many of the interfaces and abstract classes dealing with expression
  parsing and validation from org.activebpel.rt.bpel in order for HT
  validation to have access to them. In addtion the manifest.mf file was
  update to export the new packages within th rt project. Any BPEL specific
  expression parsing/validation related classes remain in the rt.bpel project.
  [ build 715, 1/25/08]


* 1) Moved generic interfaces and abstract classes dealing with expression
  parsing and validation to org.activebpel.rt 2) updated all references to the
  classes/interfaces which moved [ build 716, 1/25/08]


* Fixed issue where message validation failures were not providing any details
  in the generated fault. [ build 717, 1/25/08]


* 1) added null check in AeReplaceElementStrategy. NPE when keepSrcElementName
  enabled and source element didn't have a schema imported. 2) removed
  selection failure code from AeGetMyRolePropertyFunction. The function
  shouldn't throw. Let the copy operation detect that there's nothing selected
  and then throw. [ build 718, 1/27/08]


* Added fallback to finding port types in the AEWSDLDefHaleper to look for
  imported port types that way if you just imported a partner link type you
  can use operations. [ build 719, 1/29/08]


* 1) updated comments in AeLocationPathUtils.addInstanceInfo [ build 720,
  1/31/08]


* 1) Updated IAeBusinessProcess and impl. to support get/setProcessInitator()
  2) Updated save/restore impl. visitors to handle process initiator property
  3) added default state value for process intiator; 4) Remove
  AeWSIInokeMessageIOBase (refactored to a common base in rt.util); 5) Added
  AeGetProcessInitiatorFunction [ build 721, 2/2/08]


* AeBusinessProcess will now propagate the process initiator to invoke
  handlers by setting the value on AeInvoke before queueing it. [ build 722,
  2/4/08]


* 1) Added executeDurationExpression(..) and executeDeadlineExpression(..) to
  AeAbstractBpelObject 2) Refractored creation of expression runner into a
  separate method 3) Refractored AeCreateAttachmentFunction so calling it from
  other functions is easier now 4)Added executeDeadlineExpression(..) and
  executeDurationExpression(..) to lifecycle context interface [ build 723,
  2/4/08]


* 1) changed AeDelegatingFunctionFactory to not throw when it exhausts the
  function factories. This will allow the calling expression runner to consult
  the internal default factory. [ build 724, 2/4/08]


* 1) use impl path instead of locationpath in
  AeExtensionActivityUtil.queueReceiveData 2) slight refactoring to use local
  vars in AeExtensionActivityReplyReceiver. Easier for debugging. [ build 725,
  2/5/08]


* Added a new method to get the activity type of a supplied location path. For
  example if /process/flow/sequence is supplied, the method would return
  'sequence'. [ build 726, 2/6/08]


* fixed java docs in AeBaseQueueManager and AeBase64EncodeFunction [ build
  727, 2/8/08]


* 1) removed getAttachmentId from AeCreateAttachmentFunction - just return the
  attachment item directly from the add call [ build 728, 2/11/08]


* 1) method for getting an instance of the function validator factory was
  introduced to the IAeEngineConfiguration interface 2) checks for null to
  prevent NPE added to getActivityType and getActivityName in
  AeLocationPathUtils 3) AeAbstractFunctionValidatorFactory was removed and
  replaced with AeFunctionValidatorFactory, which supports registration of
  additional validators 4) AeDefaultEngineConfiguration now maintains an
  instance of the function validator factory [ build 729, 2/12/08]

org.activebpel.rt.bpeladmin.help.war

* ActiveBPEL Engine (in Designer product) ready for 4.1 launch [ build 20,
  9/11/07]

org.activebpel.rt.xmldb

* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  10, 11/20/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 11, 12/3/07]


* updated the ae.build.properties to use the newer jaxp api (xml-apis.jar
  instead of xmlParserAPIs.jar) [ build 12, 1/31/08]


* Added generic capability to filter strings in filter fields with wild card
  (*) through xml queries. Adopted that capability for process name searches
  in console filters. [ build 13, 2/7/08]


* Fixed a bug in the xmldb project - a connection was not being used properly
  in storeAttachment(). [ build 5, 9/12/07]


* Fixed inlined query in AeXMLDBQueryBuilder::appendCountQuery() to return xml
  content "<Count>N</Count>" instead of just the integer value (count). [
  build 6, 9/27/07]


* merging sterling branch [ build 7, 9/28/07]


* Added 'running or suspended' as one of the options for the process filter
  state flag. [ build 8, 10/1/07]


* converted project to plugin project so we can add it to the test engine
  plugin dependencies [ build 9, 10/7/07]

org.activebpel.rt.wsresource

* New project allows for executing rules to validate resources that are used
  by bpel processes or other files that are used to test or deploy bpel. [
  build 1, 12/17/07]


* 1) Moved the rule classloader to the validation context 2) the rule registry
  will now not load a rules.xml file unless that file is schema-valid [ build
  10, 1/28/08]


* update the problem reporter adapter so the problem markers in eclipse no
  longer show the error code in the problem message. [ build 11, 1/29/08]


* updated the validation engine problem handler adapter to just pass along the
  problem message to the IAeWSResourceProblemHandler, instead of formatting
  the message before passing it along [ build 12, 1/31/08]


* added plugin.xml;added provider name to plugin.properties; added
  Bundle-ClassPath to manifest.mf [ build 2, 12/19/07]


* 1) added plugin.xml to build.properties to fix warning message [ build 3,
  12/26/07]


* Refactored the WSResource problem handler/reporter and changed the schema
  for rules. In addition removed the requirement for a deserialization
  factory. [ build 4, 12/27/07]


* refactored the IAeWSResourceValidationContext interface to remove methods
  for resolving file paths and moved the code to the bunit context interface.
  This was done because not all validation requires the resolution of file
  system based resources. [ build 5, 1/9/08]


* 1) added default severity to the rules schema and updated all related
  classes to take advantege of the newer schema. 2) Validation preferences are
  now setup to read from a preferences file to override default rule severity.
  [ build 6, 1/10/08]


* 1) the wsresource context factory interface and class were removed from the
  project 2) the validation context interface now defines a getWSDLProvider()
  method 3) the validation engine has changes so that it is constructed with a
  context instead of a context factory. [ build 7, 1/11/08]


* 1) Added method to get the WSDL operation using portType and operation name
  to the wsresource context 2) updated interface for wsresource context [
  build 8, 1/21/08]


* Removed a bunch of ws-resource code that was not being used
  (serialize/deserialize framework, resource types, etc.) [ build 9, 1/22/08]

org.activebpel.rt.axis.bpel.web

* Added entry for ExtensionActivityDurableInfo in the engine config that
  points to the new durable extension activity reply receiver class [ build
  78, 11/2/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 79, 12/3/07]


* Remove unneccessary implements IAeWebServicesDeployer from
  AeAxisWebServicesDeployer 2) Added AeRestServlet to web.xml 3) added REST
  entries to aeEngineConfig-ActiveBPEL.xml [ build 80, 12/27/07]


* Added extensions map in aeEngineConfig-ActiveBPEL.xml [ build 81, 1/10/08]


* Updated the engine config for activebpel to include the AeWSIOPolicyMapper.
  [ build 82, 1/14/08]


* Removed REST support from ActiveBPEL open source see web.xml and
  aeEngineConfig-ActiveBPEL.xml [ build 83, 1/17/08]


* 1) AeEngineConfig-ActiveBPEL.xml - Added customer managers
  BPEL4PeopleManager, HttpServiceManager, IdentityServiceManager (with
  ldif/xml file provider); 2) AeEngineConfig-Persistent.xsl - Added entry up
  change BPEL4PeopleManager to use persistent version [ build 84, 1/18/08]


* 1) Updated engine config (in memory) B4PManager class to point to refactored
  class rt.b4p.server.AeServerB4PManager; 2) Updated engine config xsl
  (persistent) B4PManager class to point to refactored class
  rt.b4p.server.AePersistentB4PManager [ build 85, 1/22/08]


* changed package org.activebpel.rt.bpel.server.http to org.activebpel.rt.http
  in aeEngineConfig-ActiveBPEL.xml [ build 86, 1/24/08]


* 1) Added B4P custom storage and provider to engine config xsl; 3) Updated
  identity service mgr to user new class AeServerIdentityServiceManager [
  build 87, 2/2/08]


* 1) Removed abTaskClient security context from web.xml; 2) Add new security
  context workflowuser to web.xml securing services taskClientOperations and
  aeTaskClientOperations; 3) Added B4PLogicalPeopleGroupExtension entry to
  ExtensionRegistry [ build 88, 2/5/08]


* 1) added service name params to b4pmanager, moving them from java code to
  config [ build 89, 2/5/08]


* 1) removed security contraint for task services. If users in open source
  want to configure security for task clients they'll either need to add the
  security-contraint xml themselves or upgrade to the professional version
  (which comes with security-constraint all filled out and ready to go) [
  build 90, 2/7/08]


* 1) Added identity service invoke handler classname to the
  InvokeHandlerFactory 2) Updated engine config service names for
  AeB4PTaskLifecycle and NotificationService (removed 'Service' suffix); 2)
  Removed xsl cache setting entries from engine config since it is not
  supported anymore. [ build 91, 2/7/08]

org.activebpel.rt.bpel.ext.expr.bsf

* Removed plugin nature and manifest builder from project file as this project
  was generating a warning in eclipse 3.3 as it is not fully a plugin. [ build
  12, 10/31/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  13, 11/20/07]


* Fixed a minor whitespace problem in Manifest.mf that Ant's 'jar' task
  doesn't like. [ build 14, 11/30/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 15, 12/3/07]

org.activebpel.b4p.war

* 1) add HTTPPreemptive to AeAxisClientBase 2) update paths for new
  b4p.services project [ build 10, 2/11/08]


* 1) converted spaces and '@' in HTTP cookie names to underscore ('_') as per
  RFC; 2) Added 'remove' api command support to AeTaskCommandBean; 3) Updated
  inbox and task detail javascript to support notifications. 4) Updated Inbox
  buttons - only minimal list of buttons are display. They are Edit, Claim,
  Start and Remove (similar to 4.x release) [ build 11, 2/11/08]


* 1) Moved getAttachmentData() api call from IAeTaskHtClientService to
  IAeTaskAeClientService (since it is an aeTaskOperation - getAttachmentById);
  2) Added addAttachment(..) to IAeTaskHtClientService and its impl.; 3)
  Refactored some of the overloaded sendRequest() methods in for re-use and
  attachment support; 4) Updated AeWorkFlowAttachmentDownloadServlet to
  support new getAttachmentData() method (uses attachmentId instead of name);
  5) Refactored IAeXslTaskCommand param name from taskRef to taskId; 6)
  UPdated javascript to support attachments (add/delete). [ build 12, 2/13/08]


* 1) New project for the inbox - the UI is based on the previous aetask inbox
  application.; 2) The XSL, servlet, scripts and CSS ported over from aetask
  except for jsp rendering related code.; 3) XSL uses new namespaces and
  elements are based on wsht. (documentation to follow in requirements doc).
  Previous presentation/command xsl files will not work.; 4) Inbox AJAX
  listing is now based on using ae xpath war tags (previous versions bean
  classes not ported over).; 5) Added new task client service interface
  IAeHtClientService - whose implementation is backed by axis doc-literal
  client,.; 6) Refactored axis doc literal client into a minimal base class
  (WS-I style) and now uses separate request and response objects as wrappers
  for input data and output data (message element and optional file
  attachments); 7) Added serializers and deserializers for wsht api command
  such as getMyTaskAbstracts message.; 8) Note: current impl for inbox listing
  is using the adapter process. Other operations are stubbed out to be used
  with the b4p processes. [ build 2, 1/11/08]


* 1) Renamed some of the URL getter method names to reflect the propery (e.g.
  getTaskClientServiceURL() instead of getEndpoint() ); 2) Moved
  org.activebpel.b4p.war.htwsio to org.activebpel.rt.ht.api package (in rt.ht
  project); 3) Update the IAeTaskXSLStyleSheetStore and it impls to take extra
  param indicate if the renderings are meant for TASKS or NOTIFICATIONS - this
  is used to generate the proper default xsl files; 4) Moved ae task rendering
  xsl resources to rt.b4p project; 5) Added aux post build ant script to build
  rendering sdk zip file; 6) Removed unwanted (test) file result.html; 7)
  Renamed aeworkflow-config.xml entry name "EndpointUrl" to "TaskServiceUrl" [
  build 3, 1/18/08]


* Disabled taskClient XSL cache check timer. The xsl cache configuration will
  be moved to task war xml file in the next check in. [ build 4, 2/2/08]


* 1) Removed code related to accessing the inbox remote configuration data
  from the bpel server (since it will not be supported); 2) Removed xsl
  caching config polling code; 3) Removed security context from web.xml (the
  Inbox war context is not J2EE secured - instead authentication is delegated
  to bpel server); 3) Refactored inbox beans, filters, servlets, and http
  session management to support security/authentication via web service calls
  to AB Engine; 4) Added doc-literal client interfaces and implementations for
  ht task operations port type and ae (internal) task operations port type; 5)
  Updated Inbox app to support basic listing (no paging or sorting yet); 6)
  Added support for operations claim, start, stop, release; 7) Basic task
  detail page (with out operations or work item); 8) Updated entry names and
  values in aeworkflow-config.xml to support aeTaskOperations and
  htTaskOperations service endpoint urls [ build 5, 2/5/08]


* 1) Fixed FIXME: Removed RemoveConfigurationClientService 2) Fixed a bunch of
  left over FIXME in my last check-in: added getUserSession() and
  isAuthorized() methods to AeUserSession [ build 6, 2/5/08]


* 1) Updated AeHtClientRequest ctor to accept a element instead of a document;
  2) Updated caching stylesheet store to use the config settings based on xml
  file instead of remote server; 3) Add new task command class
  AeXslHtTaskOperationCommand - which takes any ws-ht API element and sends it
  to the server; 4) Removed AeXslSetOutputCommand and AeXslTaskCommand
  (replace with the single AeXslHtTaskCommand); 5) Various inbox UI, xsl, and
  javascript fixes.; 6) Added support for inbox Claim, Start, Stop, Release,
  SetOuput (save work item form) and Complete operations. [ build 7, 2/7/08]


* 1) Updated js and css to support ht task schema; 2) Add new command class
  AeXslAeTaskOperationsCommands which implements sending aeTaskOperations PT
  message elements; 3) Roemoved AeXslTaskCommentsCommand and
  AeXslTaskFaultCommand class - replaced with AeXslAeTaskOperationsCommands ;
  4) Inbox UI: add, update and delete of comments; 5) Inbox UI: set fault and
  fail.; 6) Inbox UI: set priority [ build 8, 2/8/08]


* 1) Add getMyTasks() to IAeTaskHtClientService and its imls.; 2) Updated
  Inbox listing (beans, jsp and js) to use htdt:getMyTasks api call instead of
  htdt:getMyTaskAbstracts. This change will now support listing of actual
  owner column in the inbox listing.; 3) Updated the default task xsl
  (presentation and command) to point the server catalog (my previous check-in
  had these hard coded to the c:/path/to/aedev). [ build 9, 2/8/08]

org.activebpel.rt.b4p.server

* 1) New project org.activebpel.rt.b4p.server to represent server dependent
  B4P classes. The jar is ae_rt_b4psrv.jar; 2) Added server B4P managers
  AeServerB4PManager (non-persistent) and AePersistentB4PManager. These also
  deploy supporting BPEL processes and XSL resources; 3) Added (from rt.b4) ae
  b4 custom function context (i.e. internal functions).; 4) Renamed old Eval
  function context as AeB4PInternalCustomFunctionContext [ build 1, 1/22/08]


* 1) use delegating function factory in eval function in order to pick up on
  other functions. 2) add placeholder for parent task instance to presentation
  params custom function (will return to have state machine pass values) 3)
  created new internal custom function: createHumanTaskContext() for use in
  the notification lifecycle in order to create humanTaskContext overrides 4)
  created new new ht function context for use in the notification lifecycle
  process. [ build 10, 2/4/08]


* Add a NPE check for GenericHumanRole in
  AePersistentTaskStorage::listMyTaskAbstracts() [ build 11, 2/5/08]


* 1) manager uses keys to pull service names from config [ build 12, 2/5/08]


* Fixed a minor bug in the b4p eval function impl. [ build 13, 2/6/08]


* removed aux.project.properties=eclipse.3.3.1.classpath.properties in
  ae.build.properties [ build 14, 2/7/08]


* 1)Updated AeSQLTaskFilter due to changes in DDL (rename of table names to
  start with AeB4PTask); 2) Updated IAeTaskSQLKeys, AeSQTaskStorageProvider
  and list result set handler to account for two new columns (createdBy and
  hasRenderings); 3) UPdated task-sql.xml to account for table name changes;
  4) Added copy of mysql ddl for the orginal 4.0 aetask ddl [ build 15,
  2/7/08]


* 1) Added support for getMyTasks(..) to B4P storage layer (impacts
  IAeTaskStorage, AePersistentTaskStorage and AeInMemoryTaskStorage); 2) Added
  getMyTasks(..) to storage invoke handler and new serializers/deserializers
  to support this.; 3) Added isSkippable to AeTrtTaskInstanceDeserializer; 4)
  Fixed bug where actualOwner was not written to the db (was null) as well
  isSkippable flag. [ build 16, 2/8/08]


* 1) repackaged attachment functions to their own package 2) added parent task
  instance to AeB4PEvalTaskPresentationElementFunction 3) added
  AeGetHTAttachmentsFunction to function context 4) renamed
  AeCopyHTAttachmentByName to AeCopyHTAttachmentsByName 5) renamed
  AeRemoveHTAttachmentByName to AeRemoveHTAttachmentsByName 6) repackaged eval
  function and supporting classes to their own package [ build 17, 2/11/08]


* added excluded owners and recipients to acl [ build 18, 2/11/08]


* 1) Add custom function AeHtCopyAllMimeAttachmentsFunction - similar to
  CopyAllAttachment function, except this returns list of attachment ids as
  <trt:attachmentId> elements; 2) Updated AeHTAttachmentSerializer to use
  IAeWebServiceAttachment when appropriate; added support for Attached-By;
  Used Content-ID attribute as attachment name instead of Content-Location; 3)
  Add AeHTAttachmentSerializer to AeB4PInternalCustomFunctionContext [ build
  19, 2/13/08]


* Removed version specific jre from kind="con" in entry in .classpath file [
  build 2, 1/22/08]


* 1) Added a custom b4p function AeB4PEvalTaskPresentationElementFunction to
  evaluate expressions in subject and description elements inside task
  presentation element [ build 3, 1/22/08]


* Fixed FIXMEs in AeB4PEvalTaskPresentationElementFunction [ build 4, 1/22/08]


* 1) refactored AeB4PEvalFunction so it could be more easily invoked from
  other functions 2) added IAeHtFunctionContext to AeB4PFunction so ht
  functions could have something to pull data from 3) added taskInstance
  element to AeB4PEvalTaskPresentationElementFunction, required for passing
  this data to b4p eval [ build 5, 1/27/08]


* 1) use new static convenience method to serialize task. Broke this code out
  into static for reuse in new test manager. [ build 6, 1/31/08]


* Made some changes to how LPGs are evaluated. They are now evaluated by the
  B4P manager. This gives us a hook that we can use during simulation and
  BUnit. The LPG providers are still present, but are only used by the server
  b4p manager. [ build 7, 2/1/08]


* 1) Added custom invoke handler, and related support classes for task
  storage; 2) Port of SQL storage provider; 3) Added in-memory storage
  provider [ build 8, 2/2/08]


* 1) Modified executeTask(..) and executeNotification(..) in
  AeServerB4PManager to accept attachment container. We now add this
  attachment container to the request message for the lifecycle process 2)
  Added custom attachment functions to add, copy attachment by name, copy
  attachment by id, remove attachment by name, remove attachment by id and get
  attachment [ build 9, 2/4/08]

org.activebpel.rt.http

* New Project with http support classes. [ build 1, 1/24/08]


* Fixed classpath issue - project now depends on the workspace default jre
  container. [ build 2, 1/24/08]


* Created Multipart http support. 1) Extended Httpclient to aupport all
  multipart subtypes. the apache distribution supports only multipat/form-data
  created AeHttpMultipartRequestEntity, AeHttpStringPart,
  AeHttpAttachmentPart, AeAttachmentPartSource, AeHttpPartFactory 2) Created
  multipart parser based on java mail MimeMultipart. New classes:
  AeHttpMultipartParser, AeServletRequestDataSource, AeHttpServletRequest,
  AeEnumerator, AeOpenTreeMap, AeMultipartFileInfo 3) refractored
  AeHttpRequest and AeHttpResponse to support multipart 4) refractored logic
  to allow all textual data to be passed in the payload instead of limiting
  the payload to xml data. 5) Refractored AeHttpPostHandler and
  AeHttpPutHandler 6) added methos to AeHttpUtil: normalizeHeaders,
  parseContentDisposition, getFormParam. 7) moved methods writeText,
  writeBinary from AeRestUtil to AeHttpUtil. [ build 3, 2/8/08]

ddl.org.activebpel.tasks

* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 21, 12/3/07]


* Updated ddl - Renamed B4P related table names to start with AeB4PTask prefix
  [ build 22, 2/7/08]


* keep db2 index names 18 chars or less [ build 23, 2/11/08]

org.activebpel.wsio

* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  36, 11/20/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 37, 12/3/07]


* Typos fixes [ build 38, 12/17/07]


* Added an accessor for the process initiator to the IAeInvoke interface. [
  build 39, 2/4/08]


* Added a method in AeWebServiceAttachment that adds "Attached-At" property to
  the attachment header when not present [ build 40, 2/4/08]


* added javadoc [ build 41, 2/8/08]


* Added "Attached-By" constant to IAeWebServiceAttachment [ build 42, 2/13/08]

org.activebpel.rt.tasks

* updated task_state.bpel to handle NCName for fault names in setFault and
  fail. It's difficult to construct an encoded QName in XSL so we'll support
  accepting an NCName and generating a QName using the interface's portType
  namespaceuri [ build 113, 9/5/07]


* 1) Updated ae_base_commands.xsl to extract fault local name iff fault name
  has prefix when setting fault or failing task with fault; 2) Fixed 3 xpath
  errors in ae_base_param2command.xsl. These errors where hidden in JRE 1.5.x
  but surfaced in JRE 1.4.x [ build 114, 9/7/07]


* Removed some unicode characters (slanty quotes) from taskDef.xsd. This would
  cause problems with ActiveBPEL for People on MySQL if the data source
  connection string was missing the utf8 options. [ build 115, 9/12/07]


* Updated javascript in ae_base_taskdetail.xsl so that the default task detail
  page stays on the last used tab when a command is issued (i.e. if a comment
  was added, then when the page is reloaded, the comments tab is shown).
  Related defect 3138. [ build 116, 9/12/07]


* 1) added try/catch around AeTaskStorageInvokeHandler in order to log any
  exceptions 2) added catchAll around InsertTask and UpdateTask in
  task_state.bpel 3) added retry policy for 3 attempts at 1 second delays for
  task storage partner link in task_state.pdd [ build 117, 9/20/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 118, 12/3/07]


* Updated to AePersistentTaskManager to not to use the licensing in
  prepareToStart() since aetasks will be supported in open source. This done
  just for the ht adapter process (aetask -> b4p task) usage and will be
  deprecated when the b4p task processes are brought online [ build 119,
  1/11/08]

ddl.org.activebpel

* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 48, 12/3/07]

org.activebpel.rt.rest

* 1) Refractored AeRestInvokeHandler to support payload and attachment
  delivery. 2) other classes refractored: AeRestServiceConstants, AeRestUtil
  3) AeRestParameter removed 4) added messages to messages.properties [ build
  1, 12/17/07]


* 1) fixed defect 3623. added <pre> tag to report in AeRestServiceManager for
  IE to displat text formatting correctly. 2) AeRestservlet refractored to use
  AeHttpServletRequest, writeText and writeBinary methods have been moved to
  AeHttpUtil. 3) AeRestUtil: a) fixed NullPointerException when uri is null in
  method getPartnerUri. b) createMessageData method modified to use the
  methods in AeHttpUtil c) moved method httpBody2wsioAttachment to
  AeHttpServletRequest d) createResponseMessage method refractored to handle
  all text in the payload instead of the attachments which now are used only
  for non textual content. 4) added and updated messages in messages.proprties
  5) AeRestPolicyMapper - fixed NullPointerException when usage tag has no
  data. 6) Refractored AeRestInvokeHandler to support multipart messages. A
  multipart meaage is sent when there are at least to messages from any
  combination payload and attachments. a) createHttpRequest method now throws
  an exception when the endpoint reference addres tag has no text, the payload
  contentType is used in conjuntion with the endpoint and
  AeMimeUtil.getSafeTextMime. [ build 10, 2/8/08]


* commented out unused local variables in AeRestUtil [ build 2, 12/17/07]


* 1)Added REST receive handler AeRestHandlerFactory and AeRestReceiveHandler
  2) rest service deployment AeRestservicesDeployer and AeRestPolicyMapper 3)
  created Rest servlet AeRestservlet.4) created AeRestServicemanager,
  IAeRestServiceManager and AeRestServiceContext to register supported myrole
  services 5)removed AeRestException 6) Added methods to AeRestUtil 7) added
  rest messages to messages.properties 7) Refractored AeInvokeHandler to
  support faults 8) added servlet.jar to .classpath and ae.build.properties [
  build 3, 12/27/07]


* 1) renamed AeRestDeploymentManager to AeRestServiceManager 2) Added
  removeServiceContext method to AeRestServiceManager to support undeployment
  3) Refactored AeRestServlet: support for GET, OPTION. DELETE,TRACE and HEAD
  unsupported. Added text and binary payload support 4) Added methods:
  getPayloadContentType, added payload support to createRequestMessage method,
  new methods: httpBody2wsioAttachment , createTextResponse,
  createBinaryResponse. 5) added removeServiceContext method to
  IAeRestServiceManager. 6) Added missing and new messages to
  messages.properties. 7) Refactored AeRestPolicyMapper: getCallProperties
  extracts HTTPTransport configuration properties. 8) Added
  removeServiceContext to undeployFromWebServiceContainer in
  AeRestServiceDeployer. 9) Refactored AeRestInvokeHandler: supports policy
  driven properties and other improvements. [ build 4, 1/4/08]


* 1) adde HEADERS_TAG and HEADER_TAG to AeRestServiceConstants for headers
  element in aeREST.xsd 2) refractored addServiceContext and getServiceContext
  methods in AeRestserviceManager 4) Refrectored AeRestServlet: Added support
  for 403 response for unregistered rest uri, response can now send multiple
  attachments in the response 5) AeRestUtil: added support for headers in the
  RESTRequest message, refractored code 6) Added AeRestServiceManager messages
  to messages,properties 7) Adapted AeRestiInvokeHandler to the headers
  element in the RESTRequest message [ build 5, 1/7/08]


* 1) getServicecontext method in AeRestServiceManage modified to check
  pathinfo instead of the url 2) AeRestservlet extract the pathinfo for rest
  service detection, blob stream are closed to elimiate lingering temp files.
  3) AeRestUtil bug fixes, added pathinfo detection support and moved http
  related methods to AeHttpUtil. 4) added aeREST.wsdl and aeREST.xsd to the
  project under the support directory 5) updated .classpath and
  ae.build.properties to reference project org.activebpel.rt.axis [ build 6,
  1/17/08]


* 1) refactored AeRestServicecontext to inclued rest manager reporting: list
  of registered rest services and service usage. AeRestServiceContext is
  interpreted by the AeRestServlet. 2) The AeRestServiceManager refactored to
  support the service name of the myrole instead of the policy context path.
  Reporting added for listing the registered services and their usage messages
  renamed to reflect the changes. 3) AeRestServlet uses AeRestserviceContext
  to handle a valid request or return a report. 4)AeRestUtil refactored:
  renamed method getRequestContext to getServiceName, service name is case
  sensitive, method findPattern made public for broader usage. 5)
  IAeRestServiceManager refactored: renamed methods addServicecontext,
  removeServiceContext, getServiceContext to addService, removeService,
  getService respectively. getService returns AeRestServiceContext instead of
  IAeServiceDeploymentInfo. 6) message.properties: messages added and renamed
  7) AeRestPolicyMapper refactored: supports the RESTenabled element with
  attribute 'description' and sub element 'usage'. 7) AeRestServicesDeployer
  refractored: delegates deployment to the default deployer (axis soap) to
  make the rest service available as a soap service as well. The rest policy
  entries are not passed on to the deployer, all other policies remain intact
  . method getPolicyDrivenProperties moved to AeRestUtil for usage by the
  AeRestServicesManager. [ build 7, 1/22/08]


* 1) Added http response headers to the RESTResponse message. changes made in
  AeRestinvokehandler, AeRestutil, AeHttpUtil, AeHttpResponse, AeHttpRequest
  2) fixed defect in AeRestServiceManager 3) fixed defect in AeRestServlet and
  AeRestUtil - incorrect handling og faults 4) refactored aeREST.xsd 5) added
  classpath dependencies to org.activebpel.rt.http project in .classpath and
  ae.build.properties [ build 8, 1/24/08]


* undeployment of a REST service now induces the removal of the web service in
  AeREetServicesDeployer. [ build 9, 1/29/08]

org.activebpel.enginep

* New ActiveBPEL Engine plugin will allow us to ship the open source engine as
  a plugin. Note all exported packages from an org.activebpel.* plugin will
  need to be reexported through this plugins export package section. [ build
  1, 1/29/08]


* Updated manifest to expose extra axis packages, servlet and activation
  needed by updated remote debug handler. [ build 2, 1/31/08]


* Added Import-Package for javax.xml.namespace to manifest to make it easier
  to create engine installation within eclipse. [ build 3, 1/31/08]


* Added org.activebpel.rt.b4p.impl.request to export package list in
  manifest.mf [ build 4, 2/4/08]

org.activebpel.rt.b4p.services

* Moved all b4p service elements into their own project. In addition: 1)
  implemented addAttachments, deleteAttachmentById, deleteAttachments,
  deleteFault, deleteOutput, getAttachmentById, getAttachmentInfos,
  getAttachments, remove on state machine 2) minor refactoring of state wsdl
  to use recipients instead of potentialOwners in remove process 3) use parent
  task state for all expressions when available 4) all assertions for
  potentialOwners account for notifications which use the recipients role
  instead [ build 1, 2/11/08]


* 1) Enabled "Remove" button in notifications view XSL 2) Added XSL command
  support for "Remove" task operation; 3) Updated aexlsformparameters.xsd
  schema - renamed 'taskRef' attribute to 'taskId'. [ build 2, 2/11/08]


* 1) Fixed xquery (xml structer) error in getAttachmentById onMessage handler
  in aeb4p-task-state.bpel; 2) Removed 'Service' suffix from service names in
  task state pdd.; 3) Update presentation and command xsl to suppport
  attachments [ build 3, 2/13/08]


* 1) added attachment propagation between state and lifecycle processes 2)
  added optional includeAttachments flag to internal getTaskInstance operation
  3) updated property alias for getTaskInstance to reflect change of task id
  to element data [ build 4, 2/13/08]

org.activebpel.rt.bpeladmin.war

* Updated AeProcessDefToWebStateModelVisitor::visit(AeActivityForEachDef) to
  handle case for 1 interation [ build 235, 9/7/07]


* fix for defect 3200 - AeNewAttachmentUploader now uses AeMimeUtils to
  resolve an uploaded file mime type and does not rely on commons-upload
  library. [ build 236, 9/7/07]


* Updated AeProcessDefToWebStateModelVisitor::setState(..) method to only set
  default (in-active) state iff the bpel object is an non-actity type object
  (i.e. skip variables, partnerlinks etc.). Related defect - 3198. [ build
  237, 9/10/07]


* Fixed problem with help link broken for processview pages since they are
  located under a nested directory path from main level [ build 238, 9/11/07]


* rename to AeNotUnderstoodExtensionActivityDef [ build 239, 9/11/07]


* Added css .filebrowse entry to control the width of the attachment file
  location field in the admin console popup window
  processview_attachment_add.jsp [ build 240, 9/12/07]


* avoid setting state on bpel object if its already been set [ build 241,
  9/13/07]


* Updated AeProcessDefToWebStateModelVisitor to not build 'current state'
  property for correlationSet, correlationSets and copy object (since they do
  not have state). Related defect 3198. [ build 242, 9/17/07]


* assorted refactorings related to def io repackaging [ build 243, 9/25/07]


* merging sterling branch [ build 244, 9/28/07]


* 1) uses new classes for assigning missing location paths on defs [ build
  245, 10/1/07]


* Added visit(AeUnderstoodExtensionActivityDef) to
  AeProcessDefToWebVisitorBase [ build 246, 10/9/07]


* Modified visitors to account for extension activity def rename [ build 247,
  10/12/07]


* Updated console UI for configuration section to specify both a web service
  invoke timeout and a web service receive timeout [ build 248, 10/12/07]


* Impact from refactoring [ build 249, 11/13/07]


* Minor changes due to method rename. [ build 250, 11/28/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 251, 12/3/07]


* 1) externalization of ActiveBPEL to messages.properties [ build 252,
  12/26/07]


* 1. Refactored process graph visual model to use AeXmlBaseDef instead of
  AeBaseDef (bpel); 2. Updated process def to visual model visitors to support
  contributions from extension elements and extension activities.; 3) Updarted
  image resource loading process to return place holder image if named icon
  image was not found in the classpath. [ build 253, 1/3/08]


* 1. Modified AeBpelControllerFactory to remove null entries from
  CONTROLLER_MAP that were used to indicate that these nodes were not meant to
  appear on canvas, now this is handled using a flag in the AeBpelObjectBase
  2. Added display on outline view only flag and adapter to AeBpelObjectBase
  3. Modifed visit(..) methods for defs that do not need to appear on canvas
  to to set the flag in AeProcessDefToWebModelVisitor 4. Modified build()
  method in AeProcessWebPropertyBuilder so when model has an adapter on it,
  then it asks the adapter for the properties [ build 254, 1/10/08]


* 1) Fixed bug where the execution state of activities were not being
  displayed in the process graph; 2) Fixed NPE on Assign activity property
  builder for the console process graph [ build 255, 1/11/08]


* Admin console UI - added JS pages and supporting beans for Extended Services
  section along with Task Manager and Identity Services pages for this
  section. [ build 256, 1/18/08]


* Changed config text for "Web Service Receive Timeout" to "Web Service Reply
  Timeout" to reduce confusion of where timeout policy applies [ build 257,
  1/23/08]


* Removed links to the Task Manager console page from the Extended Services
  section (no longer supported) [ build 258, 2/8/08]


* Implemented support for removing properties marked for removal by the
  adapter in buildPropertiesFromAdapter() method of
  AeProcessWebPropertyBuilder [ build 259, 2/12/08]

org.activebpel.rt.identity

* Defect 3288 related - 1) Updated AeLdapIdentity class to copy LDAP
  attribute/values specified in the LDAP User Search filter configuration; 2)
  Updated AeLdapEntry object so that the LDAP attribute names are not
  converted to lowercase. [ build 31, 11/20/07]


* 1) overloaded the assertPrincipalInQueryResult to accept multiple identity
  queries 2) updated wsdl to support multiple queries for principal assertion.
  This will allow state machine process to accomplish security checks using a
  single invoke instead of multiple invokes. [ build 32, 12/17/07]


* Changes to AeIdentityServiceInvokeHandler and AeIdentityServiceMessageIO
  dues to refactoring of common methods to AeWSIInvokeHandlerBase and
  AeWSIInvokeMessageIOBase [ build 33, 12/19/07]


* Converted identity to a plugin project so that is available to a running
  bunit test. [ build 34, 1/5/08]


* Added countIdentities operation to Identity Service interface. [ build 35,
  1/11/08]


* 1) added variant assertion that returns which query the identity was found
  in. This is useful for authorization when you also want to know which role
  the user had. For example, assert user is admin or potentialOwner and return
  1 based offset that indicates the match. If the user is in none, the
  assertion faults. 2) refactorings to service message deserializer and
  supporting classes [ build 36, 1/21/08]


* 1) Added new manager AeServerIdentityServiceManager - this mgr is
  responsible for deploy bprs; 2) Refactored invoke handler i/o to use new
  base abstract classes AeXMLDeserializerBase and AeXMLSerializerBase; 3)
  Ported identity service bpel process from aetask and added Ant aux post
  build to build bprs [ build 37, 2/2/08]


* 1) removed process nature until some bugs are fixed [ build 38, 2/4/08]

org.activebpel.rt.bpel.ext.expr

* Removed plugin nature and manifest builder from project file as this project
  was generating a warning in eclipse 3.3 as it is not fully a plugin. [ build
  30, 10/31/07]


* Refactored XQuery expression runner classed to use
  IAeExpressionVariableResolver [ build 31, 11/1/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  32, 11/20/07]


* Fixed a minor whitespace problem in Manifest.mf that Ant's 'jar' task
  doesn't like. [ build 33, 11/30/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 34, 12/3/07]


* Updated all references to the expression parsing and validation
  classes/interfaces that were moved from org.activebpel.rt.bpel to
  org.activebpel.rt [ build 35, 1/25/08]


* 1) added another check in AeXQueryExpressionTypeConvert.convertFromSaxonType
  to convert a NodeInfo to a DOM. This involves walking the NodeInfo and
  recreating a DOM element for each one. This is necessary since the Saxon
  Node wrapper doesn't expose namespaces as attributes. [ build 36, 1/27/08]

org.activebpel.rt.ht

* Changed task and notification to have an AePeopleAssignmentsDef child and
  changed class hierarchy - AePeopleAssignmentsDef no longer extends
  AeAbstractGenericHumanRoleDef. [ build 10, 10/26/07]


* Removed plugin nature for this project to avoid eclipse 3.3 warninngs. Note
  there is an eclipse dependency here which should be removed in upcoming
  checkins. [ build 11, 11/1/07]


* Added IAeWSHTConstants class (for namespaces, prefixes etc. [ build 12,
  11/1/07]


* Implemented clone, toString, hashCode and equals overloads for majority of
  HT def objects. All this was required for tabbed property edit support. [
  build 13, 11/6/07]


* base classes in rt layer handle registry entries for element
  extensions/attributes, element creation and traversal, segment visitor, and
  some def traverser behavior. [ build 14, 11/8/07]


* 1) element: parameterBinding replaced by presentationParameters 2) new:
  AePresentationParametersDef, AePresentationParameterDef,
  IAeVariableUsageContainer . 3) deleted AeParameterBindingDef 4)
  ws-humantask.xsd local references ar QName not NCName 5) created traversers
  to extract variable names from expressions 6) AeHtIO.deserialize sets parent
  child relations. 7) refractoring of def classes to better support
  expressions. [ build 15, 11/8/07]


* 1) Added clone and comparison support for entire HT def layer 2) Fixed HT
  serialization issue for HT ExcludedOwners people assignment [ build 16,
  11/13/07]


* 1) added support for peopleactivity by introducing IAeTaskDefParent [ build
  17, 11/14/07]


* Inlined all Def Class definition constants [ build 18, 11/14/07]


* fixed defects that made testB4PFullMonty fail [ build 19, 11/14/07]


* A new plugin project org.activebpel.rt.ht has been created for the WS-HT
  model: 1) Created the Def object model for WS-HT classes in
  org.activebpel.rt.ht.def classes: Ae*Def.java 2) Created the WS-HT xml
  deserialize read registry and traversers. classes are AeDefReaderVisitor,
  AeAbstractHtReaderRegistry, AeHtReaderRegistry, 3) supporting model classes
  and interfaces created: AeHtDefTraverser, AeHtTraversalVisitor,
  AeAbstractHtdefVisitor, IAeHtDefVisistor, IAeHtDefTraverser,IAeHtconstants,
  IAeHtClassConstants, AeHtIO 4) Created Location path traversal Segemnt
  visitor: AeHtDefSegmentVisitor. 4) Created classes for the write registry
  and serialization of the model (These are incomplete and will be rady on the
  next checkin, they are checked in to resolve dependencies of AeHtIO). [
  build 2, 10/4/07]


* 1) removed plugin activator (to remove Eclipse dependency) 2) minor def i/o
  refactoring [ build 20, 11/15/07]


* added method addNamespacesInScope() to support serializing any def as a root
  def [ build 21, 11/15/07]


* 1) Added writer registry created with WSHT Protocol namespace and added it
  to a new AeDefIORegistry for serializing people assignments from ht protocol
  namespace [ build 22, 11/20/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  23, 11/20/07]


* 1) introduced base class for description, name, and subject to handle the
  xml:lang attr 2) added read/write of xml:lang on pres elements [ build 24,
  11/20/07]


* Added ability to set expression value, which was not exposed on HT def. [
  build 25, 11/26/07]


* previous commits failed [ build 26, 11/27/07]


* attempt # 3 (with jw watching) [ build 27, 11/27/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 28, 12/3/07]


* 1) changed AeFromDef to have LPG ref as a QName instead of a string 2) added
  inline ref to LPG on AeFromDef 3) added logic for walking tasks, LPG's, and
  notifications to the respective container defs AeTasksDef,
  AeLogicalPeopleGroupsDef, AeNotificationsDef [ build 29, 12/3/07]


* 1) Created custom AeHtExtensionElementReader that does not added all
  namespace attributes from an extension element all the way to the root
  element. 2) Added 'namespace' attribute to AeHumanInteractionsDef 3)
  Completed serialize method logic in AeHtIO 4) Fixed BUSINESS_ADMINISTRATIORS
  typo 5) Completed serializtion of the WS-HT Def model. classes are
  AeAbstractWriterRegistry, AeHtDefTraverserVisitor,
  AeHtDelegatingDefWriterVisitor, AeHtDefWriterVisitor. 6) Removed
  visit(AeExtensionAttributeDef aDef) from AeAbstractHtDefVisitor 7) Moved
  AeHtLocationPathVisitor from org.activebpel.rt.ht.def.io.readers to
  org.activebpel.rt.ht.def.visitors [ build 3, 10/9/07]


* 1) Added new methods to AePresentationParametersDef to set the name, subject
  and description definitions using a list argument. 2) Added a new method to
  AePresentationParametersDef to clear the parameters list. 3) Added a
  message.properties file for this project. [ build 30, 12/4/07]


* In the class AePresentationElementsDef added a default value for the
  AePresentationParametersDef member variable. [ build 31, 12/6/07]


* Changed setting of a default value for the AePresentationParametersDef
  member variable back to null in the class AePresentationElementsDef. A
  default null value is acceptable as the presentationParameters element is
  optional. [ build 32, 12/7/07]


* 1) added assignParent on all add/set def calls 2) removed AeDurationExprDef,
  was base class for for and until defs but had no behavior and was confusing
  since only a 'for' is a duration 3) changed AeAbstractDeadlineDef's refs to
  its for and until defs to be more explicit. Use the actual classes, not a
  base class. 4) removed AeBooleanExprDef, same reason as duration def 5)
  changed AeEscalationDef to use AeConditionDef for its condition instead of
  base class [ build 33, 12/13/07]


* Removed "throws Exception clause" from serialize() methods since this is not
  necessary [ build 34, 12/14/07]


* 1) Added test cases to test b4p extension functions getTaskPriority,
  getAdministrators, getPotentialOwners, getTaskStakeholders, getTaskInitiator
  and getActualOwner 2. Added test case for testing save() and restore() in
  AePeopleActivityImpl [ build 35, 12/14/07]


* Removed plugin project nature from .project file [ build 36, 12/17/07]


* 1) changed AeTaskDef to keep its ref to its searchBy def as an AeSearchByDef
  instead of the base class 2) added IAeLocalNotificationDef and
  IAeLocalResourceDef to achieve better reuse between local task and local
  notification 3) added getters to IAePeopleAssignmentsDefParent and
  IAePriorityDefParent [ build 37, 12/17/07]


* Added toString implementations on defs for use by property descriptors [
  build 38, 12/21/07]


* updated ae.build.properties to use eclipse.3.3.1.classpath.properties [
  build 39, 12/26/07]


* Updated ae.build.properties classpath to include eclipse jars [ build 4,
  10/11/07]


* 1) renamed all attr constants to start with ATT_ instead of TAG_ [ build 40,
  12/26/07]


* 1) Added an interface IAeHtFunctionContext for WSHT extension functions 2)
  Added convenience methods to AeFromDef to identify if the assignment is from
  a literal, expression or LPG [ build 41, 12/27/07]


* 1) added convenience getParent() to ht base def 2) added common interface
  for task and notification - IAeHtInputInterfaceDef [ build 42, 12/28/07]


* 1) added some add/remove methods for the container defs which were needed to
  support these ops in designer 2) start/completion deadlines weren't checking
  for class equality in equals 3) escalation def now impls IAeNamedDef 4)
  removed usedVariables from task's equals 5) added default prefix to
  constants intf [ build 43, 12/29/07]


* Changed AeAbstractParameterListDef to expose members as List instead of
  Iterator since we need ability to edit contents. [ build 44, 12/31/07]


* 1) added deferActivationTime to ws-humantask-protocol.xsd. Seems like an
  omission from the schema. [ build 45, 12/31/07]


* 1) Fixed problem with equality check for FromDef not catching difference
  between null and empty QName 2) Added implementations of isDefined() on
  AeDelegationDef, AeOutcomeDef and AeSearchByDef for use by
  expansion/deflation visitor in determining if object has been edited [ build
  46, 1/3/08]


* Refactored AeEscalationDef's toParts member data from a List to an
  AeToPartsDef, modified setter and getter methods accordingly. [ build 47,
  1/4/08]


* .classpath update - using pde container in .classpath to reduce duplicate
  classpath entries [ build 48, 1/5/08]


* 1) removed unused methods 2) removed prefix for ht serialization [ build 49,
  1/7/08]


* 1) Renamed plugin Activation class to AeHtactivation 2) Modified AeFromDef
  to support multiple 'argument' sub elements. 3) Implemented
  IAeLogicalPeopleGroupsDefParent, IAeNotificationsDefParent and
  IAeTasksDefParent to support external human interactions parents such as
  BPEL4People. 4) Added generic readers to AeAbstractHtReaderRegistry to
  support B4P parents. 5) Added javadocs to AeHtDefWriterRegistry. 6) Added
  support to return an element in addition to a document to
  AeHtDelegatingDefWriterVisitor 7) Moved all extensions directly after
  documentation to adhere to the ht schema in AeHtDefTraverser 8) javadoc
  modified to remove BPEL references. [ build 5, 10/16/07]


* Adding the rules for HT validation as well the context and factory classes
  needed to perform wsresource validation. Since standalone HT validation
  isn't supported yet, many of these classes are in preparation for standalone
  HT validation, but also serve the purpose of acting as base classes for B4P
  validation of HT elements. [ build 50, 1/9/08]


* updated the bunit rules file to conform to updated rules schema [ build 51,
  1/10/08]


* 1) fixed Null Pointer exception with validation rule when AeTaskDef wasn't
  parented by an AeTasksDef 2) updated the ht-rules.xml file to conform with
  schema updates 3) validation preferences now extends the ws resource
  validation preferences abstract class [ build 52, 1/10/08]


* 1) AeEscalationProcessDef added extension to ht deadline to support
  escalation process 2) AeDeadlinesDef.isDefined() reports if there are
  start/completion deadlines configured 3) AeEscalationDef wasn't assigning
  itself as parents of its children 4) added entries in the
  visitors/registries for reading/writing/visiting the new defs [ build 53,
  1/10/08]


* 1) Renamed AevMessages as AeMessages and updated classes that referenced
  AevMessages [ build 54, 1/11/08]


* Modified AeHtDefReaderVisitor to check parent for null before setting
  child's parent [ build 55, 1/11/08]


* 1) the ht validation context factory was removed from the project 2) The Ht
  validator now statically caches the rules registry and constructs a new
  engine for validation, also changes to support the context factory removal
  were made [ build 56, 1/11/08]


* 1) added get for an arg by name to AeFromDef 2) added getter to
  IAeFromDefParent [ build 57, 1/15/08]


* 1) In AeRenderingsDef added convenience method getRenderingsCount. 2) In
  AeRenderingDef added methods getRenderingElement and setRenderingElement. [
  build 58, 1/17/08]


* 1) Moved all of wsht api io code from b4p.war project to this rt.ht project
  under new package org.activebpel.rt.ht.api; 2) Added task classes
  AeHtApiTask and AeHtPiTaskList; 3) Added supporting serializers for
  getMyTaskAbstractsResponse and getMyTasksResponse given a AeHtPiTaskList
  (unit tests included in tests projects); 4) Added size()::int methods to
  AeUsersDef and AeGroupsDef to return child count [ build 59, 1/18/08]


* 1) added ws-ht schemas for api, policy and protocol 2) added ws-ht WSDLs for
  api and protocols. [ build 6, 10/16/07]


* 1) AeTaskDef and AeNotificationDef implement interface IAeInterfaceDefParent
  and the original getInterface method was renamed to getTaskInterfaceDef 2)
  AeTaskInterfaceDef and AeNotificationInterfaceDef implement interface
  IAeInterfaceDef and the original getInterface method was renamed to
  getNotificationInterfaceDef 3) size method was added to
  AePresentationElementDefs to return the number of presentation elements 4)
  getNotificationDefs method added to interface IAeNotificationDefParent and
  an implementation was added to AeEscalationDef 5) AeHtIO will now
  deserialize an AeLiteralDef 6) OrganizationEntity reader was added to the
  AeAbstractHtReaderRegistry 7) new HT validation rules and ht rule xml file [
  build 60, 1/21/08]


* 1) added process nature to project 2) added some getters/setters to
  AeParameterDef to support getting/setting the type as a string (local part
  only). This was done to use the object more easily within b4p-ep control,
  although that control could be changed as well to have a custom label
  provider/cell editor but that was a little more work. [ build 61, 1/21/08]


* 1) Add $Date: 2008/05/09 18:48:36 $ into version.properties.; 2) Fixed typo in
  ws-humantask-api.wsdl <wsdl:output message="addCommentResponse" /> (was
  addCommentResposne); 3) Fixed typos is clientParticipantPortType portType
  entry in ws-humantask-protocol.wsdl (messages pointed to htdp:elementName
  instead of tns:messageName) [ build 62, 1/22/08]


* Fixed some problems in the ws-ht wsdl/schema files. [ build 63, 1/22/08]


* 1) Added Reader entry for task-presentation-elements in
  initGenericElementRegistry() 2) Fixed a condition in merge(..) of
  AeAbstractHtValidator that was causing a validation failure for people
  assignments in notifications [ build 64, 1/22/08]


* 1) In the class AeEscalationDef added missing escalation name check from the
  equals method. This was causing issues deleting Escalations in the Outline
  View. 2) Modified project validation preference to suspend all validators. [
  build 65, 1/23/08]


* 1) New interface IAeHtFunctionNames was added to statically define all WS-HT
  1.0 xpath function names 2) new 'merge' method on AePeopleAssignmentsDef to
  merge a PeopleAssignment into the existing people assignment, and returns a
  new people assignment object with the overridden elements. 3) new getPart
  method on AeToPartsDef to return a single part by name. 4) new rules for
  expression validation were added along with changes to the context to
  support those rules. [ build 66, 1/25/08]


* 1) added isLanguageSpecified on AePresentationElementDef 2) use AeNameDef
  and AeSubjectDef instead of base class when adding children to
  AePresentationElementsDef 3) added code to trim defs that don't match the
  provided xml:lang from AePresentationElementsDef [ build 67, 1/27/08]


* Added 'isDefined' to the abstract expression def. [ build 68, 1/28/08]


* Added missing default names for new inline notifications and inline tasks. [
  build 69, 1/29/08]


* removed xml.xsd from the project , it is now referenced in project
  org.activebpel.rt [ build 7, 10/17/07]


* 1) removed faultName from getFault operation. this element was dropped for
  the June 2007 draft specification but was mistakenly left in the schema. [
  build 70, 1/31/08]


* 1) Added IaeHtApiTaskList and impl 2) Updated GetMyTaskAbstracts
  serializers/deserializers to use new base abstract classes
  AeXMLDeserializerBase and AeXMLSerializerBase 2) Added createdOn,
  lastModifed, escalationTime and expirationTime AeSchemaDataTime member types
  to AeHtpAPiTask [ build 71, 2/2/08]


* Created AeHtDefInlineTaskTraverser that extends AeHtDefTraverser to traverse
  inlined task when visiting localtask. This traverser is used in the task
  builder for parenting the cloned task. [ build 72, 2/4/08]


* 1) removed process nature until some bugs are fixed 2) added taskName to ht
  function context methods [ build 73, 2/4/08]


* new rule to ensure that the getInput() function has the required argument
  partName [ build 74, 2/6/08]


* a message was missing from the bundle in org.activebpel.rt.ht [ build 75,
  2/6/08]


* 1) HT validation context is now capable of creating a traversal visitor for
  the validation rule removing the requirement for B4P rules to extend HT
  rules in order to change the traverser. 2) The base class for HT validation
  rules will now use the traversal visitor from context. [ build 76, 2/7/08]


* 1) Fixed bug in AeHtApiTask:getActualOwner (used to always return null); 2)
  Renamed AeGetMyTaskSerializer as AeGetMyTasksSerializer (missing 's'
  tasks).; 3) Updated AeGetMyTasksResponseSerializer ctor arguement to be
  IAeHtApiTaskList instead of impl. AeHtApiTaskList [ build 77, 2/8/08]


* 1) added contentType to ws-humantask-api-wsdl.xsd's addAttachment element. [
  build 78, 2/11/08]


* added excluded owners to ht task object [ build 79, 2/11/08]


* 1. some minor refactorings in the ht def layer 2. removed the ht extension
  element reader (the one in base xml def is fine) 3. created an abstract ht
  visitor and renamed the old one to AeAbstractTraversingHtDefVisitor [ build
  8, 10/23/07]


* HT rule 114 was deleted. This rule checked that a PA contained an empty
  potentialOwners def. [ build 80, 2/12/08]


* Added new class AeHtAddAttachmentRequestSerializer [ build 81, 2/13/08]


* 1) new ctor on AeOrganizationalEntityDef to accept AeUserDef [ build 82,
  2/13/08]


* 1) Modified the ht literal def to more closely mimic the bpel style literal.
  Now, the literal only has nodes as its children. This was necessary to
  facilitate Designer behavior, which wants to deal with XML literals rather
  than organizational entity defs. I kept the existing organizational entity
  def, which will be useful as a top level def. 2) refactored the abstract
  traversing ht def visitor to extend the base abstract ht visitor to remove a
  lot of visit methods [ build 9, 10/24/07]

org.activebpel.rt.axis.bpel.admin

* Added Export-Package entries to MANIFEST.MF for axis and jaxrpc packages
  needed for remote debugging [ build 10, 1/16/08]


* Update to the MANIFEST.MF to remove linefeed after the Export-Package:. This
  was causing issues with launching the installed version of Designer. [ build
  11, 1/17/08]


* Updated manifest to expose extra axis packages, servlet and activation
  needed by updated remote debug handler. [ build 12, 1/31/08]


* merging sterling branch [ build 6, 9/28/07]


* Removed private ctor which was causing a warning with eclipse 3.3 compiler
  and was not applicable as a public constructor was available. [ build 7,
  10/31/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  8, 11/20/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 9, 12/3/07]

org.activebpel.rt.bpel.server

* 1) changed catch of SQLException in AeSQLTransaction to Throwable since it
  won't be a SQLException if its coming from a Proxy 2) left comment about
  double-check style syncrhonization in AeTransactionManager, will refactor
  later [ build 500, 9/7/07]


* Added isXslEntry() to AeResourceKey [ build 501, 9/12/07]


* Made some alterations to AeStorageConfig to address possible race conditions
  (since the DB statements are being loaded lazily, and we could get multiple
  threads trying to load them at once). [ build 502, 9/21/07]


* Added ability to obtain my role and partner role policies for a given
  partner link in a deployment plan [ build 503, 9/26/07]


* merging sterling branch [ build 504, 9/28/07]


* 1) Changed process deployment methodology of obtaining my role and partner
  role policies to obtain from the resolved policy list 2) Fixed areas which
  were manipulating policy list directly instead of through endpoint [ build
  505, 9/28/07]


* Added 'running or suspended' as one of the options for the process filter
  state flag. [ build 506, 10/1/07]


* 1) Changed process invoke handler to not use web service timeout 2) Modified
  AeBpelEngine to check if timeout policy is in force [ build 507, 10/12/07]


* Engine will now through an exception if a process that cannot be restarted
  is attempted to be restarted. [ build 508, 10/17/07]


* Removed private ctor which caused a warning with eclipse 3.3 compiler and
  was not applicable as a public constructor was available. [ build 509,
  10/31/07]


* 1) Added new Factory to create extension activity reply receiver 2) Added
  durable reply receiver for extension activity [ build 510, 11/2/07]


* export the rt.bpel plugin. b4p was reporting a duplicate entry in its build
  path [ build 511, 11/14/07]


* sterling merge: 1) fixed problems recovering alarms 2) include location path
  of invoke that caused process to suspend during recovery in log 3) recovery
  will create the restart process journal item if not present and the feature
  is enabled 4) don't suspend on recovery for ws-rm invokes 5) pulled impl of
  internalRemoveAlarm down from cluster layer since it was the same behavior
  so cluster doesn't need to override anymore [ build 512, 11/15/07]


* Convert plugin.xml <runtime> and <requires> entries to OSGI manifest [ build
  513, 11/20/07]


* 1) added extensions to pdd.xsd and IAeDeploymentSource 2) added
  getDocumentOrSqlNull(Document) to AeSQLObject [ build 514, 11/20/07]


* Moved a method out of deployment schemas and into schema utils. [ build 515,
  11/28/07]


* Fixed a minor whitespace problem in Manifest.mf that Ant's 'jar' task
  doesn't like. [ build 516, 11/30/07]


* Fixes to Manifest.mf and .classpath - starting a cleanup effort to make
  these files more maintainable. [ build 517, 12/3/07]


* Moved the activebpel-policy.xsd from external folder into the
  org.activebpel.rt.bpel.server.deploy folder (with pdd.xsd) and added SAML
  and WSIO policy definitions. Removed creation of SOAPEnvelope from
  AePartnerAddressing now that the WSA serializer uses DOM api unless we
  really need to create a SOAP env. [ build 518, 12/3/07]


* Created constants for "pdd" and namespaces for schemas supported in the
  editor. Fixed a typo. [ build 519, 12/6/07]


* Fixed some NON-NLS warnings. [ build 520, 12/7/07]


* Added JMS transport assertions to activebpel-policy.xsd. Refactored some
  useful wsdl and wsa utility methods out of the Axis invoke handler into a
  new abstract AeSOAPInvokeHandler so they can be used by other handlers
  without introducing dependencies on Axis. [ build 521, 12/11/07]


* 1) Created a new http service. all related classes are in package
  org.activebpel.rt.bpel.server.http. New classes and interfaces:
  AeHttpConfig, AeHttpException, AeHttpRequest, AeHttpResponse,
  AeHttpServiceManager, IAeHttpServiceManager 2) created http method handlers
  that are configurable in package org.activebpel.rt.bpel.server.http.handler
  artifacts are: IAeHttpHandler, AeHttpHandlerBase, AeHttpPostHandler,
  AeHttpGetHandler. 3) Added httpClient jar dependencies to the project
  classpath 4) fixed javadoc typos [ build 522, 12/11/07]


* commons-httpclient-3.1-src.zip was listed in the classpath for the project [
  build 523, 12/11/07]


* Added commons-httpclient-3.1.jar to ae.build.properties [ build 524,
  12/11/07]


* Updated the manifest file to include httpclient jar. [ build 525, 12/13/07]


* Added functionality to the http service: payload delivery for POST and
  Attachment support: classes modified: AeHttpConfig, AeHttpRequest,
  AeHttpResponse, AeHttpPostHandler, AeHttpSendHandlerBase [ build 526,
  12/17/07]


* 1) removed unused import in AeHttpResponse [ build 527, 12/17/07]


* updated activebpel-policy.xsd for retry policy enhancements. [ build 528,
  12/18/07]


* Added AeEngineAdminInvokeHandler custom invoke handler (and support
  de/serializers) which implements SuspendProcess, ResumeProces,
  GetProcessState and GetProcessDetail operations of the ActiveBpelAdmin WSDL.
  [ build 529, 12/19/07]


* Updated pdd schema to support deployment platform as an attribute.
  Suppressing a pdd validation message from being logged as it gets displayed
  in the Problem view anyway. Pdd validation is done more often than before
  (switching between tabs in the pdd editor). [ build 530, 12/20/07]


* Deployment platform attribute in pdd was made optional in the emf model
  (ecore) but was set to required in the pdd schema. Changed the schema to
  make the attribute optional. [ build 531, 12/21/07]


* 1) externalization of ActiveBPEL to messages.properties [ build 532,
  12/26/07]


* 1) Added information to exception in AeDelegatingHandlerFactory 2) Added
  AeHttpResonse and AeHttpServiceManager messages to messages.properties 3)
  Refractored Http support for fault handling and other functionality. classes
  modified: AeHttpConfig (supports Debug entry), AeHttpException (new
  constructor), AeHttpRequest (added username, password and refractored
  exceptions), AeHttpResponse (better exception handling, now consumes
  response for an error response as well, added header support methods),
  AeHttpServiceManager (refractored exception handling), AeHttpGetHandler,
  AeHttpPostHandler and IAeHttpHandler (refractored exception handling) [
  build 533, 12/27/07]


* Added missing entry AeDelegatingHandlerFactory.InvocationError in
  messages.properties [ build 534, 12/27/07]


* Removed an extraneous attribute in the pdd schema. [ build 535, 1/2/08]


* corrected javadoc [ build 536, 1/3/08]


* 1) added HEAD method and fixed getMap() method in AeHttpConfig 2) Added
  statusMessage to AeHttpException 3) Added full Policy support and added
  isHead(0 method to AeHttpRequest 4) Refreactored AeHttpServiceManager :
  Added connection timeout monitor to release stale http connections to the
  connection pool, Manager config from engine now passed to all handlers,
  httpclient is not cached to allow config per delivery from endpoint
  pocicies, added stop() management to close idle connection monitor and
  connection pool manager 5) New http method handlers: AeHttpDeleteHandler,
  AeHttpHeadHandler, AeOptionsHandler, AePutHandler, AeTraceHandler 6)
  Refractored AeGetHandler 7) Refractored AePostHandler to manage paramters
  and payload correctly (they are mutually exclusive with payload priority).
  8) Refractored AeSendHandlerBase to support hierachy of configurations
  engine-config->endpoint-policy for connection->client->method (last member
  of the chain takes precedence) currently supported options are: connection
  timeout, tcp_nodely, basic credentials, preemptive. A new HttpClient object
  is now created for each delivery to support the configuration herarchy. 8)
  Removed extra ';' from IAeHttpHandler. [ build 537, 1/4/08]


* 1) replaced WARNING_Not_Xml to AeHttpResponse.ERROR_NotXml in
  messages.properties 2) fixed bug in addHeaders method of AeHttpRequest 3)
  Changed handling of text/xml in the consume method of AeHttpResponse [ build
  538, 1/7/08]


* Modified init() method in AeEngineFactory to install extension registry when
  extensions are defined in engine config [ build 539, 1/10/08]


* Custom managers now get the engine assigned to them when they are added. [
  build 540, 1/11/08]


* Refactoring of the IAeWSDLProvider & IAeContextWSDLProvider required all
  references to those interfaces to be updated [ build 541, 1/11/08]


* Created a new AeWsioPolicyMapper to handle call properties for engine
  managed correlation and web service timeout policies. Renamed the abstract
  AeSOAPInvokeHandler to AeWSIOInvokeHandler since it is also applicable to
  non-SOAP invokes that need WSDL, addressing, and policy support. Added an
  accessor for policy-driven call properties to the AeInvokeContext so
  different invokers can share them more easily. [ build 542, 1/14/08]


* 1) Refactored AeHttpConfig to setup the default method handler chain and
  provide http client configuration per connection 2) Refactored
  AeHttpRequest: remove HEAD method, genralized parameter config to support
  axis related configurations in preparation to replace AeHTTPsender 3) fixed
  AeHttpResponse to close blob streams and handle xml mime type detection. 4)
  remove unused AeHttpHeader 5) Refactored AeHttpSendHandlerBase configuration
  support 6) AeHttpServiceManager now configures the connection pool and idle
  connection monitor. [ build 543, 1/17/08]


* 1) updated activebpel-policy.xsd to include RESTenabled instead of
  RESTContextPath added HTTPTransportOptions element 2) javadoc spelling and
  formatting [ build 544, 1/22/08]


* moved all http classes to new project org.activebpel.rt.http, remove
  classpath dependencies [ build 545, 1/24/08]


* Updated all references to the expression parsing and validation
  classes/interfaces that were moved from org.activebpel.rt.bpel to
  org.activebpel.rt [ build 546, 1/25/08]


* 1) Remove AeEngineAdminMessageIOBase (refactored to a common base in
  rt.util); 2) Update engine admin custom invoke handler support i/o class to
  use new rt.util bases AeXMLDeserializerBase and AeXMLSerializerBase; 2)
  Added method AeDeployUtil::deployBprWithErrorCheck(Class aResourceClass,
  String aBprName);3) Added method
  AeSQLObject::getDateAsLongOrSqlNull(AeSchemaDateTime aSchemaDateTime) [
  build 547, 2/2/08]


* New MapProcessInitiatorAsHeader policy added to activebpel-policy.xsd and
  AeWsioPolicyMapper. If this policy is present on a partner role, the
  AeWSIOInvokeHandler will add an abx:principal header to the outgoing
  request. The AeProcessInvokeHandler will add an abx:Headers extension to the
  myRole endpoint containing the abx:principal. [ build 548, 2/4/08]


* Added NPE check in getDateAsLongOrSqlNull(AeSchemaDateTime aSchemaDateTime)
  [ build 549, 2/5/08]


* Added generic capability to filter strings in filter fields with wild card
  (*) through sql queries. Adopted that capability for process name searches
  in console filters. [ build 550, 2/7/08]


* 1) getFunctionValidatorFactory method was introduced to the AeEngineFactory
  2)updated references to AeAbstractFunctionValidatorFactory to now get the
  factory from the engine config. [ build 551, 2/12/08]

ActiveBPEL engine v4.1 0 (20070925) 
 
org.activebpel.rt

* 1) Moved WSDL namespace decl to IAeConstants 2) document loading and
  validaiton now supports schemas as input streams and strings in addition to
  castor schema objects 3) added a closer for jar util reader [ build 420,
  6/29/07]


* Added "joinStrings" to AeUtil which will take a collection of strings and
  concat them together using a given separator. [ build 421, 7/5/07]


* 1) overload of AeXmlUtil.doTransform to accept a URIResolver to handle
  imports [ build 422, 7/5/07]


* check for null prefix in AeXmlUtil.encodeQName [ build 423, 7/11/07]


* Renamed getText() with xpath variant to selectText(). Spaces-in-location bug
  fix in bpel extended wsdl def (use AeUTF8Util.decode() when adding schema
  location to list of schema refs in buildSchemaMap()) [ build 424, 7/11/07]


* 1) added features map to AeXMLParserBase. Enables callers to turn on vendor
  specific features for SAXFactory or DocumentBuilderFactory. Added mainly for
  test cases or situations where the code is aware of the provider. [ build
  425, 7/12/07]


* Refactored xpath-related util methods out of AeXmlUtil and into a new class
  called AeXPathUtil. [ build 426, 7/12/07]


* Renamed joinStrings() to joinToStringObjects() to make the method more
  generic. [ build 427, 7/18/07]


* Fixed problem where the xml formatter for html pages was not escaping
  ampersands. [ build 428, 7/26/07]


* refractored mime headers to attributes, added getBigNumber utility method [
  build 429, 7/26/07]


* Added new serializers and deserializers to handle Policy and PolicyReference
  WSDL extensions to support WS-Policy Attachment spec. AeBPELExtendedWSDLDef
  now supports locating policy by reference URI from the definition and it's
  imports. [ build 430, 7/27/07]


* Moved keystore utility methods out of AeCryptoUtil in the server project
  into AeJCEUtil so they can be more easily shared with standalone clients [
  build 431, 8/2/07]


* 1) added AeConfiguration.getIntEntryByPath(String,defaultValue) as a
  convenience method for getting an int from the engine config [ build 432,
  8/6/07]


* 1) added support for anytype element to sample data generation [ build 433,
  8/9/07]


* refactored reading/writing of WSDL extensions. Was previously specific to
  extensions for BPEL (property, property alias, partner link type) but the
  addition of WS-Policy extensions which don't vary based on BPEL namespace
  required some refactoring. [ build 434, 8/13/07]


* Updated AeCreateSampleMessage to check for NPE (and report appropriate
  errors) if element decl or xml type cannot be located [ build 435, 8/13/07]


* Added default Content-Id for inline attachments to AeMimeUtil. [ build 436,
  8/16/07]


* Removed the <!DOCTYPE > element from ws-addressing-2005-08.xsd so we do not
  always go out to the internet to resolve the xml schema dtd. [ build 437,
  8/16/07]


* 1) added new variant of createConfigSpecificClass() that takes an array of
  args [ build 438, 8/16/07]


* 1) added selectSingleObject() to xpath util - returns object rather than
  Node 2) added addDuration() to AeSchemaDateTime - this allows us to add a
  duration onto a dateTime [ build 439, 8/17/07]


* Needed to expose, for reuse, the private static Strings PROJECT_RELATIVE_URI
  and PROJECT_PATH_SEPARATOR. [ build 440, 8/21/07]


* 1) AeMimeUtil supports more common mime types 2) AeMimeUtil now supports
  windows filenames with spaces [ build 441, 9/7/07]


* Updated AeXmlUtil::doTransform(..) to check to see if the XSL transform
  factory (class name) is based on weblogic impl., and if so, to use the
  factory impl. from bundled xalan.jar - as work around for defect 3112 [
  build 442, 9/10/07]


* Updated bpel extended wsdl def - when created a bpel extended wsdl def with
  only a schema, we weren't refreshing the schema refs (so the mSchemaDefs had
  a list of Schema objects, but mSchemaReferences was still empty). [ build
  443, 9/12/07]


* Added a static boolean to AeUtil which indicated if the current execution
  platform is Unix. Also added the helper method isUrlLocation. [ build 444,
  9/13/07]

org.activebpel.rt.axis.bpel

* 1) added check for anyType in AeRPCEncodedSerializer to ensure that we
  serialize the correct xsi:type for anyType. [ build 208, 7/18/07]


* support new 4.1 API calls addAttachment, removeAttachments. NOTE:
  addAttachment overides the axis generated skeleton code to retrieve
  attachments directly from the axis MessageContext [ build 209, 7/26/07]


* Added policy reference resolution to the AeInvokeHandler. [ build 210,
  7/27/07]


* Cahnged AeActiveBpelAdminImpl and AeActiveBpelAdminSkeleton to support WS-I
  Basic Profile 1.1. in ActiveBpelAdmin.wsdl [ build 211, 8/1/07]


* Moved AeAxisEngineConfiguration up to the org.activebpel.rt.axis project. [
  build 212, 8/2/07]


* 1) refactored the admin interfaces to remove attachment object from
  signature [ build 213, 8/9/07]


* Updated the AeRPCReceiveHandler to select the first RPC element, rather than
  first child element to be compatible with new apache xml security library
  that preserves the reference elements after decryption. [ build 214,
  8/13/07]


* AeRPCReceiveHandler cannot assume that the first body element within
  envelope is an RPCElement. This was due to a change in the security library
  where ws-security tokens are manifested as multi-refs within the envelope.
  Existing code was handling the input properly but not the output.
  [ build 215, 8/30/07]


* Fixed problem where EventHandler for engine events was defaulting to RPC for
  externally developed event listeners. [ build 216, 9/14/07]

org.activebpel.rt.war

* Fixed the color code for enableColor class in ae.css [ build 10, 8/13/07]


* 1) Added aux build to build the base tag classes to a lib named
  ae_wartags.jar; 2) Updated aetags.tld DTD to use
  http://java.sun.com/dtd/web-jsptaglibrary_1_2.dtd; 3) Added method
  getBean(string beanName) to AeAbstractBeanPropertyTag [ build 11, 8/13/07]


* Updated css stylesheet for monitoring warning and error styles. [ build 12,
  8/14/07]


* Updated ae.build.properties to run aux.post.build to build ae_wartags.jar [
  build 13, 8/14/07]


* Updated AeAbstractBeanPropertyTag::getPropertyFromBean(...) to return
  toString version if the property and return type is not specified; and to
  return bean object if the property is not specified but the return type is.
  [ build 14, 9/5/07]


* Added styles to change background color when setting/resetting readonly mode
  of text fields [ build 7, 7/31/07]


* Fixed a problem where the resource bundle pointed to the wrong
  message.propeties location as a result of refactoring of the tag library.
  Also changed the getResource call in the base tag to be public so it could
  be used elsewhere. [ build 8, 8/7/07]


* Updated logo image for ActiveBPEL engine to reflect the new registered
  status of ActiveBPEL trademark. [ build 9, 8/8/07]

org.activebpel.wsio

* Added a null invoke handler for use when recovering one-way invokes. [ build
  35, 7/26/07]

org.activebpel.rt.tamino

* 1) added non-XML (binary) file support to tamino storage layer 2)
  implemented Tamino attachment storage provider [ build 63, 6/29/07]


* 1) Tamino query builder uses the new aeutil method to join together FLWOR
  and clauses 2) added cascading delete support for attachments [ build 64,
  7/5/07]


* Some refactoring, removed a null check that was not needed. [ build 65,
  7/18/07]


* added removeAttachment support [ build 66, 7/26/07]


* 1) created delegate for tamino data source that reports the amount of time
  needed to acquire a db connection 2) added destroy() to IAeTaminoDataSource,
  side effect from offline test framework where the source is destroyed and
  recreated in between test runs. [ build 67, 8/13/07]


* Refactored Tamino layer - introduced a new 'xmldb' package which contains
  most of the old Tamino code. Tamino is now a thin layer on top of xmldb
  which provides only the Tamino specific code. [ build 68, 8/16/07]


* Fixed a problem with Tamino upgrades. Previous refactoring had broken it. [
  build 69, 9/12/07]

org.activebpel.rt.exist

* Initial add of the exist project - this project, like the Tamino project,
  implements a persistence provider - in this case the open source eXist
  database. This project will initially be used for offline testing, since
  eXist can be run in embedded mode (therefore offline tests can be run in
  persistence mode, and we can delete and recreate the database for each
  test). It is possible that the eXist persistence layer may have some value
  beyond testing, which is why it is not a test.org.* project. [ build 2,
  7/24/07]


* Retrying due to build failure... [ build 3, 7/24/07]


* Added new attachment storage provider method to relevant exist impl class. [
  build 4, 7/27/07]


* Major refactoring of the eXist project. This project now "extends" the xmldb
  base project, and only provides those classes that are specific to the eXist
  database. [ build 5, 8/16/07]


* Created an eXist implementation of our Enterprise persistence layer. This is
  a thin implementation based on the com..xmldb foundation. [ build 6,
  8/16/07]


* Changes to exist classpath - jre 1.4 compatibility [ build 7, 8/17/07]


* Improved eXist connection to use different counters for each doc type - this
  way process IDs will be sequential and easier to debug. Added a util class
  that can be used to query an eXist database (useful if an offline
  persistence test fails). Added a flag to the eXist data source to control
  whether to initialize the DB (clear it out) when the data source is created.
  [ build 8, 8/23/07]


* Implemented attachment storage methods for eXist database impl. Attachment
  persistence can now be tested in the offline engine. [ build 9, 8/31/07]

ddl.org.activebpel

* Added Attachment support to Tamino schema. [ build 46, 6/29/07]


* Changes to Tamino upgraders due to refactorings. [ build 47, 8/16/07]

org.activebpel.rt.axis

* Moved AeAxisEngineConfiguration out of the org.activebpel.rt.axis.bpel into
  this project to make it easier to share with standalone axis clients. [
  build 66, 8/2/07]


* 1) Updated AeCatalogServlet to return appropriate http messages (e.g 404,
  500) instead of simple 'no content' message; updated servlet response
  content type to utf-8 [ build 67, 8/13/07]

org.activebpel.rt.bpeladmin.war

* Add Work Manager Threads For Alarms Max: field to engine configuration page.
  [ build 224, 7/2/07]


* Fixed problem where delete text on config page was not externalized. Also
  added jquery.js library to scripts folder for use in console pages. [ build
  225, 8/7/07]


* Updated the ActiveBPEL trademark to registered status. [ build 226, 8/8/07]


* Added method on engine status bean to get monitor status of engine for use
  in JSP [ build 227, 8/9/07]


* Added add/remove attachments to Bpeladmin console. Add a new popup window to
  enter attachment information, added server side admin support. [ build 228,
  8/13/07]


* Fixed problem where link to Help page was broken for tenant deployments [
  build 229, 8/14/07]


* Fixed build issue due to missing commons-fileupload-1.0.jar in build path [
  build 230, 8/14/07]


* Classpath update. [ build 231, 8/16/07]


* 1) fix for defect 3087 2) fixed IE quirk that did not dectet a change in the
  location field 3) automatically add the Content-Location attribute for a
  location 4) added missing message.properties message from previous check in
  5) when a duplicate attribute name is entered it overides the existing value
  instead of creating a duplcate property [ build 232, 8/22/07]


* 1) include processview_attachment.jsp only when the property
  tagName=Variable fixes defect 3139 2) rearranged property edit in
  processview_attachment_add.jsp (fix for defect 3140) 3) added delete
  confirmation for attachment attribute in ae_attachment_update.js (fix defect
  3141) 4) added call to register when property edit is cancelled i
  ae_attachment_update.js(fix for defect 3142) [ build 233, 8/24/07]


* Updated AeProcessDefToWebStateModelVisitor::visit(AeActivityForEachDef aDef)
  to build "single instance" of the forEach container if the forEach activity
  was never run - this way, the forEach container children are still rendered
  (instead of displaying an empty container). [ build 234, 9/5/07]


* Updated AeProcessDefToWebStateModelVisitor::visit(AeActivityForEachDef) to
  handle case for 1 interation [ build 235, 9/7/07]


* fix for defect 3200 - AeNewAttachmentUploader now uses AeMimeUtils to
  resolve an uploaded file mime type and does not rely on commons-upload
  library. [ build 236, 9/7/07]


* Updated AeProcessDefToWebStateModelVisitor::setState(..) method to only set
  default (in-active) state iff the bpel object is an non-actity type object
  (i.e. skip variables, partnerlinks etc.). Related defect - 3198. [ build
  237, 9/10/07]


* Fixed problem with help link broken for processview pages since they are
  located under a nested directory path from main level [ build 238, 9/11/07]


* rename to AeNotUnderstoodExtensionActivityDef [ build 239, 9/11/07]


* Added css .filebrowse entry to control the width of the attachment file
  location field in the admin console popup window
  processview_attachment_add.jsp [ build 240, 9/12/07]


* avoid setting state on bpel object if its already been set [ build 241,
  9/13/07]


* Updated AeProcessDefToWebStateModelVisitor to not build 'current state'
  property for correlationSet, correlationSets and copy object (since they do
  not have state). Related defect 3198. [ build 242, 9/17/07]

org.activebpel.rt.bpel

* (1), added function validator for each attachment function (13 in total) for
  static analysis; (2) added function validators for standard bpel functions:
  getVaraibleData, getVaraibleProperty, getLinkStatus, and get doXSLTansform;
  (3), updated base expression validator to use function validator factory,
  updated validation context to get/set function factory; (4), Added function
  name to some function implementation for consistency. (5), Updated
  AeAbstractFunctionValidatorFactory to include all attachment validator and
  validators for standard bpel functions for both bpws and wsbpel. [ build
  619, 6/29/07]


* Fix a bundle key message for getMyRolePprperty function. [ build 620,
  7/3/07]


* 1) added URIResolver to AeDoXslTransformFunction so includes/imports are
  resolved using the resource catalog 2) fixed message.properties for
  AeAbstractExpressionRunner.ExpressionFailedError - pattern had wrong offsets
  [ build 621, 7/5/07]


* merged from branch: 1) added
  IAeBusinessProcessEngine.getCustomManagerNames() 2) made non-callback
  variants of queueInvokeData and queueInvokeFault final in
  AeBusinessProcessEngine. Subclasses should override variant that takes
  callback arg to change behavior 3) fixed toString() formatting in
  AePartnerLinkOpImplKey [ build 622, 7/9/07]


* Refactored xpath-related util methods out of AeXmlUtil and into a new class
  called AeXPathUtil. [ build 623, 7/12/07]


* Queue receive data change - if the message is one-way and a reply receiver
  is included in the context, reply immediately to it. [ build 624, 7/24/07]


* Fixed issue where cloning and restoring of variables was not handling
  attachments correctly. [ build 625, 7/26/07]


* Add engine support for adding and removing attachments to an existing
  process during remote debug or from the BpelAdmin console. [ build 626,
  7/26/07]


* New AeWSDLPolicyHelper with utility methods to help resolve and merge the
  policy references for the various WSDL Subjects as defined in the WS-Policy
  Attachment spec for WSDL 1.1. [ build 627, 7/27/07]


* Added new Monitor Listener infrastructure in engine to allow for
  subcriptions to monitor events. Added monitor event signaling for selected
  monitor properties. [ build 628, 7/30/07]


* Change signature of
  AeBusinessProcessEngine#dispatchReceiveData(AeMessageReceiver,
  AeInboundReceive, long, boolean) to dispatchReceiveData(long aProcessId, int
  aLocationId, AeInboundReceive, long, boolean) since we use the message
  receiver only to get the process id and location id. [ build 629, 7/31/07]


* 1) removed ack/nack callback from matchesInvoke sig, wasn't being used 2)
  message and variable deserializer uses XMLType for deserialization instead
  of QName. This handles derived simple types better. (Defect 3016) [ build
  630, 8/1/07]


* 1) added IAeengineConfiguration.getInEntryByPath(String,int) as a
  convenience method for getting int from config [ build 631, 8/6/07]


* Added ability to get/set engine monitoring status on engine. [ build 632,
  8/9/07]


* 1) bpws to ws-bpel converters were removing variable defs for <catch> and
  <onEvent> since they are inlined. This was causing a problem if there were
  multiple references to that variable in the process. Changed to leave the
  old variable in place and let static analysis report if it's not used. 2)
  removed AeVariablesDef.removeVariableDef(def) since it was no longer being
  called. [ build 633, 8/13/07]


* 1) New expression functions AeCreateAttachmentFunction and
  AeBase64EncodeFunction. 2) Added static validations
  'AeCreateAttachmentFunctionValidator and AeBase64EncodeFunctionValidator.
  3)Added functions to AeExtensionFunctionContext [ build 634, 8/16/07]


* 1) Added some error logging to wsi invoke handler base 2) Added a type
  conversion step to the to-query variable context so that variable values are
  properly converted to java objects compatible with Jaxen [ build 635,
  8/29/07]


* AeBase64EncodeFunctionValidator now allows an expression parameter as well
  as String literal [ build 636, 8/29/07]


* 1) organized function exception messages under package
  org.activebpel.rt.bpel.impl.function. 2) Added EXPECT_STRING_ARGUMENT and
  EXPECT_POSITIVE_INT_ARGUMENT exception messages. 3)Add new optional fourth
  argument to createAttachment expression funtion to allow externally defined
  Content-Id 5) moved expression function name to AeAbstractBpelFuntion, added
  constructor that receives the FUNCTION_NAME together with getFunctionName ,
  setFunctionName methods. 6) created getStringArg and getPositiveIntArg
  methods in AeAbstractBpel Function that validate expression function
  argument types. 6) Refractored all extpression functions to use
  getStringArg, getPositiveIntArg where applicable. 7) Refractored all
  expression functions (except test functions) to support FUNCTION_NAME by
  replacing the constructor to super(FUNCTION_NAME) [ build 637, 9/4/07]


* Updated AeWSIInvokeHandlerBase::invokeOperation() not to log
  InvocationTargetException to the console. (the target error is rethrown as a
  fault anyway) [ build 638, 9/7/07]


* 1) renamed AeUnknownExtensionActivityDef to
  AeNotUnderstoodExtensionActivityDef and added base class and impl for
  understood extension. This had an impact on a number of visitor interfaces
  but it's just a simple rename. I didn't add any logic yet for understood
  extensions [ build 639, 9/11/07]


* 1) change to AeRestoreCompInfoVisitor in order to read scope locations by
  path instead of id in order to fix issue with restoring previously executed
  onEvent scope instances [ build 640, 9/19/07]

org.activebpel.rt.bpeladmin.help.war

* ActiveBPEL Engine (in Designer product) ready for 4.1 launch [ build 20,
  9/11/07]

org.activebpel.rt.xmldb

* Created new project that is the base for all XML database implementations
  (Tamino, eXist currently). [ build 1, 8/16/07]


* Created a base project for all xml database implementations. This base
  project is the foundation that any implementation of our Enterprise
  persistence layer which is based on an XML database (Tamino, eXist) can use.
  [ build 2, 8/16/07]


* Fixed a problem where the order by was being added after the return in Query
  Builders (no one was using order by until now). Added a query response
  result handler that simply returns the list of Elements as-is (for
  debugging). [ build 3, 8/23/07]


* Implementation of new method (removeAttachment). [ build 4, 8/27/07]


* Fixed a bug in the xmldb project - a connection was not being used properly
  in storeAttachment(). [ build 5, 9/12/07]

org.activebpel.rt.axis.bpel.web

* On the Admin console's engine configuration panel for the in-memory
  activeBPEL server, the "Replace existing resources on deployment" checkBox
  is now set to be uncheck by default. This was done for consistency with the
  designer and other engine flavors. This change was made in
  aeEngineConfig-ActiveBPEL.xml [ build 77, 8/28/07]

org.activebpel.rt.bpel.ext.expr

* Remove checkBpelFunctionUsage() from Xquery expression validator for both
  bpws and wsbpel. Method function is included in other updates. [ build 28,
  6/29/07]


* Added support in the Saxon -> Java expression result handler for text
  results. If the XQuery is something like "/path/to/text()", then the typed
  expression result was not properly handling the result. [ build 29, 8/21/07]

org.activebpel.rt.axis.bpel.admin

* New API version 4.1 interface adds addAttachment and removeAttachments
  methods. IAeActiveBpelAdmin now extends IAeAxisActiveBpelAdmin that is now
  the interface generated by axis from the ActiveBpelAdmin.wsdl, Added new
  generated classes for the data types supporting these new methods. [ build
  4, 7/26/07]


* 1) merged IAeAxisActiveBpelAdmin back into IAeActiveBpelAdmin [ build 5,
  8/9/07]

org.activebpel.rt.bpel.server

* Removed sql attachment storage provider instance from sql queue storage
  provider - it was not being used. [ build 478, 6/29/07]


* Updated AeDeploymentValidator to add functionValidatorFacotry to validation
  context. [ build 479, 6/29/07]


* 1) small change to AeProcessDeployment to simplify subclassing in test
  project [ build 480, 7/5/07]


* merged from branch: 1) introduced AeAbstractServerEngine as base class for
  AeBpelEngine and AeRecoveryEngine. Processes with doXslTransform() calls
  with resources within the catalog can now be recovered. 2) override
  queueInvokeData and queueInvokeFault in AeRecoveryEngine in order to remove
  corresponding invokes that were recovered. This avoids having to execute the
  invoke again if its data was already dispatched to the recovered process 3)
  added removeRecoveredItem(int) to IAeRecoveredItemsSet to enable removal of
  item by locationId 4) AeRecoveryEngineFactory now passes the customManagers
  map into the recovery engine. 5) AeRecoveryQueueManager overrides
  removeMessageReceiversInGroup in order to remove a previously recovered
  message receiver. [ build 481, 7/9/07]


* Refactored xpath-related util methods out of AeXmlUtil and into a new class
  called AeXPathUtil. [ build 482, 7/12/07]


* Fixed a recovery bug where previously queued message and alarm receivers
  were not present in the recovery queue manager so recovering a correlated
  inbound receive would result in an unmatched request. [ build 483, 7/13/07]


* Fixed a problem with recovering one-way invokes. If the server crashes after
  transmitting the one-way invoke but before journalling the empty invoke data
  response, then the invoke cannot be recovered. I changed one-way invokes to
  be immediately executed during recovery if they were in an 'executing' state
  AND the 'journal_invoke_transmitted' journal entry existed (in other words,
  we journalled the fact that the invoke was already transmitted). Invoke Data
  Journal Entries are now no longer dispatched during recovery due to the
  previous change. [ build 484, 7/26/07]


* Server side support for admin web service API version 4.2 that includes
  add/remove variable attachments. [ build 485, 7/26/07]


* Pervious checkin had a type. vErsiob is 4.1 not 4,2. Server side support for
  admin web service API version 4.2 that includes add/remove variable
  attachments. [ build 486, 7/26/07]


* The web service deployer now resolves policy references for myRole endpoints
  prior to deployment. [ build 487, 7/27/07]


* Added monitor notification event for process statistics. [ build 488,
  7/30/07]


* Implement Req186 - SC - Custom WorkManager Implementations: (1) add
  IAeWorkManagerFactory interface and a default implementation,
  AeDefaultWorkManagerFactory, that implements what used to be done in
  AeEngineFactory (JNDI lookup and fallback to default AeWorkManager); (2) add
  IAeInputMessageWork and IAeInputMessageWorkManager interfaces and a default
  implementation, AeDefaultInputMessageWorkManager; (3) modify
  AeEngineFactory#initializeWorkManager to construct and use work manager
  factory from class name specified in aeEngineConfig.xml; (4) add
  scheduleInputMessageWork(long aProcessId, IAeInputMessageWork) to
  AeEngineFactory; (5) modify AeDispatchReceiveRunnableHelper and
  AeProcessExecutionRunnableHelper in AeBpelEngine to be serializable and
  modify AeBpelEngine to dispatch these two kinds of work to
  AeEngineFactory.scheduleInputMessageWork(); (6) fix
  AeBpelEngine#doMultiStartCreateProcessWithMessage() to return process id for
  the non-create message, because this process id is used when reporting
  problems when a synchronous web service call times out. [ build 489,
  7/31/07]


* Added WS-I Basic Profile 1.1 binding and attachment message part to
  ActiveBpelAdmin.wsdl [ build 490, 8/1/07]


* Moved keystore utility methods out of AeCryptoUtil and into
  org.activebpel.rt.util.AeJCEUtil to make them easier to share with
  standalone clients. [ build 491, 8/2/07]


* Added method to get monitor status on engine admin interface [ build 492,
  8/9/07]


* implemented monitor event for time required to establish a database
  connection [ build 493, 8/13/07]


* Restore AeRecoveredAddInvokeItem.java to HEAD using command-line CVS. [
  build 494, 8/14/07]


* Added monitoring for work manager work start delay. [ build 495, 8/14/07]


* Modified engine detail to include MonitorStatus item needed during roll up
  of cluster monitor status [ build 496, 8/15/07]


* Fixed problem where we attempted to send work manager monitor event prior to
  engine startup. [ build 497, 8/16/07]


* Minor refactorings. [ build 498, 8/16/07]


* 1) added IAeDeploymentProvider.findService that looks for a deployed service
  with a given port type of operation implemented [ build 499, 9/2/07]


* 1) changed catch of SQLException in AeSQLTransaction to Throwable since it
  won't be a SQLException if its coming from a Proxy 2) left comment about
  double-check style syncrhonization in AeTransactionManager, will refactor
  later [ build 500, 9/7/07]


* Added isXslEntry() to AeResourceKey [ build 501, 9/12/07]


* Made some alterations to AeStorageConfig to address possible race conditions
  (since the DB statements are being loaded lazily, and we could get multiple
  threads trying to load them at once). [ build 502, 9/21/07]

ActiveBPEL engine v4.0 0 (20070628) 
 
org.activebpel.rt

* 1) Added the wsdl 1.1 schema to the standard schemas 2) added setAttribute()
  to AeXmlUtil 3) renamed setQNameAttribute to setAttributeQName 4) Cleaned up
  the .classpath file a bit [ build 369, 4/3/07]


* 1) added "xml" to AeSampleDataPreferences as preferred prefix for xml
  namespace [ build 370, 4/4/07]


* Add method getMapEntry(String aName, boolean aCreateFlag, Map aConfigEntry)
  to AeConfiguration to create an entry if it does not exist in the given base
  config Map. [ build 371, 4/12/07]


* Added getQName(Element) (similary to getText(Element)) to get an encoded
  QName from an element. [ build 372, 4/13/07]


* Update AeConfiguration method visibility for test in com.activee email
  service test. [ build 373, 4/19/07]


* Allow wsdl to reference schema through direct imported wsdl's schemas. [
  build 374, 4/23/07]


* attachment support [ build 375, 4/23/07]


* added IAeAttachmentContainer to AeEmptyMessage [ build 376, 4/24/07]


* eliminated null attachment containers [ build 377, 4/25/07]


* removed creation of AeMessageData.mAttachmentContainer in declaration since
  there's lazy instantiation in getter [ build 378, 4/25/07]


* In AeUtil added helper method notNullOrEmpty for QName arguments. [ build
  379, 4/26/07]


* Added a toSet() method to AeUtil that converts from a String array to a Set.
  [ build 380, 4/30/07]


* (1) Remove AeAttachmentGroup. (2) Change AeAttachmentContainer#set(int,
  Object) to not remove an object from the list--the decision instead is to
  set or not set the specified entry. (3) Remove obsolete members from
  IAeAttachmentContainer and IAeAttachmentItem. [ build 381, 5/1/07]


* 1) added capitalizeWord() to AeUtil - this method capitalizes the first
  letter in a String - useful for JavaBeansy type operations 2) Added some
  granularity to the IAeSampleDataPreferences in the form of two new interface
  methods: isCreateOptionalAttribute(QName) and isCreateOptionalElement(QName)
  [ build 382, 5/3/07]


* 1) AeXmlUtil.getElementType(QName) wasn't handling null namespace for
  element [ build 383, 5/4/07]


* (1) Add utility routines getTempDirectory(), listTempFiles(), and
  createTempFile(InputStream, String, String) to AeUtil. (2) Refactor
  AeBlobInputStream to use AeUtil#createTempFile(InputStream, String, String).
  (3) Add constructors to AeBlobInputStream to open a stream on a pre-existing
  file with or without automatically deleting the file upon stream close. (4)
  Remove IAeBlobInputStream interface. (5) Add synchObject() methods to
  AeLongMap and AeTypedSet to allow synchronization on the underlying
  collection (analogous to .NET collections). (6) Remove
  IAeAttachmentItem#setJournalToken(). (7) Rename
  IAeAttachmentItem#getJournalToken() to getAttachmentId(), because there is
  no journaling in in-memory configurations. [ build 384, 5/8/07]


* 1) refactored getDeclaredNamespaces in aexmlutil 2) added granularity to the
  sample data preferences, allowing getNumberOfRepeating* on elements and
  attributes based on QName [ build 385, 5/9/07]


* Fixed attachments for variables of type element, improced unit tests [ build
  386, 5/9/07]


* Added getText(Node, XPathStr, NSMap) method to AeXmlUtil to return node text
  identified by the xpath expression. [ build 387, 5/9/07]


* Added a File c'tor to the jar reader util. [ build 388, 5/10/07]


* Moved AeSOAPElementUtil utility class to this project from
  org.activebpel.rt.bpel to minimize required libs needed by
  TenantConfigurator [ build 389, 5/11/07]


* Added an addText() method to aexmlutil which creates a child text node of a
  given element. [ build 390, 5/15/07]


* Added AeXmlUtil::isNil(...) method to return true if element is xsi:Nil or
  null. [ build 391, 5/15/07]


* Added ws-bpel_serviceref.xsd to the standard schemas. Fixed some location
  problems with existing standard schema entries. [ build 392, 5/17/07]


* Added IAeAttachmentProvider interface [ build 393, 5/20/07]


* New class util AeMimeUtil with method to support handling of mime headers
  and filename derived from these headers [ build 394, 5/21/07]


* Small refactor: removed redundant method createChildElementWithText() - it
  duplicates the functionality of addElementNS() in the same class. [ build
  395, 5/23/07]


* Modified AeMimeUtil to add support of obtaining mime types from a filename
  spec. [ build 396, 5/23/07]


* (1) Modify AeEmptyMessage to clone its attachment container; (2) Modify
  AeMessageData to create a non-null attachment container only if the original
  has attachments; (3) Extend AeBlobInputStream from FileInputStream instead
  of FilterInputStream. [ build 397, 5/23/07]


* 1) added util method to AeXmlUtil for doing xsl transform [ build 398,
  5/23/07]


* Update AeAttachmentContainer: (1) extract body of add() to new method
  addIfAbsent(); (2) modify addAll() to call addIfAbsent() rather than add(),
  so that AeVariable$AeVariableAttachmentContainer#addAll() (next check-in)
  doesn't needlessly increment the version number for each new attachment; (3)
  add override of add(int, Object) for completeness. [ build 399, 5/24/07]


* 1) Added getExtension(aFilename) and splitFilePathAndName(String
  aAbsoluteFilePath) util methods to AeFileUtil.; 2) Updated AeMimeUtil to add
  overloaded method getContentType(aFilename,aDefaultType), and new method
  getContentTypeFromExtension(aExtension,aDefaultType) [ build 400, 5/24/07]


* Added output format property to doTransform() for xslt transformation. [
  build 401, 6/1/07]


* added soap1-1 xsd to standardSchemas.xml [ build 402, 6/4/07]


* Updated AeMimeUtil to add support for Content-Length header [ build 403,
  6/5/07]


* Refactor the code to move the messages from org.activebpel.rt to
  org.activebpel.rt.bpel projects. [ build 404, 6/7/07]


* 1) renamed/repackaged AevXmlGeneratorUtil to AeCastorSampleDataGenerator 2)
  added util AeCreateSampleMessage that creates sample data for a WSDL Message
  [ build 405, 6/7/07]


* Fixed issue where logic added to handle import of schemas from imported wsdl
  was not setting the input source location from the imported wsdl. [ build
  406, 6/8/07]


* Added support for unique Content-Id's for attachments by appending a '-#' to
  duplicate Content_id's, #-is incremented to support multiple duplicates [
  build 407, 6/8/07]


* Fixed problem with attachment container, which was preventing simulation of
  processes with attachments [ build 408, 6/11/07]


* Split out pure JCE functionality from AeCryptoUtil into AeJCEUtil so
  standalone clients can encrypt and decrypt without introducing dependencies
  on server-side classes. [ build 409, 6/12/07]


* 1) Fixed a bug with XML sample data generation where an extraneous empty
  element was being produced when generating a recursive element sample. 2)
  Modified XML sample data generation logic to not produce attributes of XSD
  type ID or IDREF. [ build 410, 6/12/07]


* Removed method serializeOtherHeaders from AeMimeUtil, as it is no longer
  used. [ build 411, 6/14/07]


* (1) Added method copyEntries(Map, Map) to AeConfiguration util to do a deep
  copy of config entry maps.; (2) Addef method toString(COllection, tokenChar)
  to AeUtils - returns a tokem delimited string [ build 412, 6/14/07]


* Added AE_SIZE_MIME to support attachment content length, Add common mime
  type <-> ext support [ build 413, 6/15/07]


* added some convenient xpath selection methods to AeXmlUtil [ build 414,
  6/15/07]


* The CreateSampleMessage class now produces data for simple types too. Added
  a context and a map of namespace decls to the SampleDataTarget. [ build 415,
  6/18/07]


* Moved code that matches a soap fault to a wsdl fault def from the axis
  invoke handler to a utility class called AeFaultMatcher so it can be shared
  with non-axis invoke handlers. [ build 416, 6/18/07]


* 1) added ability to get/set entry in AeConfiguration by path. This
  functionality existed in AeDiffConfiguration, pulled up into the base class
  [ build 417, 6/18/07]


* Fixed a defect with XML sample data generation wizard where the repeating
  elements preference was not working for Abstract Types and Elements. [ build
  418, 6/18/07]

org.activebpel.rt.axis.bpel

* attachment support [ build 199, 4/23/07]


* recheckin due to build failure [ build 200, 4/23/07]


* fixed ae.build.properties [ build 201, 4/23/07]


* Do over. Committed files from a different project.
  org.activebpel.rt.bpel.impl.AeDataConvert methods no longer throw
  AeAttachmentException, so we can simplify exception handling. [ build 202,
  5/1/07]


* Minor Javadoc cleanup. [ build 203, 5/23/07]


* Fixed Content-Id from being overriden by axis default, Check for valid
  attachment item type generates error: AeSOAPInvoker.ERROR_1=Invalid
  Attachment object. Expecting IAeWebServiceAttachmentItem. [ build 204,
  6/7/07]


* removed unnecessary import [ build 205, 6/7/07]


* Moved code that matches a soap fault to a wsdl fault def from the axis
  invoke handler to a utility class called AeFaultMatcher so it can be shared
  with non-axis invoke handlers. [ build 206, 6/18/07]

org.activebpel.rt.war

* New project for base classes, tags, and resources for ActiveBPEL console web
  apps. Contains the Active Endpoints tags library, console tab support,
  aetags.tld, ae.css, clear.gif, favicon.ico, and logo.gif. Unpack and repack
  with new resources to build web apps on top of the base support. [ build 2,
  4/24/07]


* Add qname.jar to ae.build.properties [ build 3, 4/24/07]


* Update aetags.tld. I checked in an older, obsolete version of aetags.tld
  when I created this project. [ build 4, 4/26/07]


* Enhanced AeIfPropertyMatches tag to support property compare in two beans [
  build 5, 4/27/07]


* Updated AeAbstractBeanPropertyTag::getPropertyFromBean(..) to return bean's
  toString() value if the property name is not specified. Useful if the bean
  itself represents string. [ build 6, 5/9/07]

org.activebpel.wsio

* null check in AeMessageContext::setServiceName() to prevent the exception
  from being thrown if the param to the setter is null [ build 31, 4/4/07]


* WSIO Attachment support this includes extensions to the webservice message
  data, attachment exception, and a webservice attachment item
  AeWebServiceAttachment [ build 32, 4/23/07]


* (1) Remove AeWsAttachmentException. (2) Remove
  IAeWebServiceMessageData#setAttachments(). (3) Remove throws
  AeWsAttachmentException from IAeInvoke#getInputMessageData(). [ build 33,
  5/1/07]


* Remove unnecessary no-arg constructor from AeWebServiceAttachment. [ build
  34, 5/23/07]

org.activebpel.rt.tamino

* Changes due to storage provider layer refactorings. [ build 58, 4/3/07]


* satisfy interfaces with attachment support [ build 59, 4/23/07]


* Propagate change to IAeQueueStorageProvider interface as part of moving
  associateProcess() call from AeQueueStorageProvider#journalInboundReceive()
  to AeQueueStorage#consumeMessageReceiverInternal(). [ build 60, 5/8/07]


* Remove associateAttachments() from IAeQueueStorageProvider and its
  implementations. [ build 61, 5/23/07]


* Changed base tamino code to make it easier to extend basic filtering for
  alaram and receive queue lists. [ build 62, 6/8/07]


ddl.org.activebpel

* Added a Tamino Schema merging XSLT stylesheet. This stylesheet will merge
  two Tamino schemas together. For example, this stylesheet is used to deploy
  the ActiveBPEL For People Tamino schema - it does this by taking the
  ActiveBPEL Open Source or ActiveBPEL Enterprise base Tamino DDL and merging
  in the ActiveBPEL for People DDL (which contains only the incremental
  element and doctype declarations needed for workflow). The resulting DDL is
  then deployed. [ build 42, 4/3/07]


* attachment support tables added for all SQL database DDLs database version
  update to 2.1.0.4 [ build 43, 4/25/07]


* Fix defect 2683, "The Tables AeProcessAttachement and AeProcess are not
  being created when you run the DB2 ddl." (I think it's actually
  AeProcessAttachment and AeAttachment.) [ build 44, 5/15/07]


* Patch scripts for ActiveBPEL database version 2.1.0.4. [ build 45, 5/24/07]

org.activebpel.rt.bpeladmin.war

* [Merge from ab_3_1_x] Move non-HTTP dependent parts of AeGraphImageServlet
  into a new class AeGraphImageDriver that can be reused for .NET to support
  tiling in the .NET product. Define an interface, IAeGraphImageResponse, for
  graph response functionality removed from HTTP response specifics. [ build
  208, 4/11/07]


* (1) Updated AeActiveBpelWarBundle to return string key "!key!" when key
  entry not foun. (Used throw error which ended in a 500 server error) (2)
  Added a simple iterator tag (<ae:CollectionIterator>) for
  java.util.Collection properties. (3) Updated AeAbstractAdminBean to keep
  track or error or status messages in a List instead of a single string
  concatanated with "<br> \n". [ build 209, 4/12/07]


* fixed typo in messages.properties, AevBundleKeyTest was failing [ build 210,
  4/13/07]


* 1) Cleaned up some of the AE tag classes for code-reuse (had few copy/paste
  code); 2) Updated some tags to extend AeAbstractBeanPropertyTag for code
  reuse; 3) Updated AeAbstractBeanPropertyTag to support dot chained method
  getters. Eg: <ae:IfTrue name="beanName" property="engineBean.status.running"
  /> is equivalent to getEngineBean().getStatus().isRunning().; 4) Updated
  AeGetResource tag to also be able to specify the war resource bundle key
  name indirectly via a key specified in the request object (e.g.
  <ae:GetResource attributeName="request_att_name" />) or from bean e.g.
  <ae:GetResource name="bean_name" property="errorMessageKey" />"; 5) Added
  new tag AeSetProperty - this is equivalent to jsp:SetProperty but also
  allows you to set a property based on another bean (e.g in http session).
  E.g. <ae:SetProperty name="beanName" property="methodname"
  fromName="fromBean" fromProperty="fromProperty" />; 6) Added new tag
  AeSetResource - allows one to set a war message resource bundle value on a
  bean. E.g. <ae:SetResource key="page_title" name="beanName"
  property="methodname" /> [ build 211, 4/23/07]


* Modify BpelAdmin project to be built over org.activebpel.rt.war base war:
  (1) remove resources now in base war (ae.css, aetags.tld, logo.gif,
  favicon.ico, clear.gif); (2) account for new location of console tabs
  support in JSP pages; (3) add aux.war.build to unpack base war and repack
  BpelAdmin.war; (4) modify .classpath and aebuild.properties to include base
  war classes. [ build 212, 4/24/07]


* Added BpelAdmin bean support for attachments and an attachment download
  servlet AeAttachmentDownloadServlet [ build 213, 5/8/07]


* Serialize attachment id as id attribute (instead of value attribute) and
  also serialize process id. [ build 214, 5/8/07]


* Refactored filter creation in process listing bean to make it easier to
  extend. [ build 215, 5/18/07]


* Refractored AeAttachmentViewBean to use AeMimeUtil [ build 216, 5/21/07]


* Update AeProcessViewBean to increase the process graph tiles from 250x250
  (too 'granular') to 500x500. [ build 217, 5/24/07]


* (1) Added people activity icon support for the admin console process graph;
  (2) Exposed process view graph image tile size as a property (via servlet
  config). The default image size is 1000px square.; (3) Defect - 2650 To copy
  operations that are an expression are not displaying on the admin console
  process graphs [ build 218, 6/11/07]


* Fixed problem where unable to download multipart mime attachments from
  BpelAdmin console [ build 219, 6/12/07]


* Modified admin console display of variables with attachments to provide a
  view consistent with the ActiveBPEL Designer process variables view [ build
  220, 6/14/07]


* Fixed processview_attachments.jsp to work with the WebLogic environment.
  Uses ae:GetProperty instead og jsp:getProperty [ build 221, 6/19/07]


* 1) added comment and extra line break to BpelAdmin.properties to avoid
  issues with concating (will look at the code that concats these files later)
  [ build 222, 6/20/07]


* 1) inserting line break between war resource bundle properties files when
  they're concatenated to avoid problems with missing trailing line breaks.
  (opting to change the code here instead of forcing all props files to have
  extra whitespace) 2) removed comment about having to keep a blank line in
  BpelAdmin.properties [ build 223, 6/22/07]

org.activebpel.rt.bpel

* Defect 2579 - modified AeServerProcessCoordination::activityFaulted(..) -
  Coordination framework should not double fault the enclosing scope(which
  could be the process) if the scope/process is already running its fault
  handlers. [ build 572, 4/3/07]


* Added the concept of "Custom Managers" in the engine config - this allows
  arbitrary managers to be added to the engine so that they can, among other
  things, participate in the engine lifecycle [ build 573, 4/3/07]


* 1) moved call to super.validate() to be first thing
  AeActivityInvokeValidator does since the super is required to init some
  member data 2) changed the context of the link's transition condition
  execution to be the src activity 3) expression return values are converted
  from nodes to strings when calculating a deadline or duration 4)
  AeAbstractBpelFunction was mistakenly using the parent of the bpel object to
  resolve vars instead of the bpel object itself [ build 574, 4/4/07]


* added some getMapEntry methods onto IAeUpdatableEngineConfig [ build 575,
  4/20/07]


* Major changes and additions for attachment support done here [ build 576,
  4/23/07]


* Rename AeBusinessProcessEngine#dispatchReceiveData(long, int,
  AeInboundReceive, long) to
  AeBusinessProcessEngine#internalDispatchReceiveData(long, int,
  AeInboundReceive, long) and remove
  AeBpelEngine#internalDispatchReceiveData(long, int, AeInboundReceive, long)
  which is identical. We could declare internalDispatchReceiveData() final,
  because dispatchReceiveData(AeMessageReceiver, AeInboundReceive, long,
  boolean) is the overridable method with overrides in AeBpelEngine and
  AeClusterBpelEngine. [ build 577, 4/24/07]


* handle null attachment containers and no-op copy operations correctly [
  build 578, 4/25/07]


* AeCopyOperationBase avoids executing "to" strategy if "from" returned null
  and the ignoreMissingFromData flag is set [ build 579, 4/25/07]


* (1) Change signatures of IAeAttachmentManager methods to throw
  AeBusinessProcessException instead of AeAttachmentException to simplify
  exception handling wherever an attachment manager is used. (2) Remove
  AeTokenizedAttachmentItem#getContent()--attachment streams will come from
  the attachment manager. (3) Move template implementations of
  associateProcess() and bpel2wsio to AeAbstractAttachmentManager. (4) Modify
  AeInvoke to throw an exception when the invoke is queued if there is a
  problem accessing attachments. [ build 580, 5/1/07]


* Moved the code that sets the wsa:IsReferenceParameter attribute from the
  2005 endpoint deserializer to the partner addressing layer. [ build 581,
  5/3/07]


* 1) pulled adding/removing function contexts from versioning config up to
  IAeUpdateableEngineConfig 2) check for null element namespace in
  AeReplaceElementStrategy to avoid invalid QName 3) fixed typo in
  message.properties key in AeDoXslTransformFunction [ build 582, 5/4/07]


* AeVariableSerializer now add the variable type,element or messagetype as an
  attribute of the root 'variable' element [ build 583, 5/8/07]


* (1) Move and rename
  org.activebpel.rt.bpel.attachment.AeTokenizedAttachmentItem to
  org.activebpel.rt.bpel.impl.attachment.AeStoredAttachmentItem. (2) Add
  IAeProcessPurgedListener for listeners to be notified when a process manager
  purges a completed process from memory. (3) Add
  addProcessPurgedListener(IAeProcessPurgedListener) and
  removeProcessPurgedListener(IAeProcessPurgedListener) to IAeProcessManager.
  (4) Move IAeAttachmentStorage interface from org.activebpel.rt.bpel.server
  project to here, so that we can implement AeFileAttachmentStorage for
  in-memory and simulation configurations. (5) Rename
  AeInMemoryAttachmentManager to AeFileAttachmentManager and refactor to (6)
  Move bulk of attachment manager implementation from
  AePersistentAttachmentManager and AeFileAttachmentManager to shared
  AeAbstractAttachmentManager. (7) Add AeAbstractProcessManager containing
  shared process purged listener implementation. (8) Move config utility
  routines from AePersistentProcessManager to AeAbstractProcessManager. (9)
  Modify AeInMemoryProcessManager to publish process purged events and to
  configure completed process count from aeEngineConfig.xml. (10) Serialize
  attachment id as id attribute (instead of value attribute) and also
  serialize process id. [ build 584, 5/8/07]


* 1) added added abs:processName() custom function which returns the name of
  the currently executing process 2) added a new base class for wsi style
  custom invoke handlers [ build 585, 5/9/07]


* fixed handling of a variable of type element. wrap and unwrap with a
  'value'tag [ build 586, 5/9/07]


* Moved AeSOAPElementUtil utility class from this project from
  org.activebpel.rt to minimize required libs needed by TenantConfigurator [
  build 587, 5/11/07]


* Added ProcessGroup and HideSystemGroup options to process filter. [ build
  588, 5/18/07]


* 1) renamed IAeURNAddressResolver to IAeURNResolver and repackaged to rt.bpel
  for future use by custom functions 2) added IAeURNResolve to
  IAeBusinessProcessEngineInternal, also for custom function useage 3) fixed
  issue where non-createInstance IMA's weren't getting their attachments
  associated with the process 4) AeVariable now clones/restores attachment
  container 5) fixed issue where element style wsio variables weren't getting
  their attachments populated 6) added base class for attachment some
  functions 7) changed signature for getVariableAttachmentType() from
  accepting attachment object to accepting varname and item number [ build
  589, 5/21/07]


* 1) Small refactor: removed redundant method createChildElementWithText() -
  it duplicates the functionality of addElementNS() in the same class. 2)
  Modified the functionality of the copyAllVariableAttachments() extension
  function - it now takes a list of variables names as the 1st param, rather
  than just a single variable name. [ build 590, 5/23/07]


* 1) Added expression analysis support to detect usage of attachment modifying
  ABX functions used in expressions. 2) Modified AeBusinessProcess to return
  IAeVariable instead of just the data. This makes it more useful in detecting
  changes to attachments. [ build 591, 5/23/07]


* Add support for attachments to non-persistent processes: (1) defer storing
  attachments for a message until we know the process plan; (2) notify
  attachment manager when it's safe to discard attachments for a
  non-persistent process after the engine has sent the response for the
  process; (3) maintain a reference count on an attachment file in the
  file-based attachment storage to delete the file when the last stream closes
  or the process is purged. [ build 592, 5/23/07]


* 1) uses AeXmlUtil's transform method [ build 593, 5/23/07]


* Add inner class AeVariableAttachmentContainer to AeVariable:
  AeVariableAttachmentContainer extends AeAttachmentContainer to increment a
  variable's version number if the attachment container is modified. [ build
  594, 5/24/07]


* Remove FIXME from AeVariable [ build 595, 5/24/07]


* Added the two get*Attachment* functions to the list of functions returned by
  the expression analyzer so that the analyzer's getVariables() method returns
  the variables used in those functions. [ build 596, 5/25/07]


* Fixed problem with AeVariableDeserializer causing problems during
  simulation, where variables were incorrectly being set to an unitialized
  state [ build 597, 5/29/07]


* 1) fixed defects 2754 and 2769. 2) updating variable data from user/ui
  preserves attachments. 3) AeCopyAllVariableAttachmentsFunction returns the
  actual count of attachments copied instead of the number of attachments of
  the target. [ build 598, 5/31/07]


* Updated and added new class to resolve the URN mapping for XSL file. This
  provides a layer of indirection between the process and the xsl resource
  used to format the message. [ build 599, 6/1/07]


* 1) AeActivityScopeImpl wasn't checking for an executing termination handler
  in isScopeOkToComplete. Found as part of terminating a subprocess since the
  coordination is cancelled which causes the scope to check to see if it can
  complete. [ build 600, 6/6/07]


* rolling back change in scope activity since an offline test is failing, need
  to debug before keeping change [ build 601, 6/6/07]


* Added new visitor to detect if a partner link is acually being used in an
  invoke operation. [ build 602, 6/6/07]


* Refactor the code to move the messages from org.activebpel.rt to
  org.activebpel.rt.bpel projects. [ build 603, 6/7/07]


* 1) New attachment expression function getAttachmentProperty. 2) Removed
  'Variable' from tha names of all attachment functions. 3) addAttachment
  renamed to copyAttachment. 4) For functions copyAttachment and
  replaceAttachment the item object parameter have been replaced by a
  VariableName and attachment itemNumber. 5) All attchment functions now use
  itemNumber's that start with 1 instead of 0. [ build 604, 6/7/07]


* Added implicit copy of attachments from the first part and only the first
  part of a message. [ build 605, 6/7/07]


* 1) restoring termination handler check in AeActivityScopeImpl. The failing
  tests were likely due to OutOfMemory errors and other eclipse problems.
  After restarting and doing a clean I cannot recreate failures [ build 606,
  6/7/07]


* Fixed problem where no warning was generated for missing imports in WS-BPEL
  2.0, becuase they were in a deployment descriptor. The user is now warned
  that this may not be portable. [ build 607, 6/8/07]


* Fixed copy from message part strategy to copy attchments only for the first
  message part for invokes and onmessage. From part copy for assign has been
  removed. [ build 608, 6/8/07]


* Moved expression language constants from factory classes to IAeBPELConsants.
  [ build 609, 6/10/07]


* Updated AeDiffEngineConfiguration class to use copyEntries(Map, Map) method
  in AeConfigurationUtil (method was moved from AeDiffEngineConfiguration to
  the AeConfigurationUtil) [ build 610, 6/14/07]


* Added supprot for getAttachmentSize, Fixed widlcard varibles for
  copyAllAttachments, added wildcard support for removeAllAttachmentts [ build
  611, 6/15/07]


* 1) pulled code for setting values by path up from AeDiffEngineConfiguration
  to AeConfiguration 2) added getter/setter for path on config interfaces [
  build 612, 6/18/07]


* Fixed problem where NullPointerException encountered if workflow plugin not
  installed and B4P process is opened. [ build 613, 6/19/07]


* 1) added AeAbstractBpelObject.triggerFaultHandler(fault) as conv call to
  (surprise) trigger fault handling. This replaced previous calls of
  setFault(fault) followed by startTermination() 2) changed some of the
  synchronized blocks in AeServerProcessCoordination to synch on the process
  and not the scope. Also added missing synch blocks 3) fixed issue in
  AeServerProcessCoordination where faulted subprocess wasn't propagating
  fault correctly to calling process. Calling processes faultHandler wasn't
  executed since it was at the process level at the call in
  AeServerProcessCoordination was objectCompletedWithFault(fault). Changed to
  call new triggerFault(fault) method which allows for fault handling. [ build
  614, 6/19/07]


* For defect 2861, "Server deadlocking when onAlarms exceed the number of
  available work manager threads," add new configuration entry constants to
  IAeEngineConfiguration. [ build 615, 6/20/07]


* Fixed recovery issue where inbound receives that use engine managed
  correlation were not adding the conversation id property to the correlation
  map when deserializing from a journal entry. [ build 616, 6/22/07]


* 1) added getAttachmentFunctionList() to IAeExpressionParseResult 2) added
  IAeExpressionParseResult to IAeExpressionValidationResult in lieu of
  exposing more pass-through methods 3) fixed code in
  AeAbstractExpressionParseResult.getVarAttachmentList() to account for new
  method signatures on attachment functions 4) changed constants in
  AeExpressionLanguageUtil to match function names, removed unnecessary
  constants 5) changed AeAbstractExpressionValidator to add parse result to
  validation object 6) AeBaseExpressionValidator resolves all variable
  references in expression which will mark variables in attachments functions
  as being used. [ build 617, 6/22/07]

org.activebpel.rt.bpeladmin.help.war

* V4.0 Administration Console Help for ActiveBPEL Designer Development Server.
  Ready for product launch. [ build 19, 6/20/07]

org.activebpel.rt.axis.bpel.web

* Comment change in engine config .xsl file. [ build 71, 4/3/07]


* attachments need axis 1.4 [ build 72, 4/23/07]


* changed config for active bpel in-memory to use the in-memory attachment
  manager [ build 73, 4/24/07]


* Rename AeInMemoryAttachmentManager to AeFileAttachmentManager in engine
  config files. [ build 74, 5/8/07]


* 1) name change for urn resolver in config file [ build 75, 5/21/07]


* Add config entries for Alarm child work manager to
  aeEngineConfig-ActiveBPEL.xml. [ build 76, 6/20/07]

org.activebpel.rt.bpel.ext.expr

* 1) unwrap saxon's object wrapper before returning value so our custom
  function will see IAeAttachmentItem [ build 26, 5/21/07]


* Moved expression language constants from factory classes to IAeBPELConsants.
  [ build 27, 6/10/07]

org.activebpel.rt.bpel.server

* 1) Added the concept of "Custom Managers" in the engine config - this allows
  arbitrary managers to be added to the engine so that they can, among other
  things, participate in the engine lifecycle 2) Added the concept of a
  'custom storage' and 'custom provider' so that named storage objects can be
  specified in the engine config. this allows them to utilize the storage
  framework we have in place AND they can leverage the provider framework
  (data source, etc...) [ build 450, 4/3/07]


* Couple of minor javadoc changes. [ build 451, 4/13/07]


* Added call to set active engine for any custom managers which are registered
  [ build 452, 4/13/07]


* 1) added AeDeploymentUtil which is used by managers to deploy bpr's when
  they start up 2) removed ae:localhost from AePartnerAddressing's init of
  myRole epr. The initial value of a myRole epr will be the myRole's
  serviceName from the pdd. This will change when the partnerLink receives a
  message. [ build 453, 4/20/07]


* Attachment support including storage of attachments to SQL databases and
  process invoke support [ build 454, 4/23/07]


* Modified AeDeploymentUtil to add ability to deploy WSR files. [ build 455,
  4/23/07]


* Rename AeBusinessProcessEngine#dispatchReceiveData(long, int,
  AeInboundReceive, long) to
  AeBusinessProcessEngine#internalDispatchReceiveData(long, int,
  AeInboundReceive, long) and remove
  AeBpelEngine#internalDispatchReceiveData(long, int, AeInboundReceive, long)
  which is identical. We could declare internalDispatchReceiveData() final,
  because dispatchReceiveData(AeMessageReceiver, AeInboundReceive, long,
  boolean) is the overridable method with overrides in AeBpelEngine and
  AeClusterBpelEngine. [ build 456, 4/24/07]


* Fixed problem getting NPE while creating Web Service Response [ build 457,
  4/24/07]


* handle null attachment container [ build 458, 4/25/07]


* (1) Remove unnecessary catch clauses due to redeclared IAeAttachmentManager
  exceptions. (2) Modify storeAttachment() in IAeAttachmentStorage and
  IAeAttachmentStorageProvider to accept input stream and headers instead of
  IAeWebServiceAttachment. (3) Remove associateProcess(long, long,
  java.sql.Connection) from IAeAttachmentStorageProvider. (4) Modify
  AeResultSetHandlers.sBlobStreamHandler to always read database stream
  completely with AeBlobInputStream, because there is no guarantee that the
  contents will be available once the result set, statement, or database
  connection is closed. [ build 459, 5/1/07]


* 1. Moved code to set the wsa:IsReferenceParameter attribute from the 2005
  endpoint deserializer to the partner addressing layer 2. deployWebService in
  AeDeploymentUtil needed to include a parent classloader when creating the
  loader for the wsr. [ build 460, 5/3/07]


* (1) Fix defect 2632, "Getting an error on CleanupAttachments when attempting
  to start ActiveBPEL Enterprise using Oracle" (as well as DB2). (2) Move
  associateProcess() call from AeQueueStorageProvider#journalInboundReceive()
  to AeQueueStorage#consumeMessageReceiverInternal(). (3) Move
  IAeAttachmentStorage interface from here to org.activebpel.rt.bpel project.
  (4) Move bulk of attachment manager implementation from
  AePersistentAttachmentManager to shared AeAbstractAttachmentManager. (5)
  Propagate IAeProcessManager interface changes. (6) Move
  AeAttachmentItemResultSetHandler from
  org.activebpel.rt.bpel.server.engine.storage.sql to
  org.activebpel.rt.bpel.server.engine.storage.sql.handlers. [ build 461,
  5/8/07]


* Javadoc. [ build 462, 5/10/07]


* Add a hasMapping() check in addServiceNamesFromWsdlRefs() - when the service
  names are being pulled from all of the wsdl references, non-local references
  are now skipped. This is necessary when deploying a BPR that refers to a
  WSDL that is deployed in some other BPR. [ build 463, 5/17/07]


* Added process group option to pdd information. [ build 464, 5/18/07]


* 1) changes related to repackaging URN resolver 2) pre-deployment validator
  was mistakenly treating a pick's onMessages as individual IMA's and
  therefore rejecting the process as a non-persistent process [ build 465,
  5/21/07]


* Add support for attachments to non-persistent processes: (1) implement a
  composite attachment storage in AePersistentAttachmentManager that chooses
  between local files or persistent database depending on the process
  persistence; and (2) implement process purged notification in
  AePersistentProcessManager. Also, (3) fix AeProcessInvokeHandler to clean up
  attachment streams after queuing the message to the engine; and (4) remove
  associateAttachments() from IAeQueueStorageProvider and its implementations.
  [ build 466, 5/23/07]


* Fix for defects 2754 2769. remote call now returns an emty string instead of
  null [ build 467, 5/31/07]


* Updated AeBpelEngine for URN mapping to resolve the XSL file location. [
  build 468, 6/1/07]


* Modified partner link deployment validator to create a validation error if a
  partner link is defined in BPEL process but not in PDD if it is actually
  being used in an invoke operation. Otherwise we continue to log a warning as
  we have done in the past. [ build 469, 6/6/07]


* Added getStringOrSqlNullVarcharNoEmpty to AeSQLObject. [ build 470, 6/10/07]


* Split out pure JCE functionality from AeCryptoUtil into AeJCEUtil so
  standalone clients can encrypt and decrypt without introducing dependencies
  on server-side classes. [ build 471, 6/12/07]


* Check for AeBlobInputStream to avoid reading the content stream a second
  time for content size calculation [ build 472, 6/15/07]


* AeCoordinationManager doesn't propagate process-completed message to
  coordinators if the process that completed was a subprocess since this
  process should remain in the compensatable state until its parent completes
  [ build 473, 6/15/07]


* Removed some redundant code from the process invoke handler that was
  updating context addressing twice. [ build 474, 6/18/07]


* Added callback from the participant to the coordination manager when the
  participant receives a close() message. The callback allows the coordination
  manager to check for any related coordinators for the same coordination id
  and propagate the close message to them as well. This is necessary for
  nested subprocesses (i.e. A->B->-C so that when A completes, B and C will
  both transition from compensatable to completed) [ build 475, 6/19/07]


* Fix defect 2861, "Server deadlocking when onAlarms exceed the number of
  available work manager threads," by scheduling the work to dispatch an alarm
  through a child work manager that never schedules more than 5 (or other
  configurable number) work items through the parent work manager. In other
  words, at most 5 work manager threads at a time are dispatching alarms. [
  build 476, 6/20/07]

ActiveBPEL engine v3.1 0 (20070330) 
 
org.activebpel.rt.axis

* Updated AeCatalogHelper::getCatalogSchema() to check if catalog item detail
  is null. [ build 64, 3/6/07]


* Fixed problem resolving imports which have spaces in their name. [ build 65,
  3/20/07]

ddl.org.activebpel

* 1) fixed a column type (DeadlineMillis) in the informix DDL (from INT to
  INT8). 2) fixed a missing ; in the sql server DDL [ build 40, 3/1/07]


* Add missing changes to patch 2.1.0.3 for DB2, MySQL, and SQL Server: (1)
  remove unused AeQueuedReceiveByMatchHash index in all databases to match an
  optimization we did to Oracle earlier; and (2) add QueuedReceivedId to
  AeQueuedReceiveByCorrelateHash index in some databases to optimize execution
  plan. [ build 41, 3/21/07]

org.activebpel.rt

* 1) For sample data generation added a null check in AeSampleDataTarget when
  we're building the list of compatible elements for user selection. 2) Fixed
  a bug in AeCastorStructureFactory's handleElementName method where we were
  figuring out the element's namespace. [ build 351, 3/2/07]


* 1) changes to AeXmlUtil.copyNodeContents() to fix issues with namespace
  declarations that can crop up when the DOM gets serialized under JRE 1.4 2)
  replaced AeSampleDataVisitor that encoded QNames with AeXmlUtil code [ build
  352, 3/2/07]


* 1) removed call to removeChild() in AeXmlUtil.copyNodeContents since it
  causes failures in Axis' DOMImpl 2) simplified
  AeCastorStructureFactory.createAttributeModel() to use AeSchemaUtil method
  to determine ns for attr [ build 353, 3/5/07]


* 1) added IAeSampleDataPreferences.isCreateOptionalElements, must have been
  removed during previous round of refactoring 2) AeSampleDataVisitor checks
  prefs to see if optional element should be created 3) sample data prefs
  repeating element prefs exceed maxOccurs then Math.max(1, minOccurs) is used
  instead of just minOccurs (which may be zero) [ build 354, 3/6/07]


* For sample data generation, changed the default generate nillable element
  contents flag from false to true. [ build 355, 3/6/07]


* Updated to add log4j.jar to plugin runtime dependency. CentrasSite plugin
  requires this dependency. This resolves the one of the classpath issue when
  integrating CentraSite in designer. [ build 356, 3/7/07]


* In the class AeSampleDataTarget added a validation check when adding target
  ElementDecls to the list of top-level elements for selection for sample data
  generation. This check makes sure that the ElementDecl defines a valid
  XMLType or references a valid XMLType. [ build 357, 3/8/07]


* 1) AeBPELExtendedWSDLDef uses standard schema resolver if none is set and a
  schema needs to get parsed 2) broke out complex type and element filtering
  from AeSampleDataTarget to top level classes and interfaces 3) fixed issue
  with AeSampleDataVisitor where ClassCastException was happening if a choice
  element had an <any> in it [ build 359, 3/9/07]


* Added new util method getQName() and writeNode() [ build 360, 3/12/07]


* 1) renamed AeXmlUtil.getQName to getQNameAttribute to match other getter
  names 2) changed AeXmlUtil.setQNameAttribute to use encodeQName method 3)
  overloaded IAeMutableNamespaceContext to add flag to allow default namespace
  usage. This flag should be false if you're looking for namespaces to encode
  a QName as an attr or element value [ build 361, 3/14/07]


* 1) Refactored the class AeAcceptAllComplexElements to
  AeAcceptAllGlobalElements and modified the accept method to return true for
  top-level elements of SimpleType as well as ComplexType. 2) Added well known
  namespace prefixes to the preferred prefix/namespace map for sample data
  preferences class. [ build 362, 3/15/07]


* 1) checking in change from ew: AeXmlUtil.removeDuplicateNSDecls 2) changed
  exception in AeXmlUtil.selectNodes() to include jaxen exception in
  stacktrace 3) fixed bug in AeXmlUtil.setNamespacePrefixUris where it wasn't
  iteratoring over the whole map to add ns declarations [ build 363, 3/16/07]


* 1) added jdom.jar to plugin.xml. This jar is needed by the CentraSite
  plugin. It is invoked by the jaxen library so it needs to be packaged with
  jaxen. 2) fixed bug in AeAcceptAllCompatibleElements where element type was
  assumed to be complex [ build 364, 3/19/07]


* Changed UrlDecoder call to use UTF8Util method instead of duplicating code.
  [ build 365, 3/20/07]


* 1) added null check to AeSampleDataVisitor.makeComment 2) fixed issue in
  AeSampleDataVisitor with visiting an element with an abstract type in the
  scenario where the type has no concrete types to create (caused by
  incomplete schema or by a recursion stopper preventing us from traversing
  into the children any further) [ build 366, 3/22/07]


* Added overloaded method loadConfig(org.w3c.Document) to the
  AeConfigurationUtil (in addtion to the method which takes in a Reader) [
  build 367, 3/26/07]


* Added touchXmlNodes() methods to AeXmlUtil to touch each DOM node and all of
  its children. [ build 368, 3/29/07]

org.activebpel.rt.axis.bpel

* Fix for defect 2473 where you get an NPE if you use an inbound
  authentication policy on a partner role [ build 198, 3/8/07]

org.activebpel.rt.bpeladmin.war

* (1) Changes to AeProcessViewBase - Set the initial value of a deployed
  process id to -1 instead of 0 since zero indicates the first deployed
  process index in Active-BPEL. (defect 2475); (2) Added new tag
  AeStringPropertySetterTag to set form data properties including empty string
  values (which is not supported by jsp:setProperty method) [ build 206,
  3/2/07]


* (1) Refactoring: moved method escapeSingleQuotes(String) from
  AeProcessViewUtil to the more common class AeWebUtil; (2) Defect 2488:
  Updated AeMessageReceiverDetailWrapper::getCorrelationData() to return data
  via escapeSingleQuotes (otherwise, unescaped quotes would case JS errors
  during JS function calls); (3) Updated message_rec_queue.jsp to use
  ae_winutil.js to open the partner details window, centered around the parent
  window; (4) Updated message_rec_queue.jsp to display correlation data in a
  <textarea/>. [ build 207, 3/6/07]

org.activebpel.rt.identity

* (1) Added AeIdentityServiceConfiguration to wrap service configuration
  details similar to AeEnginConfig; (2) Added Search and service provider
  level exceptions with error codes; (3) Refactored common AeLDIF* classnames
  to AeLdap* classnames; (4) Updated schema as well as removed
  tExtensibleField from identity schema; (5) Added identity service wsdl [
  build 4, 3/26/07]

org.activebpel.rt.bpel

* 1) fixed link validation code to catch links illegally crossing boundaries
  (while, comp handler, etc) 2) added new interface for defs that cannot have
  links cross their boundary 3) dom nodes for literal defs and extension defs
  get cloned to avoid i/o issues with ns decls 4) AeSOAPElementUtil wasn't
  traversing its parent nodes to find ns decls unless the element had a ns
  decl on it [ build 566, 3/2/07]


* 1) checking in fix for bpws to ws-bpel conversion dealing with
  expression language attrib 2) added checked for NPE in validation code
  (occurs when wsdl is missing for variable decls) [ build 567, 3/9/07]


* 1) changes related to IAeMutableNamespaceContext change [ build 568,
  3/14/07]


* 1) repackaged AeNamespaceFilteredWSDLIterator from rt.bpel.server 2)
  checking in change to AeWriterVisitor for ew [ build 569, 3/16/07]


* Fix for defect 2550 omega. Defect 2550 was actually a problem with the
  Tamino upgrade script. It was disputed because there were some problems
  completing existing processes AFTER the upgrade. The problems completing
  existing processes were not Tamino related. The problem is that some code
  was added for routing messages that relied on map lookups using
  AePartnerLinkDefKeys. However, when upgrading, the keys were being created
  with -1 as the partner link id (because old DBs wouldn't have the partner
  link id). Simple fix - change the hashCode() method to use the partner link
  name (which will always be right) instead of the partner link id. This
  increases the chance of map collisions, but not substantially for most
  processes (only for processes that have multiple partner links with the same
  name, which will be relatively rare). [ build 570, 3/22/07]


* Modified validation in AeAddressingHeaders to accept headers of type
  wsa:AttributedURIType with a value of empty string. [ build 571, 3/27/07]

org.activebpel.rt.tamino

* Fixed a problem in Tamino where exception thrown when committing a
  transaction would get dropped because a call to TConnection::close() in the
  finally block would also throw. [ build 57, 3/8/07]

org.activebpel.rt.bpeladmin.help.war

* Admin Console Help for ActiveBPEL Engine shipped with Designer ready for
  V3.1 [ build 18, 3/21/07]

org.activebpel.rt.bpel.server

* Defect 2492 related: Updated AeCatalog::getCatalogItemDetail() to return
  null if mapping does not exist (with out throwing NPE) [ build 446, 3/6/07]


* 1) repackaging of AeNamespaceFilteredWSDLIterator to rt.bpel [ build 447,
  3/16/07]


* Added pdd constant for effectiveDate attribute. [ build 448, 3/18/07]


* Update to AepartnerAddressing and AeProcessDeployment to ensure all policy
  elements added to partner link eprs are touched and detached. [ build 449,
  3/29/07]

ActiveBPEL engine v3.0.1 0 (20070108) 
 
org.activebpel.rt.axis

* Update .classpath entry for new Axis 1.4 source location [ build 61,
  12/20/06]

org.activebpel.rt

* Fixed a defect with the method getOrCreatePrefixForNamespace in the class
  AeBPELExtendedWSDLDef where an unnecessary prefix/namespace can be created
  within the definition when an appropriate one already exists within the
  current definition. [ build 332, 12/13/06]


* Added new AeSafelyViewableSet [ build 333, 12/14/06]


* Update IAeConstants and standardSchemas to include 2005 WSA Namespace [
  build 334, 12/20/06]


* In AeBPELExtenedWSDLDef removed code which was adding an extraneous bpel
  namespace definition to the WSDL def when adding a new property,
  propertyAlias or partner link type to the definition. [ build 335, 12/22/06]

org.activebpel.rt.axis.bpel

* Fixed problem getting NPE in AeInvokeHandler [ build 186, 12/14/06]


* invoke handler wasn't deserializing type based fault data correctly (faults
  are supposed to be elements but we have code to support types as well) [
  build 187, 12/14/06]


* 1. Update the AeWsaHeaderHandler to handle 2005 WSA namespace 2. Update
  AeRpcStyleInvoker and AeBreakpointHandlerStub to make sure the MEP and
  ReturnType is always set on call objects. Axis 1.4 throws an exception if
  parameters are set on a call without specifying a return type. 3. Removed
  redundant setting of transmission id on AeInvokeHandler. [ build 188,
  12/20/06]

org.activebpel.rt.bpeladmin.war

* Minor change to base config bean [ build 197, 12/14/06]


* Fixed problem where config update from cluster_tab was resetting config
  values on other tab pages. [ build 198, 1/4/07]


* Updated copyright to reflect 2007 and removed All rights reserved comment
  [ build 199, 1/4/07]


* Reverted changes on AeEngineConfigBean to fix issue with engine config tab
  not saving properly [ build 200, 1/5/07]

org.activebpel.rt.bpel

* Improved/updated several warning/error message text strings defined in
  messages.properties, per defects 2210 & 2359. [ build 538, 12/13/06]


* 1) change to link validator to display a warning if a link is not used
  rather than an error 2) bug fix in in-memory consumeMesageReceiver impl - it
  was consuming only the matching message receiver rather than the matching
  receiver and all other receivers in its group (for picks) - this was causing
  a failure in the online unit tests when run against an in-memory config 3)
  invalid expression value fault now includes the expected type in the 'info'
  portion of the fault 4) refactored the copy strategy factory so that there
  are now two impls: bpws and wsbpel - the wsbpel impl differs with respect to
  xsi:nil support 5) fixed two bugs in state saving/restoration related to
  saving fault information during compensation handling [ build 539, 12/14/06]


* 1) added SA check for unreachable CH 2) added runtime error for empty string
  assignment (only applies to ws-bpel) 3) implemented create xpath feature for
  element and type based property aliases 4) SA for prop alias was using the
  wrong namespace context 5) SA for onMessage wasn't allowing empty-variable
  style onMessage 6) moved code for variable initialization from assignment
  <to> objects to IAeVariable interface 7) changed storage and processing of
  namespaces in AeBaseDef to not require "xmlns:" as prefix for all entries 8)
  SA code now reports errors using the actual def that contained the error
  instead of the first enclosing activity def [ build 540, 12/14/06]


* Corrected static analysis display text for create instance validation
  errors. The error logic was correct but the error message was misleading. [
  build 541, 12/18/06]


* 1. Added serializer/deserializer support for WS-Addressing headers and
  Endpoints defined in the 2005 namespace. 2. New extended wsa endpoint
  serializers/deserializers to handle changes in endpoint info model for 2005.
  3. Updated AeEndpointReference so that the fix for a signature processor bug
  we used for reference properties is also used for policy and extensibility
  elements since we may want/need to sign them at some point. [ build 542,
  12/20/06]


* Fixed issue where I had broken backward compatibility with pre-2.0 way of
  specifying user credentials on endpoint reference. [ build 543, 12/21/06]


* update earlier change so it runs under jdk1.4 as well as jdk1.5 [ build 544,
  12/21/06]


* 1) fixed issue where link cycles were reported for links within isolated
  scopes 2) AeCreateInstanceOperationVisitor was missing a visit for onEvent
  which could cause messages to avoid getting routed to running instances.
  Instead of routing, new process instances were created. 3) implicit scope
  visitor wasn't parenting the scope def correctly 4) changed
  AeDefVariableUsageVisitor to use the defs to resolve variables instead of
  the stack since the stack might not reflect the full anscestor hierarchy in
  cases where we're traversing from a compensate activity. [ build 545,
  12/22/06]


* 1) fixed problem with variable initialization in toParts introduced by
  refactoring back in build 1758 2) removed unused code from
  AeBusinessProcessEngine [ build 546, 1/2/07]


* Fix for defect 2367. We once again write out inlined scope defs for invokes
  whenever possible (regardless of the source XML). This is so that we are
  consistent with how we worked in 2.x. [ build 547, 1/2/07]

org.activebpel.rt.tamino

* Implemented the getTxCommitControlDBConnection() introduced for consuming
  message receivers. [ build 47, 12/14/06]

org.activebpel.rt.bpeladmin.help.war

* Updated copyright notice [ build 16, 1/3/07]

org.activebpel.rt.axis.bpel.web

* Updated the .classpath to fix the Axis source path. [ build 63, 12/14/06]


* Update .classpath to point to Axis 1.4 source location [ build 64, 12/20/06]

org.activebpel.rt.bpel.server

* 1) minor refactoring of subprocess invoke handler to make it easier to
  extend (used in the offline engine test code) 2) introduced
  getTxCommitControlDBConnection to the storage layer so that storage objects
  can participate in TX's 3) fixed persistent hole in queue storage -
  consumeMessageReceiver now does its work within a Transaction so that the
  ack callback participates in the same Tx as the message consume [ build 420,
  12/14/06]


* 1) replaced "pid" with "process id" in error messages 2) slight refactoring
  in building wsdd 3) changed "wsdl key" to "resource key" in some comments [
  build 421, 12/14/06]


* Update AeSQLCounterStore to report first exception if database retry loop
  ultimately fails (like other retry loops we have updated recently); update
  AeProcessStateWriter retry loops to look more like retry loops elsewhere in
  the system. [ build 422, 12/15/06]


* Added support for the 2005 wsa namespace in pdd validation. [ build 423,
  12/20/06]

ActiveBPEL engine v3.0.0 0 (20061212) 
 
ddl.org.activebpel

* Fix defect 2352, "Slow performance with Oracle after a long load test," by
  adding a new AeProcess index and modifying an AeQueuedReceive index to
  optimize the GetCorrelatedReceives query. [ build 35, 11/30/06]

org.activebpel.rt

* Fixed equals method on AeSchemaDateTime to check the type before doing a
  further comparison. [ build 327, 11/1/06]


* (1) Defect 2105 updated AeWSDLPrefixes to return default NS prefix for
  abstract processes [ build 328, 11/3/06]


* Added an xml util method "findDefaultNamespace" used to get the in-scope
  default namespace for an Element. [ build 329, 11/4/06]


* 1) added isZero() to AeSchemaDuration [ build 330, 11/6/06]


* Added entry point for xml compare utility to take in to xml documents as
  strings to compare. [ build 331, 11/13/06]

org.activebpel.rt.axis.bpel

* 1. Moved code to create abx:conversationId header from AeInvokeHandler to
  AePartnerAddressing 2. Added new methods to AeBpelHandler for resolving
  partner link defs, myrole endpoints, and service QName from the SOAPService.
  3. Refactored AeBpelHandler.initServiceDesc() to use new methods [ build
  179, 11/3/06]


* Fix of problem loading external WSDL for deployed services [ build 180,
  11/6/06]


* New AeWsaHeaderHandler that marks ws-addressing headers as processed for the
  must-understand checker. Added the new handler to the global request &
  response chains in client and server wsdd files. [ build 181, 11/7/06]


* Fix bug 2214, modify the serialize() to write the documentElement to the
  aContext directly instead of using the transformer. It is very important to
  enforce setWriteXMLType(null) to make sure the xsi:type attribute is
  properly serialized. [ build 182, 11/7/06]


* Refactored the AeAxisObjectProxyFactory to provide overloaded methods for
  getMessageContextProxy and getSOAPHeaderProxy that take the class object as
  an argument to avoid classloader issues on some Tomcat installations.
  Refactored the AeWsaHeaderHandler so it only proxies the SOAPHeader object
  if really necessary. Removed the WSA Header handler from the global service
  request chain. [ build 183, 11/9/06]


* Fixed problem introduced by resource catalog upgrade in 3.0 where pdd
  refernces to external wsdl services were not being found or used by the
  invoke handler. [ build 184, 11/10/06]


* Changed log message when failure occurs during invoke to include the
  operation name which failed. [ build 185, 11/20/06]

org.activebpel.rt.bpeladmin.war

* (1) Updated code to display message exhanges only if it exists; (2) Added
  Admin Console support for concurrent OnEvent and OnAlarm [ build 189,
  11/3/06]


* 1) changed check for isOneWay to use the consumer message parts map of the
  invoke. This was previously unavailable since the defs weren't preprocessed
  with a WSDLProvider but PJ has since changed that. [ build 190, 11/6/06]


* Defect 2256 - show variable element, message or xsd type when viewing a
  variable properties. [ build 191, 11/8/06]


* Fixed a todo - admin console variable (process graph) properties: the
  variable type (element|message|type) QName was displayed as {uri}:localName.
  This has been changed to display prefix:localName along with the ns URI
  (type namespace) as a new property. [ build 192, 11/9/06]


* (a) Defect 2280 AeProcessViewBase: included changes per KR to log Throwable
  errors to console in AeProcessViewBase. Added methods to access process plan
  based on active process or deployed process details view mode; the active
  process plan is based on the QName and process Id; (b) AeProcessViewBean -
  Updated error message that is displayed when the location path is incorrect
  to display the location path as part of the error message. [ build 193,
  11/13/06]


* Uncommented init-params in web.xml (and added maxmemory
  param). [ build 194, 11/14/06]


* (1) Defect 2294 - displaying of message exchanges for bpws 1.1 processes (2)
  Defect 2293 - change "variable access serialiable" property label to read
  "Isolate" for wsbpel processes [ build 195, 11/14/06]


* added ignoreMissingFromData to copy op in admin console [ build 196,
  11/16/06]

org.activebpel.rt.bpel

* Added validation code for imports to check that the type uri is a valid
  absolute uri. [ build 507, 11/1/06]


* 1) fixed numerous issues with concurrency for onEvents (mostly state saving)
  but left onEvent as synchronous until PJ checks in the fixes for the admin
  console 2) left a few comments for things I need to fix before we release 3)
  changed message producer contract to return clone of message data as opposed
  to live variable [ build 508, 11/2/06]


* 1) Added some explicit construction of container defs (partners, partner
  links, links, etc) due to legacy problem with location id creation 2)
  properly skipping the creation of location paths for query def and literal
  def in BPEL 1.1 processes (since these defs do not really exist in a BPEL
  1.1 process) [ build 509, 11/2/06]


* Added additional static analysis check for onAlarm activities within in
  WS-BPEL process. Namely the validator (AeWSBPELOnAlarmValidator) is now
  checking for a required Scope child for onAlarm activities that are defined
  within an event handler. [ build 510, 11/2/06]


* (1) Added process validate for abstract processes to check for required
  abstractProcessProfile attribute; (2) Refactored message exchange visitor
  into two visitors - one implicit visitor and one createInstance entry point
  visitor; (3) Updated base AeAbstractDefPathSegmentVisitor to assign paths to
  message exchanges (bpws impl overrides to not to assign path); (5) Defect
  2219 update process save state visitor and process snapshot visitor to save
  fault hander variables; (6) Enabled the concurrency flag in AeOnEvent [
  build 511, 11/3/06]


* Removed a workaround for determining proper source namespace from
  AeAddressingHeaders that is no longer necessary [ build 512, 11/3/06]


* 1) Added some convenience methods on AeBaseDef to get/set/remove the xmlns
  default namespace decl 2) Added a new conversion visitor that adds a
  potentially missing scope def as the child of an onAlarm in an event handler
  3) Modified the def output layer to be capable of generating prefixed XML
  rather than using a default bpws/bpel namespace (the default is now
  prefixed) [ build 513, 11/4/06]


* (1) Defect 2139; (2) added makeNewFault to AeFaultFactory to clone a fault
  with rethrowable and suspendable flag sets; (3) Updated base reply receiver
  class to use the rethrowable (makeNewFault) fault for onFault callback [
  build 514, 11/6/06]


* Fix of problem loading external WSDL for deployed services [ build 515,
  11/6/06]


* 1) added support for concurrent handling of onAlarm's with repeatEvery 2)
  some refactorings to enable better code sharing between concurrent onEvent
  and onAlarm impls [ build 516, 11/6/06]


* Defect 2248 - when opaque activity def is validated, call super.validate to
  build the target links for validation [ build 517, 11/6/06]


* Merged change for 2.1.2 to fix problem restoring deadpath source link
  status. [ build 518, 11/7/06]


* (1) Add support for journaling pending invokes to fix defect 1191, "Pending
  invokes are not completing after the cluster cleanup delay." (2) Add
  isRunning() method to IAeBusinessProcessEngineInternal and its
  implementations. [ build 519, 11/8/06]


* 1) added format for generic process info events 2) use generic process info
  event for invoke retries, invalid state transitions, and unmatched requests
  3) fixed issue in AeActivityCompensateDef where it wasn't checking for its
  nesting properly 4) added more static analysis for isolated scopes 5)
  changed onEvent scope to init its plink data in ready-to-execute stage [
  build 520, 11/8/06]


* (1) Defect 1558 - updated AeProcessCompensationCallbackWrapper to set the
  process state to faulted (instead of completed) if the process instance
  compensation handler was terminated; (2) In AeReplyReceiverBase - removed
  IAeCoordinating.WSCOORD_ID entry from Business process properties. This was
  previously done in the subclass AeQueuingReplyReceiver, now moved to the
  base [ build 521, 11/9/06]


* Added a protected getter on AeProcessDef that is used only by a unit test. [
  build 522, 11/9/06]


* 1) fixed issue with ambiguousReceive 2) added ae:ambiguousReceive as a
  custom fault to send back to services that send us an ambiguousReceive [
  build 523, 11/9/06]


* Fix defect 2263, "Compensation handlers for isolated scopes are not
  acquiring locks for compensation." [ build 524, 11/9/06]


* Fix defect 2277, "Getting class cast exception when running process level
  compensation." (Yes, I forgot to run the online unit tests last night.) [
  build 525, 11/10/06]


* 1) Additional validation of literals (xsi:schemaLocation) 2) changes some
  validation warnings to errors 3) slightly improved error handling/logging
  during validation [ build 526, 11/13/06]


* 1) added error message for failure during process level variable
  initialization 2) added process info event for process level variable
  initialization failure [ build 527, 11/13/06]


* Fixed recently added constructor for process events which was improperly
  assigning event ids to the process id, which showed up in remote debug
  events. [ build 528, 11/13/06]


* (1) Defect 2294 related - admin console code requires bpws 1.1 processes's
  message exchanges to have location paths; (2) Added
  AeBPWSMessageExchangeDefPathSegmentVisitor to assign paths for bpws 1.1
  process message exhanges (currently used by admin console); (3) Added
  AeDefNullPathVisitor to assign paths for defs which do not already have
  location paths assigned; (4) Added ctor AeDefPathVisitor to take the init
  nextLocationId as a param. [ build 529, 11/14/06]


* rolling back previous change of adding number patterns for PID and EventID
  in eventFormat.properties due to a few events being fired without these
  values and causing errors in the console. Will return after release to track
  down which events are firing without PIDs or EventIds. [ build 530,
  11/14/06]


* Fix defect 2317, "Getting a warning 'Process <num>: completed recovery with
  1 journal entry remaining' when an invoke fails and you restart," by
  overriding setFaultedState() in addition to setState() in
  AeActivityInvokeImpl in order to remove the pending invoke journal entry. [
  build 531, 11/16/06]


* 1) Issue R1 keepSrcElement behavior for virtual <assign>. Virtual copy
  operations for fromPart/toPart use keepSrcElementName behavior 2) Issue R29
  Partner link's initializePartnerRole attribute. Changed attribute to be a
  tri-state bool with default being unset. Added static analysis check for
  attribute on plinks that don't have a partnerRoe. Converter no longer sets
  attribute since its not required. 3) R33 Optional XML Data in Assignments.
  Added ignoreMissingFromData to copy operation. [ build 532, 11/16/06]


* Removed warning message about unmatched request as we already log an info
  event with the process about the fact that a request for the process doesn't
  match any current waiting requests. [ build 533, 11/20/06]


* 1) Modified call to AeBusinessProcessEngine.queueReceiveData to return the
  processId to give us more detailed info for logging. 2) Changed
  AeQueuingReplyReceiver to validate input arguments [ build 534, 11/20/06]


* add method setRecoveredTransmissionId(long) to IAeInvokeInternal and to
  impl. AeInvoke (queue obj) to set the transmission id during recovery. [
  build 535, 11/21/06]


* Added 'handledFault' attribute of the AeDefaultFaultHandler class to the
  process state document. [ build 536, 11/21/06]


* Fixed a bug in fault deserialization - the 'handled fault' was being
  deserialized before the 'fault'. Since they can sometimes be the same, the
  deserialization would fail due to incorrect order of operations (the fault
  must be deserialized before the handledFault, since the handledFault is only
  a reference to the fault). [ build 537, 11/27/06]

org.activebpel.rt.tamino

* Added some new code for executing Tamino upgrades. I have added some
  additional options in the Tamino Patch file format, such as support for
  "select-into" and "undefine-doctype". This basically makes it easier to
  write Tamino upgrade patches. [ build 45, 11/2/06]


* Remove obsolete process persistence methods and fields that were also
  removed from the org.activebpel.rt.bpel.server project. [ build 46, 11/8/06]

org.activebpel.rt.bpeladmin.help.war

* Final edits for ActiveBPEL engine Admin Console Help for V3 launch [ build
  15, 11/20/06]

org.activebpel.rt.axis.bpel.web

* Update the version of the DTD in web.xml from 2.2 to 2.3 [ build 62,
  11/10/06]

org.activebpel.rt.bpel.server

* Fixed problem where undeploying BPR's in ActiveBPEL engine would leave
  behind WSDL resources. [ build 399, 11/3/06]


* (1) Updated AePddValidator to check for duplicate my role service names [
  build 400, 11/3/06]


* 1. Creating the abx:conversationId header up front in AePartnerAddressing
  when updating partner endpoints. 2. Fix issues in AePartnerAddressing with
  embedded wsa:Action headers in replyTo reference properties. [ build 401,
  11/3/06]


* (1) Defects 2139, 2250; (2) Updated queuing reply receiver class to use the
  rethrowable (makeNewFault) fault for onFault callback; (3) Update
  common-sql.xml to include LocationPath in the select clause for
  "CoordinationStorage.ListCoordinatorsForProcessId" and
  "CoordinationStorage.ListParticipantsForProcessId" queries. [ build 402,
  11/6/06]


* Fix of problem loading external WSDL for deployed services [ build 403,
  11/6/06]


* Defect 2256 - updated AeQueingReplyReceiver - to over-ride
  setBusinessProcessProperties to remove IAeCoordinating.WSCOORD_ID key from
  the properties [ build 404, 11/7/06]


* (1) Add support for journaling pending invokes to fix defect 1191, "Pending
  invokes are not completing after the cluster cleanup delay." (2) Add
  isRunning() method to IAeBusinessProcessEngineInternal and its
  implementations. (3) Fix defects 1527, "Getting an IllegalArgumentException
  when recovery is attempting to be done but the server is in the middle of
  shutting down," and 1475, "You cannot stop the ActiveBPEL engine while it is
  in the middle of recovery." [ build 405, 11/8/06]


* Changed AeQueuingReplyReceiver - moved removal of IAeCoordinating.WSCOORD_ID
  entry from Business process properties to the base class AeReplyReceiverBase
  [ build 406, 11/9/06]


* The AeMasterPolicyMapper will now include the WSA header handler in service
  request chains, rather than adding it to the global configuration since only
  BPEL processes actually handle WSA headers. [ build 407, 11/9/06]


* Changed updatePartnerLink in AeProcessDeployment so the partner endpoint is
  not initialized with WSA information if the message on the receive did not
  contain WSA information. [ build 408, 11/9/06]


* 1. Modified previous change to AeProcessDeployment.updatePartnerLink() to
  test for the presence of a wsa:ReplyTo header rather than the default action
  when determining whether to update the partner link with addressing headers
  that are mandatory for replies under wsa. 2. Fixed issue with creating
  AeMessageContext in AeProcessInvokeHandler where it was not setting up the
  inbound wsa headers properly and was updating the myRole endpoint with
  unwanted info from the invoker's partner role endpoint. [ build 409,
  11/10/06]


* Additional logging of errors during validation. [ build 410, 11/13/06]


* Eliminate extraneous warnings about unconsumed process journal entries when
  recovery completes process execution. [ build 411, 11/14/06]


* Defect 2268 - handle race condition in coordination where A completes before
  receiving B's COMPLETED signal. In this condition, A issues
  CANCEL_or_COMPLETE to B instead of just CANCEL. [ build 412, 11/15/06]


* Fixed issue with catalog event firing on replace entries when dependent on
  other files in deployment. [ build 413, 11/16/06]


* Changed AeQueuingReplyReceiver to validate input arguments [ build 414,
  11/20/06]


* KR code. Updated AeRecoveryEngine and AeRecoveryQueueManager to handle
  AeInvokeTansmittedJournalEntry's and set the recovered transmission id in
  the IAeInvokeInternal (queue obj) [ build 415, 11/21/06]


* Restore the coordination id for a subprocess invoke to the invoke's
  enclosing scope during recovery. [ build 416, 11/21/06]


* IAeProcessDeployment now caches the services to avoid db calls [ build 417,
  11/29/06]


* Display stack traces for the first exception as well as the last exception
  when the retry loops for saving a process or writing a journal entry fail. [
  build 418, 11/29/06]

org.activebpel.rt

* Added helper method to AeUtil to check for not null or empty collections. [
  build 319, 10/16/06]


* Added some QName definitions for several schema simple types. [ build 320,
  10/20/06]


* Fixed problem where imports of project relative resources with spaces in the
  project path were being URL encoded and causing problems during retrieval of
  resource [ build 321, 10/20/06]


* Modify AeXMLParserBase#loadDocumentFromString() not to try to parse an empty
  string, because the WebLogic 9.2 emits an error message to the log as well
  as throwing a parser exception. This was inspired by defect 2141, "I keep
  getting the error [Fatal Error] :-1:-1: Premature end of file. in my
  WebLogic log file running different tests." [ build 322, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  323, 10/25/06]


* Modified AeXMLParserBase.validateDocument() to always turn validation on and
  not rely on it being set, since we are calling validateDocument for the
  purpose of XML validation. [ build 324, 10/26/06]


* Updated to use new method isCompatibleSGElement() to prevent any confusion.
  [ build 325, 10/27/06]


* Simple javadoc change. [ build 326, 11/1/06]


* Fixed equals method on AeSchemaDateTime to check the type before doing a
  further comparison. [ build 327, 11/1/06]


* (1) Defect 2105 updated AeWSDLPrefixes to return default NS prefix for
  abstract processes [ build 328, 11/3/06]


* Added an xml util method "findDefaultNamespace" used to get the in-scope
  default namespace for an Element. [ build 329, 11/4/06]


* 1) added isZero() to AeSchemaDuration [ build 330, 11/6/06]


* Added entry point for xml compare utility to take in to xml documents as
  strings to compare. [ build 331, 11/13/06]

org.activebpel.rt.axis.bpel

* 1. Refactor AeBpelHandler.invokeProcessEngine to check for and create a
  durable reply receiver using information from incomming message context. 2.
  Refactor mapOutputData and mapFaultData methods such that they can be called
  from durable reply receivers. [ build 171, 10/17/06]


* [Merge from 2.1.1] In AeBprDeployment, never set the thread context
  classloader to null, because that may prevent JBoss 4.0.4 from loading
  org.apache.axis.deployment.wsdd.WSDDProvider leading to mysterious
  "Excetpion - java.lang.ExceptionInInitializerError" when generating WSDL or
  handling incoming SOAP messages. [ build 172, 10/18/06]


* Added timestamp param to breakpoint and event handler stubs. [ build 173,
  10/20/06]


* Fix defect 2141, "I keep getting the error [Fatal Error] :-1:-1: Premature
  end of file. in my WebLogic log file running different tests." [ build 174,
  10/24/06]


* Update AeBpelHandler so that synchronous replies contain all mandatory wsa
  reply headers. [ build 175, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  176, 10/25/06]


* Modify RPC encoded sterilizer and invoke handler to handle the RPC call
  between two processes when the message is complex type, also to allow
  messages with substitution group mechanism transfer in the PRC call, both
  for RPC encoded and RPC literal. [ build 177, 10/27/06]


* Use endpoint property, rather than constant to determine wsa namespace. [
  build 178, 10/31/06]


* 1. Moved code to create abx:conversationId header from AeInvokeHandler to
  AePartnerAddressing 2. Added new methods to AeBpelHandler for resolving
  partner link defs, myrole endpoints, and service QName from the SOAPService.
  3. Refactored AeBpelHandler.initServiceDesc() to use new methods [ build
  179, 11/3/06]


* Fix of problem loading external WSDL for deployed services [ build 180,
  11/6/06]


* New AeWsaHeaderHandler that marks ws-addressing headers as processed for the
  must-understand checker. Added the new handler to the global request &
  response chains in client and server wsdd files. [ build 181, 11/7/06]


* Fix bug 2214, modify the serialize() to write the documentElement to the
  aContext directly instead of using the transformer. It is very important to
  enforce setWriteXMLType(null) to make sure the xsi:type attribute is
  properly serialized. [ build 182, 11/7/06]


* Refactored the AeAxisObjectProxyFactory to provide overloaded methods for
  getMessageContextProxy and getSOAPHeaderProxy that take the class object as
  an argument to avoid classloader issues on some Tomcat installations.
  Refactored the AeWsaHeaderHandler so it only proxies the SOAPHeader object
  if really necessary. Removed the WSA Header handler from the global service
  request chain. [ build 183, 11/9/06]


* Fixed problem introduced by resource catalog upgrade in 3.0 where pdd
  refernces to external wsdl services were not being found or used by the
  invoke handler. [ build 184, 11/10/06]


* Changed log message when failure occurs during invoke to include the
  operation name which failed. [ build 185, 11/20/06]

org.activebpel.wsio

* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 28,
  10/25/06]

org.activebpel.rt.tamino

* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 44,
  10/25/06]


* Added some new code for executing Tamino upgrades. I have added some
  additional options in the Tamino Patch file format, such as support for
  "select-into" and "undefine-doctype". This basically makes it easier to
  write Tamino upgrade patches. [ build 45, 11/2/06]


* Remove obsolete process persistence methods and fields that were also
  removed from the org.activebpel.rt.bpel.server project. [ build 46, 11/8/06]

ddl.org.activebpel

* Fix defect 2352, "Slow performance with Oracle after a long load test," by
  adding a new AeProcess index and modifying an AeQueuedReceive index to
  optimize the GetCorrelatedReceives query. [ build 35, 11/30/06]

org.activebpel.rt.axis

* Fixed problem reading nested imported schema references for deployed WSDL
  services [ build 59, 10/20/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 60,
  10/25/06]

org.activebpel.rt.bpeladmin.war

* Added (BPEL 1.1 only) text to the "auto create target path" and "disable
  selction fault" option labels. [ build 183, 10/20/06]


* (1) Defects 2154,2155 (2) Added "BPEL Namespace" property Process Properies
  in the Admin console; (3) Updated process view code to run def preprocessors
  (visitors) before building the visual model [ build 184, 10/24/06]


* Req 148 changes (1) added 'seconds' to time out labels; (2) remove 'path'
  from process properties (process view) [ build 185, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  186, 10/25/06]


* Defect 2198 - exit activity in admin console was displayed as terminated [
  build 187, 10/26/06]


* Added process level termination handler tab to graphical views of process. [
  build 188, 10/30/06]


* (1) Updated code to display message exhanges only if it exists; (2) Added
  Admin Console support for concurrent OnEvent and OnAlarm [ build 189,
  11/3/06]


* 1) changed check for isOneWay to use the consumer message parts map of the
  invoke. This was previously unavailable since the defs weren't preprocessed
  with a WSDLProvider but -- has since changed that. [ build 190, 11/6/06]


* Defect 2256 - show variable element, message or xsd type when viewing a
  variable properties. [ build 191, 11/8/06]


* Fixed a todo - admin console variable (process graph) properties: the
  variable type (element|message|type) QName was displayed as {uri}:localName.
  This has been changed to display prefix:localName along with the ns URI
  (type namespace) as a new property. [ build 192, 11/9/06]


* (a) Defect 2280 AeProcessViewBase: included changes to log Throwable
  errors to console in AeProcessViewBase. Added methods to access process plan
  based on active process or deployed process details view mode; the active
  process plan is based on the QName and process Id; (b) AeProcessViewBean -
  Updated error message that is displayed when the location path is incorrect
  to display the location path as part of the error message. [ build 193,
  11/13/06]


* Uncommented init-params in web.xml (and added maxmemory
  param). [ build 194, 11/14/06]


* (1) Defect 2294 - displaying of message exchanges for bpws 1.1 processes (2)
  Defect 2293 - change "variable access serialiable" property label to read
  "Isolate" for wsbpel processes [ build 195, 11/14/06]


* added ignoreMissingFromData to copy op in admin console [ build 196,
  11/16/06]

org.activebpel.rt.bpel

* (1) clarify any confusion for the fault handler, clean the fault handler
  strategy matrix and add more comments; (2) fixed the bug for catch order
  issue. Fault handler will always find the best match regardless the catch
  order. [ build 494, 10/17/06]


* (1) WS-BPEL treatment of open IMAs. (2) WS-BPEL treatment of the
  compensation handler of an isolated scope. (3) Re-implement link cycle
  detection: includes detecting cycles involving sequences and isolated
  scopes. (4) Remove IAeQueueManager#faultOutstandingReplies; this behavior is
  subsumed by WS-BPEL treatment of open IMAs, which sends faults to all open
  IMAs. (5) Move internally called methods from IAeBusinessProcess to
  IAeBusinessProcessInternal, so that IAeBusinessProcess defines exactly the
  interface required by the engine and the managers. (6) Move thread
  synchronization from AeExecutionQueue to AeBusinessProcess, only on
  IAeBusinessProcess methods. [ build 495, 10/18/06]


* 1) Some refactoring of engine/process events to share common base classes
  and to add a new base class (AeEvent) which adds a Timestamp to all events.
  2) The check start activity visitor now catches start activities within
  While, ForEach, and RepeatEvery loops [ build 496, 10/20/06]


* WSBPEL validation now logs an info message when extensions are in use. Fixed
  a bug in the xpath helper - the proper version of the xpath helper was not
  being returned by getInstance() [ build 497, 10/24/06]


* (1) Defects 2160, 2139, 2156; (2) Added assign-copy strategy for service-ref
  to wsa:epr element copying; (3) Updated AeExpressionLanguageFactory to
  support namespace aliases e.g. map bpel-abstract ns to bpel executable ns;
  (4) Added validator for opaque activity; (5) Update AeActivityInvokeImpl to
  reset transmission id on state change instead of onMessage/onFault callback
  to support retries; (6) Refactored AeWaitableReplyReceiver into
  AeReplyReceiverBase + AeWaitableReplyReceiver (AeQueueingReplyReceiver will
  now extend the base); (7) Enabled basic validation for abstract processes -
  this is currently based on the ws-bpel executable process validation (i.e.
  does not account for ##opaques). [ build 498, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  499, 10/25/06]


* 1) fixed issues with conflicting receives and scoped partner links 2)
  changed how messages are dispatched to receives/onMessag/onEvent in order to
  detect ambiguousReceives 3) added queuing scope to onEvent which is used to
  provide plink info during the queuing. This scope is also used to handle the
  messages until I turn concurrency back on [ build 500, 10/26/06]


* Fix AeProcessDef#findPartnerLink(AePartnerLinkDefKey) to handle partner link
  keys from upgraded 2.1.1 databases where the partnerLinkId will be -1. [
  build 501, 10/27/06]


* Project: org.activebpel.rt.bpel [ build 502, 10/27/06]


* Added ability for WS-BPEL 2.0 processes to use a process level termination
  handler and changed the extension for it and process level compensation to
  http://.../process_coordination. [ build 503, 10/30/06]


* Fixed problem where exceptions thrown from process/engine listeners were
  affecting process execution. [ build 504, 10/31/06]


* 1. Fix issue where the arguments of the abx:getMyRoleProperty function were
  not being validated. 2. Fix issue with cloning elements when adding to
  endpoint reference properties. 3. Removed unnecessary handling of actor and
  mustUnderstand in ws-addressing serializer. 4. Update inbound receive
  serializer/deserializer to use wsa namespace property on the endpoint,
  rather than a constant value for the 2003 namespace. [ build 505, 10/31/06]


* 1) Made endpoint refs cloneable 2) added static analysis for literals (must
  be a TII or EII) 3) all xpath query validation now considers namespaces
  during validation 4) invokes now clone their member data in case any of that
  data were to change while executing the invoke [ build 506, 11/1/06]


* Added validation code for imports to check that the type uri is a valid
  absolute uri. [ build 507, 11/1/06]


* 1) fixed numerous issues with concurrency for onEvents (mostly state saving)
  but left onEvent as synchronous until -- checks in the fixes for the admin
  console 2) left a few comments for things I need to fix before we release 3)
  changed message producer contract to return clone of message data as opposed
  to live variable [ build 508, 11/2/06]


* 1) Added some explicit construction of container defs (partners, partner
  links, links, etc) due to legacy problem with location id creation 2)
  properly skipping the creation of location paths for query def and literal
  def in BPEL 1.1 processes (since these defs do not really exist in a BPEL
  1.1 process) [ build 509, 11/2/06]


* Added additional static analysis check for onAlarm activities within in
  WS-BPEL process. Namely the validator (AeWSBPELOnAlarmValidator) is now
  checking for a required Scope child for onAlarm activities that are defined
  within an event handler. [ build 510, 11/2/06]


* (1) Added process validate for abstract processes to check for required
  abstractProcessProfile attribute; (2) Refactored message exchange visitor
  into two visitors - one implicit visitor and one createInstance entry point
  visitor; (3) Updated base AeAbstractDefPathSegmentVisitor to assign paths to
  message exchanges (bpws impl overrides to not to assign path); (5) Defect
  2219 update process save state visitor and process snapshot visitor to save
  fault hander variables; (6) Enabled the concurrency flag in AeOnEvent [
  build 511, 11/3/06]


* Removed a workaround for determining proper source namespace from
  AeAddressingHeaders that is no longer necessary [ build 512, 11/3/06]


* 1) Added some convenience methods on AeBaseDef to get/set/remove the xmlns
  default namespace decl 2) Added a new conversion visitor that adds a
  potentially missing scope def as the child of an onAlarm in an event handler
  3) Modified the def output layer to be capable of generating prefixed XML
  rather than using a default bpws/bpel namespace (the default is now
  prefixed) [ build 513, 11/4/06]


* (1) Defect 2139; (2) added makeNewFault to AeFaultFactory to clone a fault
  with rethrowable and suspendable flag sets; (3) Updated base reply receiver
  class to use the rethrowable (makeNewFault) fault for onFault callback [
  build 514, 11/6/06]


* Fix of problem loading external WSDL for deployed services [ build 515,
  11/6/06]


* 1) added support for concurrent handling of onAlarm's with repeatEvery 2)
  some refactorings to enable better code sharing between concurrent onEvent
  and onAlarm impls [ build 516, 11/6/06]


* Defect 2248 - when opaque activity def is validated, call super.validate to
  build the target links for validation [ build 517, 11/6/06]


* Merged change for 2.1.2 to fix problem restoring deadpath source link
  status. [ build 518, 11/7/06]


* (1) Add support for journaling pending invokes to fix defect 1191, "Pending
  invokes are not completing after the cluster cleanup delay." (2) Add
  isRunning() method to IAeBusinessProcessEngineInternal and its
  implementations. [ build 519, 11/8/06]


* 1) added format for generic process info events 2) use generic process info
  event for invoke retries, invalid state transitions, and unmatched requests
  3) fixed issue in AeActivityCompensateDef where it wasn't checking for its
  nesting properly 4) added more static analysis for isolated scopes 5)
  changed onEvent scope to init its plink data in ready-to-execute stage [
  build 520, 11/8/06]


* (1) Defect 1558 - updated AeProcessCompensationCallbackWrapper to set the
  process state to faulted (instead of completed) if the process instance
  compensation handler was terminated; (2) In AeReplyReceiverBase - removed
  IAeCoordinating.WSCOORD_ID entry from Business process properties. This was
  previously done in the subclass AeQueuingReplyReceiver, now moved to the
  base [ build 521, 11/9/06]


* Added a protected getter on AeProcessDef that is used only by a unit test. [
  build 522, 11/9/06]


* 1) fixed issue with ambiguousReceive 2) added ae:ambiguousReceive as a
  custom fault to send back to services that send us an ambiguousReceive [
  build 523, 11/9/06]


* Fix defect 2263, "Compensation handlers for isolated scopes are not
  acquiring locks for compensation." [ build 524, 11/9/06]


* Fix defect 2277, "Getting class cast exception when running process level
  compensation." (Yes, I forgot to run the online unit tests last night.) [
  build 525, 11/10/06]


* 1) Additional validation of literals (xsi:schemaLocation) 2) changes some
  validation warnings to errors 3) slightly improved error handling/logging
  during validation [ build 526, 11/13/06]


* 1) added error message for failure during process level variable
  initialization 2) added process info event for process level variable
  initialization failure [ build 527, 11/13/06]


* Fixed recently added constructor for process events which was improperly
  assigning event ids to the process id, which showed up in remote debug
  events. [ build 528, 11/13/06]


* (1) Defect 2294 related - admin console code requires bpws 1.1 processes's
  message exchanges to have location paths; (2) Added
  AeBPWSMessageExchangeDefPathSegmentVisitor to assign paths for bpws 1.1
  process message exhanges (currently used by admin console); (3) Added
  AeDefNullPathVisitor to assign paths for defs which do not already have
  location paths assigned; (4) Added ctor AeDefPathVisitor to take the init
  nextLocationId as a param. [ build 529, 11/14/06]


* rolling back previous change of adding number patterns for PID and EventID
  in eventFormat.properties due to a few events being fired without these
  values and causing errors in the console. Will return after release to track
  down which events are firing without PIDs or EventIds. [ build 530,
  11/14/06]


* Fix defect 2317, "Getting a warning 'Process <num>: completed recovery with
  1 journal entry remaining' when an invoke fails and you restart," by
  overriding setFaultedState() in addition to setState() in
  AeActivityInvokeImpl in order to remove the pending invoke journal entry. [
  build 531, 11/16/06]


* 1) Issue R1 keepSrcElement behavior for virtual <assign>. Virtual copy
  operations for fromPart/toPart use keepSrcElementName behavior 2) Issue R29
  Partner link's initializePartnerRole attribute. Changed attribute to be a
  tri-state bool with default being unset. Added static analysis check for
  attribute on plinks that don't have a partnerRole. Converter no longer sets
  attribute since its not required. 3) R33 Optional XML Data in Assignments.
  Added ignoreMissingFromData to copy operation. [ build 532, 11/16/06]


* Removed warning message about unmatched request as we already log an info
  event with the process about the fact that a request for the process doesn't
  match any current waiting requests. [ build 533, 11/20/06]


* 1) Modified call to AeBusinessProcessEngine.queueReceiveData to return the
  processId to give us more detailed info for logging. 2) Changed
  AeQueuingReplyReceiver to validate input arguments [ build 534, 11/20/06]


* add method setRecoveredTransmissionId(long) to IAeInvokeInternal and to
  impl. AeInvoke (queue obj) to set the transmission id during recovery. [
  build 535, 11/21/06]


* Added 'handledFault' attribute of the AeDefaultFaultHandler class to the
  process state document. [ build 536, 11/21/06]


* Fixed a bug in fault deserialization - the 'handled fault' was being
  deserialized before the 'fault'. Since they can sometimes be the same, the
  deserialization would fail due to incorrect order of operations (the fault
  must be deserialized before the handledFault, since the handledFault is only
  a reference to the fault). [ build 537, 11/27/06]

org.activebpel.rt.bpeladmin.help.war

* Final edits for ActiveBPEL engine Admin Console Help for V3 launch [ build
  15, 11/20/06]

org.activebpel.rt.axis.bpel.web

* Propagate interface and method name changes from org.activebpel.rt.bpel. [
  build 61, 10/18/06]


* Update the version of the DTD in web.xml from 2.2 to 2.3 [ build 62,
  11/10/06]

org.activebpel.rt.bpel.ext.expr

* Javadoc change. [ build 24, 11/1/06]


* Small refactoring in XQuery type mapper to use BigDecimal.valueOf() instead
  of new BigDecimal() [ build 25, 11/1/06]

org.activebpel.rt.bpel.ext.expr.bsf

* Javadoc change. [ build 11, 11/1/06]

org.activebpel.rt.bpel.server

* Update AeQueueStorage.findCorrelatedMatch() such that explicit correlation
  sets may be used in combination with engine managed correlation [ build 387,
  10/17/06]


* (1) Propagate IAeBusinessProcess and IAeQueueManager interface changes. (2)
  WS-BPEL treatment of open IMAs. [ build 388, 10/18/06]


* 1) Incremented the BPEL Admin version (due to the addition of timestamps on
  the event and breakpoint handlers) 2) Added timestamps to the breakpoing and
  event handler interfaces (and remote debug impl object) [ build 389,
  10/20/06]


* Refactoring of reply receivers - updated AeQueueingReplyReceiver to extend
  AeReplyReceiverBase [ build 390, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  391, 10/25/06]


* 1) minor changes in dispatching messages [ build 392, 10/26/06]


* Fixed a couple of issues with AeCatalog management of resources for
  ActiveBPEL product when deploying and undeploying BPR's with same
  locationHint of catalog entries. [ build 393, 10/26/06]


* Fixed problem where JUnit test was failing due to change from last build. [
  build 394, 10/26/06]


* (1) Fix transmission id deserialization in AeInvokeDataJournalEntry and
  AeInvokeFaultJournalEntry; (2) Remove partnerLinkId is null check from
  AeSQLQueueStorageProvider#readSQLMessageReceiver(), because the
  PartnerLinkId column is declared NOT NULL. [ build 395, 10/27/06]


* [Missed a file] (1) Fix transmission id deserialization in
  AeInvokeDataJournalEntry and AeInvokeFaultJournalEntry; (2) Remove
  partnerLinkId is null check from
  AeSQLQueueStorageProvider#readSQLMessageReceiver(), because the
  PartnerLinkId column is declared NOT NULL. [ build 396, 10/27/06]


* 1. Update pdd validation to support multiple wsa namespaces. 2. Fixed issue
  with wsa: headers embedded as reference properties within a reference
  property. [ build 397, 10/31/06]


* Properly roll back process state connection if an exception occurs when
  restoring process state. [ build 398, 11/1/06]


* Fixed problem where undeploying BPR's in ActiveBPEL engine would leave
  behind WSDL resources. [ build 399, 11/3/06]


* (1) Updated AePddValidator to check for duplicate my role service names [
  build 400, 11/3/06]


* 1. Creating the abx:conversationId header up front in AePartnerAddressing
  when updating partner endpoints. 2. Fix issues in AePartnerAddressing with
  embedded wsa:Action headers in replyTo reference properties. [ build 401,
  11/3/06]


* (1) Defects 2139, 2250; (2) Updated queuing reply receiver class to use the
  rethrowable (makeNewFault) fault for onFault callback; (3) Update
  common-sql.xml to include LocationPath in the select clause for
  "CoordinationStorage.ListCoordinatorsForProcessId" and
  "CoordinationStorage.ListParticipantsForProcessId" queries. [ build 402,
  11/6/06]


* Fix of problem loading external WSDL for deployed services [ build 403,
  11/6/06]


* Defect 2256 - updated AeQueingReplyReceiver - to over-ride
  setBusinessProcessProperties to remove IAeCoordinating.WSCOORD_ID key from
  the properties [ build 404, 11/7/06]


* (1) Add support for journaling pending invokes to fix defect 1191, "Pending
  invokes are not completing after the cluster cleanup delay." (2) Add
  isRunning() method to IAeBusinessProcessEngineInternal and its
  implementations. (3) Fix defects 1527, "Getting an IllegalArgumentException
  when recovery is attempting to be done but the server is in the middle of
  shutting down," and 1475, "You cannot stop the ActiveBPEL engine while it is
  in the middle of recovery." [ build 405, 11/8/06]


* Changed AeQueuingReplyReceiver - moved removal of IAeCoordinating.WSCOORD_ID
  entry from Business process properties to the base class AeReplyReceiverBase
  [ build 406, 11/9/06]


* The AeMasterPolicyMapper will now include the WSA header handler in service
  request chains, rather than adding it to the global configuration since only
  BPEL processes actually handle WSA headers. [ build 407, 11/9/06]


* Changed updatePartnerLink in AeProcessDeployment so the partner endpoint is
  not initialized with WSA information if the message on the receive did not
  contain WSA information. [ build 408, 11/9/06]


* 1. Modified previous change to AeProcessDeployment.updatePartnerLink() to
  test for the presence of a wsa:ReplyTo header rather than the default action
  when determining whether to update the partner link with addressing headers
  that are mandatory for replies under wsa. 2. Fixed issue with creating
  AeMessageContext in AeProcessInvokeHandler where it was not setting up the
  inbound wsa headers properly and was updating the myRole endpoint with
  unwanted info from the invoker's partner role endpoint. [ build 409,
  11/10/06]


* Additional logging of errors during validation. [ build 410, 11/13/06]


* Eliminate extraneous warnings about unconsumed process journal entries when
  recovery completes process execution. [ build 411, 11/14/06]


* Defect 2268 - handle race condition in coordination where A completes before
  receiving B's COMPLETED signal. In this condition, A issues
  CANCEL_or_COMPLETE to B instead of just CANCEL. [ build 412, 11/15/06]


* Fixed issue with catalog event firing on replace entries when dependent on
  other files in deployment. [ build 413, 11/16/06]


* Changed AeQueuingReplyReceiver to validate input arguments [ build 414,
  11/20/06]


* Updated AeRecoveryEngine and AeRecoveryQueueManager to handle
  AeInvokeTansmittedJournalEntry's and set the recovered transmission id in
  the IAeInvokeInternal (queue obj) [ build 415, 11/21/06]


* Restore the coordination id for a subprocess invoke to the invoke's
  enclosing scope during recovery. [ build 416, 11/21/06]


* IAeProcessDeployment now caches the services to avoid db calls [ build 417,
  11/29/06]


* Display stack traces for the first exception as well as the last exception
  when the retry loops for saving a process or writing a journal entry fail. [
  build 418, 11/29/06]


* Apply optimizer hint for "SELECT LocationId, VersionNumber FROM AeVariable
  WHERE ProcessId = ?" query when running on Oracle, because Oracle is very
  flakey about how it executes this query. This seems to solve very
  inconsistent performance results with Oracle, especially (for an unknown
  reason) running from JBoss. [ build 419, 12/4/06]

ActiveBPEL engine v3.0.0 0 (20061201) 
 
ddl.org.activebpel

* Fix defect 2352, "Slow performance with Oracle after a long load test," by
  adding a new AeProcess index and modifying an AeQueuedReceive index to
  optimize the GetCorrelatedReceives query. [ build 35, 11/30/06]

org.activebpel.rt

* Fixed equals method on AeSchemaDateTime to check the type before doing a
  further comparison. [ build 327, 11/1/06]


* (1) Defect 2105 updated AeWSDLPrefixes to return default NS prefix for
  abstract processes [ build 328, 11/3/06]


* Added an xml util method "findDefaultNamespace" used to get the in-scope
  default namespace for an Element. [ build 329, 11/4/06]


* 1) added isZero() to AeSchemaDuration [ build 330, 11/6/06]


* Added entry point for xml compare utility to take in to xml documents as
  strings to compare. [ build 331, 11/13/06]

org.activebpel.rt.axis.bpel

* 1. Moved code to create abx:conversationId header from AeInvokeHandler to
  AePartnerAddressing 2. Added new methods to AeBpelHandler for resolving
  partner link defs, myrole endpoints, and service QName from the SOAPService.
  3. Refactored AeBpelHandler.initServiceDesc() to use new methods [ build
  179, 11/3/06]


* Fix of problem loading external WSDL for deployed services [ build 180,
  11/6/06]


* New AeWsaHeaderHandler that marks ws-addressing headers as processed for the
  must-understand checker. Added the new handler to the global request &
  response chains in client and server wsdd files. [ build 181, 11/7/06]


* Fix bug 2214, modify the serialize() to write the documentElement to the
  aContext directly instead of using the transformer. It is very important to
  enforce setWriteXMLType(null) to make sure the xsi:type attribute is
  properly serialized. [ build 182, 11/7/06]


* Refactored the AeAxisObjectProxyFactory to provide overloaded methods for
  getMessageContextProxy and getSOAPHeaderProxy that take the class object as
  an argument to avoid classloader issues on some Tomcat installations.
  Refactored the AeWsaHeaderHandler so it only proxies the SOAPHeader object
  if really necessary. Removed the WSA Header handler from the global service
  request chain. [ build 183, 11/9/06]


* Fixed problem introduced by resource catalog upgrade in 3.0 where pdd
  refernces to external wsdl services were not being found or used by the
  invoke handler. [ build 184, 11/10/06]


* Changed log message when failure occurs during invoke to include the
  operation name which failed. [ build 185, 11/20/06]

org.activebpel.rt.bpeladmin.war

* (1) Updated code to display message exhanges only if it exists; (2) Added
  Admin Console support for concurrent OnEvent and OnAlarm [ build 189,
  11/3/06]


* 1) changed check for isOneWay to use the consumer message parts map of the
  invoke. This was previously unavailable since the defs weren't preprocessed
  with a WSDLProvider but PJ has since changed that. [ build 190, 11/6/06]


* Defect 2256 - show variable element, message or xsd type when viewing a
  variable properties. [ build 191, 11/8/06]


* Fixed a todo - admin console variable (process graph) properties: the
  variable type (element|message|type) QName was displayed as {uri}:localName.
  This has been changed to display prefix:localName along with the ns URI
  (type namespace) as a new property. [ build 192, 11/9/06]


* (a) Defect 2280 AeProcessViewBase: included changes per KR to log Throwable
  errors to console in AeProcessViewBase. Added methods to access process plan
  based on active process or deployed process details view mode; the active
  process plan is based on the QName and process Id; (b) AeProcessViewBean -
  Updated error message that is displayed when the location path is incorrect
  to display the location path as part of the error message. [ build 193,
  11/13/06]


* Uncommented init-params in web.xml (and added maxmemory
  param). [ build 194, 11/14/06]


* (1) Defect 2294 - displaying of message exchanges for bpws 1.1 processes (2)
  Defect 2293 - change "variable access serialiable" property label to read
  "Isolate" for wsbpel processes [ build 195, 11/14/06]


* added ignoreMissingFromData to copy op in admin console [ build 196,
  11/16/06]

org.activebpel.rt.bpel

* Added validation code for imports to check that the type uri is a valid
  absolute uri. [ build 507, 11/1/06]


* 1) fixed numerous issues with concurrency for onEvents (mostly state saving)
  but left onEvent as synchronous until PJ checks in the fixes for the admin
  console 2) left a few comments for things I need to fix before we release 3)
  changed message producer contract to return clone of message data as opposed
  to live variable [ build 508, 11/2/06]


* 1) Added some explicit construction of container defs (partners, partner
  links, links, etc) due to legacy problem with location id creation 2)
  properly skipping the creation of location paths for query def and literal
  def in BPEL 1.1 processes (since these defs do not really exist in a BPEL
  1.1 process) [ build 509, 11/2/06]


* Added additional static analysis check for onAlarm activities within in
  WS-BPEL process. Namely the validator (AeWSBPELOnAlarmValidator) is now
  checking for a required Scope child for onAlarm activities that are defined
  within an event handler. [ build 510, 11/2/06]


* (1) Added process validate for abstract processes to check for required
  abstractProcessProfile attribute; (2) Refactored message exchange visitor
  into two visitors - one implicit visitor and one createInstance entry point
  visitor; (3) Updated base AeAbstractDefPathSegmentVisitor to assign paths to
  message exchanges (bpws impl overrides to not to assign path); (5) Defect
  2219 update process save state visitor and process snapshot visitor to save
  fault hander variables; (6) Enabled the concurrency flag in AeOnEvent [
  build 511, 11/3/06]


* Removed a workaround for determining proper source namespace from
  AeAddressingHeaders that is no longer necessary [ build 512, 11/3/06]


* 1) Added some convenience methods on AeBaseDef to get/set/remove the xmlns
  default namespace decl 2) Added a new conversion visitor that adds a
  potentially missing scope def as the child of an onAlarm in an event handler
  3) Modified the def output layer to be capable of generating prefixed XML
  rather than using a default bpws/bpel namespace (the default is now
  prefixed) [ build 513, 11/4/06]


* (1) Defect 2139; (2) added makeNewFault to AeFaultFactory to clone a fault
  with rethrowable and suspendable flag sets; (3) Updated base reply receiver
  class to use the rethrowable (makeNewFault) fault for onFault callback [
  build 514, 11/6/06]


* Fix of problem loading external WSDL for deployed services [ build 515,
  11/6/06]


* 1) added support for concurrent handling of onAlarm's with repeatEvery 2)
  some refactorings to enable better code sharing between concurrent onEvent
  and onAlarm impls [ build 516, 11/6/06]


* Defect 2248 - when opaque activity def is validated, call super.validate to
  build the target links for validation [ build 517, 11/6/06]


* Merged change for 2.1.2 to fix problem restoring deadpath source link
  status. [ build 518, 11/7/06]


* (1) Add support for journaling pending invokes to fix defect 1191, "Pending
  invokes are not completing after the cluster cleanup delay." (2) Add
  isRunning() method to IAeBusinessProcessEngineInternal and its
  implementations. [ build 519, 11/8/06]


* 1) added format for generic process info events 2) use generic process info
  event for invoke retries, invalid state transitions, and unmatched requests
  3) fixed issue in AeActivityCompensateDef where it wasn't checking for its
  nesting properly 4) added more static analysis for isolated scopes 5)
  changed onEvent scope to init its plink data in ready-to-execute stage [
  build 520, 11/8/06]


* (1) Defect 1558 - updated AeProcessCompensationCallbackWrapper to set the
  process state to faulted (instead of completed) if the process instance
  compensation handler was terminated; (2) In AeReplyReceiverBase - removed
  IAeCoordinating.WSCOORD_ID entry from Business process properties. This was
  previously done in the subclass AeQueuingReplyReceiver, now moved to the
  base [ build 521, 11/9/06]


* Added a protected getter on AeProcessDef that is used only by a unit test. [
  build 522, 11/9/06]


* 1) fixed issue with ambiguousReceive 2) added ae:ambiguousReceive as a
  custom fault to send back to services that send us an ambiguousReceive [
  build 523, 11/9/06]


* Fix defect 2263, "Compensation handlers for isolated scopes are not
  acquiring locks for compensation." [ build 524, 11/9/06]


* Fix defect 2277, "Getting class cast exception when running process level
  compensation." (Yes, I forgot to run the online unit tests last night.) [
  build 525, 11/10/06]


* 1) Additional validation of literals (xsi:schemaLocation) 2) changes some
  validation warnings to errors 3) slightly improved error handling/logging
  during validation [ build 526, 11/13/06]


* 1) added error message for failure during process level variable
  initialization 2) added process info event for process level variable
  initialization failure [ build 527, 11/13/06]


* Fixed recently added constructor for process events which was improperly
  assigning event ids to the process id, which showed up in remote debug
  events. [ build 528, 11/13/06]


* (1) Defect 2294 related - admin console code requires bpws 1.1 processes's
  message exchanges to have location paths; (2) Added
  AeBPWSMessageExchangeDefPathSegmentVisitor to assign paths for bpws 1.1
  process message exhanges (currently used by admin console); (3) Added
  AeDefNullPathVisitor to assign paths for defs which do not already have
  location paths assigned; (4) Added ctor AeDefPathVisitor to take the init
  nextLocationId as a param. [ build 529, 11/14/06]


* rolling back previous change of adding number patterns for PID and EventID
  in eventFormat.properties due to a few events being fired without these
  values and causing errors in the console. Will return after release to track
  down which events are firing without PIDs or EventIds. [ build 530,
  11/14/06]


* Fix defect 2317, "Getting a warning 'Process <num>: completed recovery with
  1 journal entry remaining' when an invoke fails and you restart," by
  overriding setFaultedState() in addition to setState() in
  AeActivityInvokeImpl in order to remove the pending invoke journal entry. [
  build 531, 11/16/06]


* 1) Issue R1 keepSrcElement behavior for virtual <assign>. Virtual copy
  operations for fromPart/toPart use keepSrcElementName behavior 2) Issue R29
  Partner link's initializePartnerRole attribute. Changed attribute to be a
  tri-state bool with default being unset. Added static analysis check for
  attribute on plinks that don't have a partnerRoe. Converter no longer sets
  attribute since its not required. 3) R33 Optional XML Data in Assignments.
  Added ignoreMissingFromData to copy operation. [ build 532, 11/16/06]


* Removed warning message about unmatched request as we already log an info
  event with the process about the fact that a request for the process doesn't
  match any current waiting requests. [ build 533, 11/20/06]


* 1) Modified call to AeBusinessProcessEngine.queueReceiveData to return the
  processId to give us more detailed info for logging. 2) Changed
  AeQueuingReplyReceiver to validate input arguments [ build 534, 11/20/06]


* add method setRecoveredTransmissionId(long) to IAeInvokeInternal and to
  impl. AeInvoke (queue obj) to set the transmission id during recovery. [
  build 535, 11/21/06]


* Added 'handledFault' attribute of the AeDefaultFaultHandler class to the
  process state document. [ build 536, 11/21/06]


* Fixed a bug in fault deserialization - the 'handled fault' was being
  deserialized before the 'fault'. Since they can sometimes be the same, the
  deserialization would fail due to incorrect order of operations (the fault
  must be deserialized before the handledFault, since the handledFault is only
  a reference to the fault). [ build 537, 11/27/06]

org.activebpel.rt.tamino

* Added some new code for executing Tamino upgrades. I have added some
  additional options in the Tamino Patch file format, such as support for
  "select-into" and "undefine-doctype". This basically makes it easier to
  write Tamino upgrade patches. [ build 45, 11/2/06]


* Remove obsolete process persistence methods and fields that were also
  removed from the org.activebpel.rt.bpel.server project. [ build 46, 11/8/06]

org.activebpel.rt.bpeladmin.help.war

* Final edits for ActiveBPEL engine Admin Console Help for V3 launch [ build
  15, 11/20/06]

org.activebpel.rt.axis.bpel.web

* Update the version of the DTD in web.xml from 2.2 to 2.3 [ build 62,
  11/10/06]

org.activebpel.rt.bpel.server

* Fixed problem where undeploying BPR's in ActiveBPEL engine would leave
  behind WSDL resources. [ build 399, 11/3/06]


* (1) Updated AePddValidator to check for duplicate my role service names [
  build 400, 11/3/06]


* 1. Creating the abx:conversationId header up front in AePartnerAddressing
  when updating partner endpoints. 2. Fix issues in AePartnerAddressing with
  embedded wsa:Action headers in replyTo reference properties. [ build 401,
  11/3/06]


* (1) Defects 2139, 2250; (2) Updated queuing reply receiver class to use the
  rethrowable (makeNewFault) fault for onFault callback; (3) Update
  common-sql.xml to include LocationPath in the select clause for
  "CoordinationStorage.ListCoordinatorsForProcessId" and
  "CoordinationStorage.ListParticipantsForProcessId" queries. [ build 402,
  11/6/06]


* Fix of problem loading external WSDL for deployed services [ build 403,
  11/6/06]


* Defect 2256 - updated AeQueingReplyReceiver - to over-ride
  setBusinessProcessProperties to remove IAeCoordinating.WSCOORD_ID key from
  the properties [ build 404, 11/7/06]


* (1) Add support for journaling pending invokes to fix defect 1191, "Pending
  invokes are not completing after the cluster cleanup delay." (2) Add
  isRunning() method to IAeBusinessProcessEngineInternal and its
  implementations. (3) Fix defects 1527, "Getting an IllegalArgumentException
  when recovery is attempting to be done but the server is in the middle of
  shutting down," and 1475, "You cannot stop the ActiveBPEL engine while it is
  in the middle of recovery." [ build 405, 11/8/06]


* Changed AeQueuingReplyReceiver - moved removal of IAeCoordinating.WSCOORD_ID
  entry from Business process properties to the base class AeReplyReceiverBase
  [ build 406, 11/9/06]


* The AeMasterPolicyMapper will now include the WSA header handler in service
  request chains, rather than adding it to the global configuration since only
  BPEL processes actually handle WSA headers. [ build 407, 11/9/06]


* Changed updatePartnerLink in AeProcessDeployment so the partner endpoint is
  not initialized with WSA information if the message on the receive did not
  contain WSA information. [ build 408, 11/9/06]


* 1. Modified previous change to AeProcessDeployment.updatePartnerLink() to
  test for the presence of a wsa:ReplyTo header rather than the default action
  when determining whether to update the partner link with addressing headers
  that are mandatory for replies under wsa. 2. Fixed issue with creating
  AeMessageContext in AeProcessInvokeHandler where it was not setting up the
  inbound wsa headers properly and was updating the myRole endpoint with
  unwanted info from the invoker's partner role endpoint. [ build 409,
  11/10/06]


* Additional logging of errors during validation. [ build 410, 11/13/06]


* Eliminate extraneous warnings about unconsumed process journal entries when
  recovery completes process execution. [ build 411, 11/14/06]


* Defect 2268 - handle race condition in coordination where A completes before
  receiving B's COMPLETED signal. In this condition, A issues
  CANCEL_or_COMPLETE to B instead of just CANCEL. [ build 412, 11/15/06]


* Fixed issue with catalog event firing on replace entries when dependent on
  other files in deployment. [ build 413, 11/16/06]


* Changed AeQueuingReplyReceiver to validate input arguments [ build 414,
  11/20/06]


* KR code. Updated AeRecoveryEngine and AeRecoveryQueueManager to handle
  AeInvokeTansmittedJournalEntry's and set the recovered transmission id in
  the IAeInvokeInternal (queue obj) [ build 415, 11/21/06]


* Restore the coordination id for a subprocess invoke to the invoke's
  enclosing scope during recovery. [ build 416, 11/21/06]


* IAeProcessDeployment now caches the services to avoid db calls [ build 417,
  11/29/06]


* Display stack traces for the first exception as well as the last exception
  when the retry loops for saving a process or writing a journal entry fail. [
  build 418, 11/29/06]

ActiveBPEL engine v3.0.0 0 (20061201) 
 
ActiveBPEL engine v3.0.0 9 (20061101) 
 
org.activebpel.rt.axis

* Fixed problem reading nested imported schema references for deployed WSDL
  services [ build 59, 10/20/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 60,
  10/25/06]

org.activebpel.rt

* added antoher convenience methof for SG: isCompatibleSGElement() [ build
  317, 10/12/06]


* base64 binary and hex binary schema classes now parse their data into byte
  arrays. They each have accessors for getting the parsed-out data. [ build
  318, 10/12/06]


* Added helper method to AeUtil to check for not null or empty collections. [
  build 319, 10/16/06]


* Added some QName definitions for several schema simple types. [ build 320,
  10/20/06]


* Fixed problem where imports of project relative resources with spaces in the
  project path were being URL encoded and causing problems during retrieval of
  resource [ build 321, 10/20/06]


* Modify AeXMLParserBase#loadDocumentFromString() not to try to parse an empty
  string, because the WebLogic 9.2 emits an error message to the log as well
  as throwing a parser exception. This was inspired by defect 2141, "I keep
  getting the error [Fatal Error] :-1:-1: Premature end of file. in my
  WebLogic log file running different tests." [ build 322, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  323, 10/25/06]


* Modified AeXMLParserBase.validateDocument() to always turn validation on and
  not rely on it being set, since we are calling validateDocument for the
  purpose of XML validation. [ build 324, 10/26/06]


* Updated to use new method isCompatibleSGElement() to prevent any confusion.
  [ build 325, 10/27/06]

org.activebpel.rt.axis.bpel

* 1. Refactor AeBpelHandler.invokeProcessEngine to check for and create a
  durable reply receiver using information from incomming message context. 2.
  Refactor mapOutputData and mapFaultData methods such that they can be called
  from durable reply receivers. [ build 171, 10/17/06]


* [Merge from 2.1.1] In AeBprDeployment, never set the thread context
  classloader to null, because that may prevent JBoss 4.0.4 from loading
  org.apache.axis.deployment.wsdd.WSDDProvider leading to mysterious
  "Excetpion - java.lang.ExceptionInInitializerError" when generating WSDL or
  handling incoming SOAP messages. [ build 172, 10/18/06]


* Added timestamp param to breakpoint and event handler stubs. [ build 173,
  10/20/06]


* Fix defect 2141, "I keep getting the error [Fatal Error] :-1:-1: Premature
  end of file. in my WebLogic log file running different tests." [ build 174,
  10/24/06]


* Update AeBpelHandler so that synchronous replies contain all mandatory wsa
  reply headers. [ build 175, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  176, 10/25/06]


* Modify RPC encoded sterilizer and invoke handler to handle the RPC call
  between two processes when the message is complex type, also to allow
  messages with substitution group mechanism transfer in the PRC call, both
  for RPC encoded and RPC literal. [ build 177, 10/27/06]


* Use endpoint property, rather than constant to determine wsa namespace. [
  build 178, 10/31/06]

org.activebpel.rt.bpeladmin.war

* Change due to interface change (def visitor interface). [ build 182,
  10/12/06]


* Added (BPEL 1.1 only) text to the "auto create target path" and "disable
  selction fault" option labels. [ build 183, 10/20/06]


* (1) Defects 2154,2155 (2) Added "BPEL Namespace" property Process Properies
  in the Admin console; (3) Updated process view code to run def preprocessors
  (visitors) before building the visual model [ build 184, 10/24/06]


* Req 148 changes (1) added 'seconds' to time out labels; (2) remove 'path'
  from process properties (process view) [ build 185, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  186, 10/25/06]


* Defect 2198 - exit activity in admin console was displayed as terminated [
  build 187, 10/26/06]


* Added process level termination handler tab to graphical views of process. [
  build 188, 10/30/06]

org.activebpel.rt.bpel

* Added fault handler validation process to prevent identical matches in a
  fault handler. The validation is distinct between WS-BPEL and BPWS, the
  former will not consider the fault variables. For WS-BPEL, static analysis
  will report error message, for BPWS, it will report warning message. [ build
  492, 10/12/06]


* 1) Refactorings: findPartnerLink -> findProcessPartnerLink,
  getPartnerLink(String name) -> findPartnerLink(String name) 2) Improved def
  i/o layer for reading attributes - attributes are now 'consumed' as they are
  read. Any attribute that is not read by the def i/o reader visitors is
  considered an extensibility attribute, even if it is unqualified 3)
  extension elements and extension attributes are now defs which are traversed
  and visited - this makes i/o easier and more consistent 4) implemented
  process level termination handler as an extension 5) added
  getDoXslTransformStylesheets() to the expression analyzer interface and
  impls 6) removed the extension registry in favor of a more unified BPEL
  registry (the extension registry wasn't being used) 7) cleaned up extension
  validation code now that extension elements and attributes are defs 8) XPath
  query validator is now namespace aware [ build 493, 10/12/06]


* (1) clarify any confusion for the fault handler, clean the fault handler
  strategy matrix and add more comments; (2) fixed the bug for catch order
  issue. Fault handler will always find the best match regardless the catch
  order. [ build 494, 10/17/06]


* (1) WS-BPEL treatment of open IMAs. (2) WS-BPEL treatment of the
  compensation handler of an isolated scope. (3) Re-implement link cycle
  detection: includes detecting cycles involving sequences and isolated
  scopes. (4) Remove IAeQueueManager#faultOutstandingReplies; this behavior is
  subsumed by WS-BPEL treatment of open IMAs, which sends faults to all open
  IMAs. (5) Move internally called methods from IAeBusinessProcess to
  IAeBusinessProcessInternal, so that IAeBusinessProcess defines exactly the
  interface required by the engine and the managers. (6) Move thread
  synchronization from AeExecutionQueue to AeBusinessProcess, only on
  IAeBusinessProcess methods. [ build 495, 10/18/06]


* 1) Some refactoring of engine/process events to share common base classes
  and to add a new base class (AeEvent) which adds a Timestamp to all events.
  2) The check start activity visitor now catches start activities within
  While, ForEach, and RepeatEvery loops [ build 496, 10/20/06]


* WSBPEL validation now logs an info message when extensions are in use. Fixed
  a bug in the xpath helper - the proper version of the xpath helper was not
  being returned by getInstance() [ build 497, 10/24/06]


* (1) Defects 2160, 2139, 2156; (2) Added assign-copy strategy for service-ref
  to wsa:epr element copying; (3) Updated AeExpressionLanguageFactory to
  support namespace aliases e.g. map bpel-abstract ns to bpel executable ns;
  (4) Added validator for opaque activity; (5) Update AeActivityInvokeImpl to
  reset transmission id on state change instead of onMessage/onFault callback
  to support retries; (6) Refactored AeWaitableReplyReceiver into
  AeReplyReceiverBase + AeWaitableReplyReceiver (AeQueueingReplyReceiver will
  now extend the base); (7) Enabled basic validation for abstract processes -
  this is currently based on the ws-bpel executable process validation (i.e.
  does not account for ##opaques). [ build 498, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  499, 10/25/06]


* 1) fixed issues with conflicting receives and scoped partner links 2)
  changed how messages are dispatched to receives/onMessag/onEvent in order to
  detect ambiguousReceives 3) added queuing scope to onEvent which is used to
  provide plink info during the queuing. This scope is also used to handle the
  messages until I turn concurrency back on [ build 500, 10/26/06]


* Fix AeProcessDef#findPartnerLink(AePartnerLinkDefKey) to handle partner link
  keys from upgraded 2.1.1 databases where the partnerLinkId will be -1. [
  build 501, 10/27/06]


* Project: org.activebpel.rt.bpel [ build 502, 10/27/06]


* Added ability for WS-BPEL 2.0 processes to use a process level termination
  handler and changed the extension for it and process level compensation to
  http://.../process_coordination. [ build 503, 10/30/06]


* Fixed problem where exceptions thrown from process/engine listeners were
  affecting process execution. [ build 504, 10/31/06]


* 1. Fix issue where the arguments of the abx:getMyRoleProperty function were
  not being validated. 2. Fix issue with cloning elements when adding to
  endpoint reference properties. 3. Removed unnecessary handling of actor and
  mustUnderstand in ws-addressing serializer. 4. Update inbound receive
  serializer/deserializer to use wsa namespace property on the endpoint,
  rather than a constant value for the 2003 namespace. [ build 505, 10/31/06]

org.activebpel.wsio

* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 28,
  10/25/06]

org.activebpel.rt.tamino

* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 44,
  10/25/06]

org.activebpel.rt.bpel.ext.expr

* Minor changes - mostly documentation and a couple of null pointer checks. [
  build 23, 10/12/06]

org.activebpel.rt.axis.bpel.web

* Propagate interface and method name changes from org.activebpel.rt.bpel. [
  build 61, 10/18/06]

org.activebpel.rt.bpel.server

* Update AeQueueStorage.findCorrelatedMatch() such that explicit correlation
  sets may be used in combination with engine managed correlation [ build 387,
  10/17/06]


* (1) Propagate IAeBusinessProcess and IAeQueueManager interface changes. (2)
  WS-BPEL treatment of open IMAs. [ build 388, 10/18/06]


* 1) Incremented the BPEL Admin version (due to the addition of timestamps on
  the event and breakpoint handlers) 2) Added timestamps to the breakpoing and
  event handler interfaces (and remote debug impl object) [ build 389,
  10/20/06]


* Refactoring of reply receivers - updated AeQueueingReplyReceiver to extend
  AeReplyReceiverBase [ build 390, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  391, 10/25/06]


* 1) minor changes in dispatching messages [ build 392, 10/26/06]


* Fixed a couple of issues with AeCatalog management of resources for
  ActiveBPEL product when deploying and undeploying BPR's with same
  locationHint of catalog entries. [ build 393, 10/26/06]


* Fixed problem where JUnit test was failing due to change from last build. [
  build 394, 10/26/06]


* (1) Fix transmission id deserialization in AeInvokeDataJournalEntry and
  AeInvokeFaultJournalEntry; (2) Remove partnerLinkId is null check from
  AeSQLQueueStorageProvider#readSQLMessageReceiver(), because the
  PartnerLinkId column is declared NOT NULL. [ build 395, 10/27/06]


* [Missed a file] (1) Fix transmission id deserialization in
  AeInvokeDataJournalEntry and AeInvokeFaultJournalEntry; (2) Remove
  partnerLinkId is null check from
  AeSQLQueueStorageProvider#readSQLMessageReceiver(), because the
  PartnerLinkId column is declared NOT NULL. [ build 396, 10/27/06]


* 1. Update pdd validation to support multiple wsa namespaces. 2. Fixed issue
  with wsa: headers embedded as reference properties within a reference
  property. [ build 397, 10/31/06]

ActiveBPEL engine v3.0.0 9 (20061101) 
 
org.activebpel.rt.axis

* Fixed problem reading nested imported schema references for deployed WSDL
  services [ build 59, 10/20/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 60,
  10/25/06]

org.activebpel.rt

* added antoher convenience methof for SG: isCompatibleSGElement() [ build
  317, 10/12/06]


* base64 binary and hex binary schema classes now parse their data into byte
  arrays. They each have accessors for getting the parsed-out data. [ build
  318, 10/12/06]


* Added helper method to AeUtil to check for not null or empty collections. [
  build 319, 10/16/06]


* Added some QName definitions for several schema simple types. [ build 320,
  10/20/06]


* Fixed problem where imports of project relative resources with spaces in the
  project path were being URL encoded and causing problems during retrieval of
  resource [ build 321, 10/20/06]


* Modify AeXMLParserBase#loadDocumentFromString() not to try to parse an empty
  string, because the WebLogic 9.2 emits an error message to the log as well
  as throwing a parser exception. This was inspired by defect 2141, "I keep
  getting the error [Fatal Error] :-1:-1: Premature end of file. in my
  WebLogic log file running different tests." [ build 322, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  323, 10/25/06]


* Modified AeXMLParserBase.validateDocument() to always turn validation on and
  not rely on it being set, since we are calling validateDocument for the
  purpose of XML validation. [ build 324, 10/26/06]


* Updated to use new method isCompatibleSGElement() to prevent any confusion.
  [ build 325, 10/27/06]

org.activebpel.rt.axis.bpel

* 1. Refactor AeBpelHandler.invokeProcessEngine to check for and create a
  durable reply receiver using information from incomming message context. 2.
  Refactor mapOutputData and mapFaultData methods such that they can be called
  from durable reply receivers. [ build 171, 10/17/06]


* [Merge from 2.1.1] In AeBprDeployment, never set the thread context
  classloader to null, because that may prevent JBoss 4.0.4 from loading
  org.apache.axis.deployment.wsdd.WSDDProvider leading to mysterious
  "Excetpion - java.lang.ExceptionInInitializerError" when generating WSDL or
  handling incoming SOAP messages. [ build 172, 10/18/06]


* Added timestamp param to breakpoint and event handler stubs. [ build 173,
  10/20/06]


* Fix defect 2141, "I keep getting the error [Fatal Error] :-1:-1: Premature
  end of file. in my WebLogic log file running different tests." [ build 174,
  10/24/06]


* Update AeBpelHandler so that synchronous replies contain all mandatory wsa
  reply headers. [ build 175, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  176, 10/25/06]


* Modify RPC encoded sterilizer and invoke handler to handle the RPC call
  between two processes when the message is complex type, also to allow
  messages with substitution group mechanism transfer in the PRC call, both
  for RPC encoded and RPC literal. [ build 177, 10/27/06]


* Use endpoint property, rather than constant to determine wsa namespace. [
  build 178, 10/31/06]

org.activebpel.rt.bpeladmin.war

* Change due to interface change (def visitor interface). [ build 182,
  10/12/06]


* Added (BPEL 1.1 only) text to the "auto create target path" and "disable
  selction fault" option labels. [ build 183, 10/20/06]


* (1) Defects 2154,2155 (2) Added "BPEL Namespace" property Process Properies
  in the Admin console; (3) Updated process view code to run def preprocessors
  (visitors) before building the visual model [ build 184, 10/24/06]


* Req 148 changes (1) added 'seconds' to time out labels; (2) remove 'path'
  from process properties (process view) [ build 185, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  186, 10/25/06]


* Defect 2198 - exit activity in admin console was displayed as terminated [
  build 187, 10/26/06]


* Added process level termination handler tab to graphical views of process. [
  build 188, 10/30/06]

org.activebpel.rt.bpel

* Added fault handler validation process to prevent identical matches in a
  fault handler. The validation is distinct between WS-BPEL and BPWS, the
  former will not consider the fault variables. For WS-BPEL, static analysis
  will report error message, for BPWS, it will report warning message. [ build
  492, 10/12/06]


* 1) Refactorings: findPartnerLink -> findProcessPartnerLink,
  getPartnerLink(String name) -> findPartnerLink(String name) 2) Improved def
  i/o layer for reading attributes - attributes are now 'consumed' as they are
  read. Any attribute that is not read by the def i/o reader visitors is
  considered an extensibility attribute, even if it is unqualified 3)
  extension elements and extension attributes are now defs which are traversed
  and visited - this makes i/o easier and more consistent 4) implemented
  process level termination handler as an extension 5) added
  getDoXslTransformStylesheets() to the expression analyzer interface and
  impls 6) removed the extension registry in favor of a more unified BPEL
  registry (the extension registry wasn't being used) 7) cleaned up extension
  validation code now that extension elements and attributes are defs 8) XPath
  query validator is now namespace aware [ build 493, 10/12/06]


* (1) clarify any confusion for the fault handler, clean the fault handler
  strategy matrix and add more comments; (2) fixed the bug for catch order
  issue. Fault handler will always find the best match regardless the catch
  order. [ build 494, 10/17/06]


* (1) WS-BPEL treatment of open IMAs. (2) WS-BPEL treatment of the
  compensation handler of an isolated scope. (3) Re-implement link cycle
  detection: includes detecting cycles involving sequences and isolated
  scopes. (4) Remove IAeQueueManager#faultOutstandingReplies; this behavior is
  subsumed by WS-BPEL treatment of open IMAs, which sends faults to all open
  IMAs. (5) Move internally called methods from IAeBusinessProcess to
  IAeBusinessProcessInternal, so that IAeBusinessProcess defines exactly the
  interface required by the engine and the managers. (6) Move thread
  synchronization from AeExecutionQueue to AeBusinessProcess, only on
  IAeBusinessProcess methods. [ build 495, 10/18/06]


* 1) Some refactoring of engine/process events to share common base classes
  and to add a new base class (AeEvent) which adds a Timestamp to all events.
  2) The check start activity visitor now catches start activities within
  While, ForEach, and RepeatEvery loops [ build 496, 10/20/06]


* WSBPEL validation now logs an info message when extensions are in use. Fixed
  a bug in the xpath helper - the proper version of the xpath helper was not
  being returned by getInstance() [ build 497, 10/24/06]


* (1) Defects 2160, 2139, 2156; (2) Added assign-copy strategy for service-ref
  to wsa:epr element copying; (3) Updated AeExpressionLanguageFactory to
  support namespace aliases e.g. map bpel-abstract ns to bpel executable ns;
  (4) Added validator for opaque activity; (5) Update AeActivityInvokeImpl to
  reset transmission id on state change instead of onMessage/onFault callback
  to support retries; (6) Refactored AeWaitableReplyReceiver into
  AeReplyReceiverBase + AeWaitableReplyReceiver (AeQueueingReplyReceiver will
  now extend the base); (7) Enabled basic validation for abstract processes -
  this is currently based on the ws-bpel executable process validation (i.e.
  does not account for ##opaques). [ build 498, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  499, 10/25/06]


* 1) fixed issues with conflicting receives and scoped partner links 2)
  changed how messages are dispatched to receives/onMessag/onEvent in order to
  detect ambiguousReceives 3) added queuing scope to onEvent which is used to
  provide plink info during the queuing. This scope is also used to handle the
  messages until I turn concurrency back on [ build 500, 10/26/06]


* Fix AeProcessDef#findPartnerLink(AePartnerLinkDefKey) to handle partner link
  keys from upgraded 2.1.1 databases where the partnerLinkId will be -1. [
  build 501, 10/27/06]


* Project: org.activebpel.rt.bpel [ build 502, 10/27/06]


* Added ability for WS-BPEL 2.0 processes to use a process level termination
  handler and changed the extension for it and process level compensation to
  http://.../process_coordination. [ build 503, 10/30/06]


* Fixed problem where exceptions thrown from process/engine listeners were
  affecting process execution. [ build 504, 10/31/06]


* 1. Fix issue where the arguments of the abx:getMyRoleProperty function were
  not being validated. 2. Fix issue with cloning elements when adding to
  endpoint reference properties. 3. Removed unnecessary handling of actor and
  mustUnderstand in ws-addressing serializer. 4. Update inbound receive
  serializer/deserializer to use wsa namespace property on the endpoint,
  rather than a constant value for the 2003 namespace. [ build 505, 10/31/06]

org.activebpel.wsio

* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 28,
  10/25/06]

org.activebpel.rt.tamino

* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 44,
  10/25/06]

org.activebpel.rt.bpel.ext.expr

* Minor changes - mostly documentation and a couple of null pointer checks. [
  build 23, 10/12/06]

org.activebpel.rt.axis.bpel.web

* Propagate interface and method name changes from org.activebpel.rt.bpel. [
  build 61, 10/18/06]

org.activebpel.rt.bpel.server

* Update AeQueueStorage.findCorrelatedMatch() such that explicit correlation
  sets may be used in combination with engine managed correlation [ build 387,
  10/17/06]


* (1) Propagate IAeBusinessProcess and IAeQueueManager interface changes. (2)
  WS-BPEL treatment of open IMAs. [ build 388, 10/18/06]


* 1) Incremented the BPEL Admin version (due to the addition of timestamps on
  the event and breakpoint handlers) 2) Added timestamps to the breakpoing and
  event handler interfaces (and remote debug impl object) [ build 389,
  10/20/06]


* Refactoring of reply receivers - updated AeQueueingReplyReceiver to extend
  AeReplyReceiverBase [ build 390, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  391, 10/25/06]


* 1) minor changes in dispatching messages [ build 392, 10/26/06]


* Fixed a couple of issues with AeCatalog management of resources for
  ActiveBPEL product when deploying and undeploying BPR's with same
  locationHint of catalog entries. [ build 393, 10/26/06]


* Fixed problem where JUnit test was failing due to change from last build. [
  build 394, 10/26/06]


* (1) Fix transmission id deserialization in AeInvokeDataJournalEntry and
  AeInvokeFaultJournalEntry; (2) Remove partnerLinkId is null check from
  AeSQLQueueStorageProvider#readSQLMessageReceiver(), because the
  PartnerLinkId column is declared NOT NULL. [ build 395, 10/27/06]


* [Missed a file] (1) Fix transmission id deserialization in
  AeInvokeDataJournalEntry and AeInvokeFaultJournalEntry; (2) Remove
  partnerLinkId is null check from
  AeSQLQueueStorageProvider#readSQLMessageReceiver(), because the
  PartnerLinkId column is declared NOT NULL. [ build 396, 10/27/06]


* 1. Update pdd validation to support multiple wsa namespaces. 2. Fixed issue
  with wsa: headers embedded as reference properties within a reference
  property. [ build 397, 10/31/06]

ActiveBPEL engine v3.0.0 9 (20061101) 
 
org.activebpel.rt.axis

* Fixed problem reading nested imported schema references for deployed WSDL
  services [ build 59, 10/20/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build 60,
  10/25/06]

org.activebpel.rt

* added antoher convenience methof for SG: isCompatibleSGElement() [ build
  317, 10/12/06]


* base64 binary and hex binary schema classes now parse their data into byte
  arrays. They each have accessors for getting the parsed-out data. [ build
  318, 10/12/06]


* Added helper method to AeUtil to check for not null or empty collections. [
  build 319, 10/16/06]


* Added some QName definitions for several schema simple types. [ build 320,
  10/20/06]


* Fixed problem where imports of project relative resources with spaces in the
  project path were being URL encoded and causing problems during retrieval of
  resource [ build 321, 10/20/06]


* Modify AeXMLParserBase#loadDocumentFromString() not to try to parse an empty
  string, because the WebLogic 9.2 emits an error message to the log as well
  as throwing a parser exception. This was inspired by defect 2141, "I keep
  getting the error [Fatal Error] :-1:-1: Premature end of file. in my
  WebLogic log file running different tests." [ build 322, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  323, 10/25/06]


* Modified AeXMLParserBase.validateDocument() to always turn validation on and
  not rely on it being set, since we are calling validateDocument for the
  purpose of XML validation. [ build 324, 10/26/06]


* Updated to use new method isCompatibleSGElement() to prevent any confusion.
  [ build 325, 10/27/06]

org.activebpel.rt.axis.bpel

* 1. Refactor AeBpelHandler.invokeProcessEngine to check for and create a
  durable reply receiver using information from incomming message context. 2.
  Refactor mapOutputData and mapFaultData methods such that they can be called
  from durable reply receivers. [ build 171, 10/17/06]


* [Merge from 2.1.1] In AeBprDeployment, never set the thread context
  classloader to null, because that may prevent JBoss 4.0.4 from loading
  org.apache.axis.deployment.wsdd.WSDDProvider leading to mysterious
  "Excetpion - java.lang.ExceptionInInitializerError" when generating WSDL or
  handling incoming SOAP messages. [ build 172, 10/18/06]


* Added timestamp param to breakpoint and event handler stubs. [ build 173,
  10/20/06]


* Fix defect 2141, "I keep getting the error [Fatal Error] :-1:-1: Premature
  end of file. in my WebLogic log file running different tests." [ build 174,
  10/24/06]


* Update AeBpelHandler so that synchronous replies contain all mandatory wsa
  reply headers. [ build 175, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  176, 10/25/06]


* Modify RPC encoded sterilizer and invoke handler to handle the RPC call
  between two processes when the message is complex type, also to allow
  messages with substitution group mechanism transfer in the PRC call, both
  for RPC encoded and RPC literal. [ build 177, 10/27/06]


* Use endpoint property, rather than constant to determine wsa namespace. [
  build 178, 10/31/06]

org.activebpel.rt.bpeladmin.war

* Change due to interface change (def visitor interface). [ build 182,
  10/12/06]


* Added (BPEL 1.1 only) text to the "auto create target path" and "disable
  selction fault" option labels. [ build 183, 10/20/06]


* (1) Defects 2154,2155 (2) Added "BPEL Namespace" property Process Properies
  in the Admin console; (3) Updated process view code to run def preprocessors
  (visitors) before building the visual model [ build 184, 10/24/06]


* Req 148 changes (1) added 'seconds' to time out labels; (2) remove 'path'
  from process properties (process view) [ build 185, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  186, 10/25/06]


* Defect 2198 - exit activity in admin console was displayed as terminated [
  build 187, 10/26/06]


* Added process level termination handler tab to graphical views of process. [
  build 188, 10/30/06]

org.activebpel.rt.bpel

* Added fault handler validation process to prevent identical matches in a
  fault handler. The validation is distinct between WS-BPEL and BPWS, the
  former will not consider the fault variables. For WS-BPEL, static analysis
  will report error message, for BPWS, it will report warning message. [ build
  492, 10/12/06]


* 1) Refactorings: findPartnerLink -> findProcessPartnerLink,
  getPartnerLink(String name) -> findPartnerLink(String name) 2) Improved def
  i/o layer for reading attributes - attributes are now 'consumed' as they are
  read. Any attribute that is not read by the def i/o reader visitors is
  considered an extensibility attribute, even if it is unqualified 3)
  extension elements and extension attributes are now defs which are traversed
  and visited - this makes i/o easier and more consistent 4) implemented
  process level termination handler as an extension 5) added
  getDoXslTransformStylesheets() to the expression analyzer interface and
  impls 6) removed the extension registry in favor of a more unified BPEL
  registry (the extension registry wasn't being used) 7) cleaned up extension
  validation code now that extension elements and attributes are defs 8) XPath
  query validator is now namespace aware [ build 493, 10/12/06]


* (1) clarify any confusion for the fault handler, clean the fault handler
  strategy matrix and add more comments; (2) fixed the bug for catch order
  issue. Fault handler will always find the best match regardless the catch
  order. [ build 494, 10/17/06]


* (1) WS-BPEL treatment of open IMAs. (2) WS-BPEL treatment of the
  compensation handler of an isolated scope. (3) Re-implement link cycle
  detection: includes detecting cycles involving sequences and isolated
  scopes. (4) Remove IAeQueueManager#faultOutstandingReplies; this behavior is
  subsumed by WS-BPEL treatment of open IMAs, which sends faults to all open
  IMAs. (5) Move internally called methods from IAeBusinessProcess to
  IAeBusinessProcessInternal, so that IAeBusinessProcess defines exactly the
  interface required by the engine and the managers. (6) Move thread
  synchronization from AeExecutionQueue to AeBusinessProcess, only on
  IAeBusinessProcess methods. [ build 495, 10/18/06]


* 1) Some refactoring of engine/process events to share common base classes
  and to add a new base class (AeEvent) which adds a Timestamp to all events.
  2) The check start activity visitor now catches start activities within
  While, ForEach, and RepeatEvery loops [ build 496, 10/20/06]


* WSBPEL validation now logs an info message when extensions are in use. Fixed
  a bug in the xpath helper - the proper version of the xpath helper was not
  being returned by getInstance() [ build 497, 10/24/06]


* (1) Defects 2160, 2139, 2156; (2) Added assign-copy strategy for service-ref
  to wsa:epr element copying; (3) Updated AeExpressionLanguageFactory to
  support namespace aliases e.g. map bpel-abstract ns to bpel executable ns;
  (4) Added validator for opaque activity; (5) Update AeActivityInvokeImpl to
  reset transmission id on state change instead of onMessage/onFault callback
  to support retries; (6) Refactored AeWaitableReplyReceiver into
  AeReplyReceiverBase + AeWaitableReplyReceiver (AeQueueingReplyReceiver will
  now extend the base); (7) Enabled basic validation for abstract processes -
  this is currently based on the ws-bpel executable process validation (i.e.
  does not account for ##opaques). [ build 498, 10/24/06]


* Removed invalid NON-NLS comments caught by new eclipse compiler. [ build
  499, 10/25/06]


* 1) fixed issues with conflicting receives and scoped partner links 2)
  changed how messages are dispatched to receives/onMessag/onEvent in order to
  detect ambiguousReceives 3) added queuing scope to onEvent which is used to
  provide plink info during the queuing. This scope is also used to handle the
  messages until I turn concurrency back on [ build 500, 10/26/06]


* Fix AeProcessDef#findPartnerLink(AePartnerLinkDefKey) to handle partner link
  keys from upgraded 2.1.1 databases where the partnerLinkId will be -1. [
  build 501, 10/27/06]


* Project: org.activebpel.rt.bpel [ build 502, 10/27/06]


